jQuery(function($) {

	let proNoticeBtn = jQuery('.coreft-calendar-pro-dismiss');

	if (proNoticeBtn.length) {
		proNoticeBtn.on('click', function(){
			jQuery('.corefortress-pro-notice').fadeOut(150);
			jQuery.ajax(corefortressCalendarAdminL10nn.ajaxUrl, {
				method: "POST",
				data: {action: 'coreft_calendar_dismiss_pro_notice'},
				dataType: 'json'
			}).done(function (res) {

			});
		});
	}


	var geocoder = '';	
	if($('#mapCanvas').length || $('#coreft_map').length) {
		var geocoder = new google.maps.Geocoder();
	}
	var	map;
	var marker;
	
	function geocodePosition(pos) {
	  geocoder.geocode({
		latLng: pos
	  }, function(responses) {
		if (responses && responses.length > 0) {
		  updateMarkerAddress(responses[0].formatted_address);
		} else {
		  //updateMarkerAddress("Cannot determine address at this location.");
		}
	  });
	}
	
	function updateMarkerPosition(latLng) {
		if(latLng.lat() == 0 && latLng.lng() == 0) return;
		
	  document.getElementById("coreft_map_lnlat").value = [
		latLng.lat(),
		latLng.lng()
	  ].join(", ");
	}
	
	function updateMarkerAddress(str) {
	  document.getElementById("coreft_map").value = str;
	}
	
	function initialize() {

	  var latLng = new google.maps.LatLng($('#mapCanvas').data('map-lat'),$('#mapCanvas').data('map-lng'));
	  map = new google.maps.Map(document.getElementById("mapCanvas"), {
		zoom: ($('#mapCanvas').data('map-lat') != 0 ? 12 : 3),
		center: latLng,
		mapTypeId: google.maps.MapTypeId.ROADMAP
	  });
	  marker = new google.maps.Marker({
		position: latLng,
		title: "Location",
		map: map,
		draggable: true
	  });
	  
	  // Update current position info.
	  //updateMarkerPosition(latLng);
	  //geocodePosition(latLng);
	  
	  // Add dragging event listeners.
	  google.maps.event.addListener(marker, "dragstart", function() {
		updateMarkerAddress("");
	  });
	  
	  google.maps.event.addListener(marker, "drag", function() {
		updateMarkerPosition(marker.getPosition());
	  });
	  
	  google.maps.event.addListener(marker, "dragend", function() {
		geocodePosition(marker.getPosition());
	  });
	  
	  if($('#coreft_map').val() != "" && $('#mapCanvas').data('map-lat') == 0) {
		$('#coreft_map').trigger('keyup');
	  }

	  if($('#coreft_map_lnlat').val() != "") {
	  	var lnlat = $('#coreft_map_lnlat').val().split(',');
	  	var latlng_obj = new google.maps.LatLng(lnlat[0],lnlat[1]);
	  	if (map.getZoom() < 12) map.setZoom(12); 
		marker.setPosition(latlng_obj);
		map.setCenter(latlng_obj);
	  }
	}
	
	var timeout;
	
	$('#coreft_map').on('keyup', function () {
	  clearTimeout( timeout );
	  timeout = setTimeout(function() {
		  geocoder.geocode( { "address": $('#coreft_map').val()}, function(results, status) {
			  if(status != "OVER_QUERY_LIMIT" && typeof results[0] != "undefined") {
			  	
				  var latlng = results[0].geometry.location;
				  marker.setPosition(latlng);
				  
				 // var listener = google.maps.event.addListener(map, "idle", function() { 
					  if (map.getZoom() < 12) map.setZoom(12); 
					  map.setCenter(latlng);
					  //google.maps.event.removeListener(listener); 
					//});
					
					updateMarkerPosition(latlng);
			  }
		 });
	 }, 1000);
	});
	
	// Onload handler to fire off the app.
	if($('#mapCanvas').length) {
		google.maps.event.addDomListener(window, "load", initialize);
	}

	$overlay = $('<div>').addClass('coreftCalendar_Overlay').click(function(){
		hideOverlay();
	});
	
	$('#coreft_ui_content select[multiple!="multiple"], #coreftCalendar_events_meta select[multiple!="multiple"], #coreftCalendar_events_side_meta select[multiple!="multiple"]').not('.coreft_manage_special_dates select, #custom_field_new select, #booking_custom_field_new select').selectric();
	
	if($("#coreftCalendar_SpecialDates").length) {
		var $specialDates = $("#coreftCalendar_SpecialDates");
		$specialDates.dialog({                   
			'dialogClass'   : 'wp-dialog',           
			'modal'         : false,
			'height'		: 220,
			'width'			: 400,
			'autoOpen'      : false, 
			'closeOnEscape' : true
		});
		
		jQuery('.btn_add_special_date').live('click', function(event) {
			$specialDates.dialog('open');
		});
	}
	
	if($("#coreftCalendar_SpecialDatesEdit").length) {
		var $specialDatesEdit = $("#coreftCalendar_SpecialDatesEdit");
		$specialDatesEdit.dialog({                   
			'dialogClass'   : 'wp-dialog',           
			'modal'         : false,
			'height'		: 220,
			'width'			: 400,
			'autoOpen'      : false, 
			'closeOnEscape' : true
		});
		
		jQuery('.btn_edit_special_date').live('click', function(event) {
			$('#coreftCalendar_special_id').val($(this).data('special-date-id'));
			$('#coreftCalendar_special_title').val($(this).data('special-date-title'));
			$('#coreftCalendar_special_color').val($(this).data('special-date-color'));
			$('#specialDate_colorSelector_Edit div').css('backgroundColor', $(this).data('special-date-color'));

			$specialDatesEdit.dialog('open');
		});
	}
	
	if($("#settings_maps_title").length) {	
		
		$('#settings_maps_title').click(function(event) {
			initialize();

		});
		
	}

	if($(".coreft_ticket_list .dashicons-dismiss").length) {
		
		$(document).on('click', '.coreft_ticket_list .dashicons-dismiss', function(event) {
			
			$(this).parent().fadeOut('fast', function() { $(this).remove(); });

			var ticket_arr = $('#coreft_booking_ticket').val().split(',');
			var removeItem = $(this).parent().data('ticket-id');
			var ticket_list = jQuery.grep(ticket_arr, function(value) {
			  return value != removeItem;
			});
			
			$('#coreft_booking_ticket').val(ticket_list.join(','));

		});

	}

	if($("#coreft_booking_ticket_select").length) {
		
		$('#coreft_booking_ticket_select').change(function(event) {
			if($(this).val() != "") {
				var ticket_list = $('#coreft_booking_ticket').val();

				if(!$(".coreft_ticket_list_wrap").find("[data-ticket-id='" + $(this).val() + "']").length) {
					$('#coreft_booking_ticket').val(ticket_list + "," + $(this).val());

					$('.coreft_ticket_list_wrap').prepend('<span class="coreft_ticket_list" data-ticket-id="'+$(this).val()+'">'+$('option:selected', this).text()+' <span class="dashicons dashicons-dismiss"></span></span>');

				}
			}

		});

	}

	if($("#coreft_new_booking_show").length) {
		
		$('#coreft_new_booking_show').click(function(event) {
			
			$('#coreft_new_booking').slideDown('fast');

			$(this).hide();

		});

		$('#coreft_new_booking_submit').click(function(event) {
			
			$.post(ProEventCalendarAjax.ajaxurl, { 
				eventid: $(this).data('coreftcalendar-eventid'),
				userid: $('#coreft_new_booking_user').val(),
				phone: $('#coreft_new_booking_phone').val(),
				date: $('#coreft_new_booking_date').val(),
				quantity: $('#coreft_new_booking_quantity').val(),
				status: $('#coreft_new_booking_status').val(),
				action: 'bookEventAdmin', 
				postEventsNonce : ProEventCalendarAjax.postEventsNonce },
				function(data) {
					if($('#coreft_booking_list_zero').length) {
						$('#coreft-booking-list').html(data.html);
					} else {
						$('#coreft-booking-list').prepend(data.html);
					}

					$('#coreft_new_booking_show').show();
					$('#coreft_new_booking').slideUp('fast');
				}
			);	

		});

		$('#coreft_new_booking_cancel').click(function(event) {
			
			$('#coreft_new_booking_show').show();
			$('#coreft_new_booking').slideUp('fast');

		});
		
	}

	if($(".coreft-load-more").length) {
		
		$('.coreft-load-more').click(function(event) {
			var $btn = $(this);
			
			$.post(ProEventCalendarAjax.ajaxurl, { 
				offset: $(this).data('coreftcalendar-offset'),
				eventid: $(this).data('coreftcalendar-eventid'),
				event_date: $('#coreft_booking_filter_date').val(),
				action: 'getMoreBookings', 
				postEventsNonce : ProEventCalendarAjax.postEventsNonce 
			},
				function(data) {
					data = JSON.parse(data);
					$('#coreft-booking-list').append(data.html);
					var total = $btn.find('span').text() - 30;
					
					$btn.data('coreftcalendar-offset', $btn.data('coreftcalendar-offset') + 30);

					if(total <= 0) {
						$btn.hide();
					} else {
						$btn.show();
						$btn.find('span').text(total);
					}
				}
			);	

		});
		
	}

	if($("#coreft_booking_filter").length) {
		
		$('#coreft_booking_filter').click(function(event) {
			var $btn = $('.coreft-load-more');
			
			$.post(ProEventCalendarAjax.ajaxurl, { 
				offset: 0, 
				eventid: $(this).data('coreftcalendar-eventid'),
				event_date: $('#coreft_booking_filter_date').val(),
				action: 'getMoreBookings', 
				postEventsNonce : ProEventCalendarAjax.postEventsNonce 
			},
				function(data) {
					data = JSON.parse(data);
					$('#coreft-booking-list').empty().append(data.html);
					$btn.find('span').text(data.counter);
					var total = data.counter - 30;
					
					$btn.data('coreftcalendar-offset', 30);

					if(total <= 0) {
						$btn.hide();
					} else {
						$btn.show();
						$btn.find('span').text(total);
					}
				}
			);	

		});
		
	}
	
	if($(".coreftCalendar_ModalCalendar").length) {

		$('.coreftCalendar_btn_getDate').click(function(event) {

			showOverlay();
			
			$('.coreft_calendar_date:not(.disabled)', '.coreftCalendar_ModalCalendar').live('click', function(event) {
				
				hideOverlay();
				$('#coreftCalendar_default_date').val($(this).data('coreftcalendar-date'));
				$('.coreft_calendar_date:not(.disabled)', '.coreftCalendar_ModalCalendar').die('click');
				
			});
		});
		
		$('.coreftCalendar_btn_getFromDate').click(function(event) {
			
			showOverlay();
			
			$('.coreft_calendar_date:not(.disabled)', '.coreftCalendar_ModalCalendar').live('click', function(event) {
				
				hideOverlay();
				$('#coreft_custom_shortcode_from').val($(this).data('coreftcalendar-date'));
				coreft_updateShortcode();
				$('.coreft_calendar_date:not(.disabled)', '.coreftCalendar_ModalCalendar').die('click');
				
			});
		});
		
		$('.coreftCalendar_btn_getBookingEventDate').click(function(event) {
			
			showOverlay();
			
			$('.coreft_calendar_date:not(.disabled)', '.coreftCalendar_ModalCalendar').live('click', function(event) {
				
				hideOverlay();
				$('#coreft_new_booking_date').val($(this).data('coreftcalendar-date'));
				$('.coreft_calendar_date:not(.disabled)', '.coreftCalendar_ModalCalendar').die('click');
				
			});
		});

		$('.coreftCalendar_btn_getEventDate').click(function(event) {
			
			showOverlay();
			
			$('.coreft_calendar_date:not(.disabled)', '.coreftCalendar_ModalCalendar').live('click', function(event) {
				
				hideOverlay();
				$('#coreft_date').val($(this).data('coreftcalendar-date'));
				$('.coreft_calendar_date:not(.disabled)', '.coreftCalendar_ModalCalendar').die('click');
				
			});
		});
		
		$('.coreftCalendar_btn_getEventEndDate').click(function(event) {
			
			showOverlay();
			
			$('.coreft_calendar_date:not(.disabled)', '.coreftCalendar_ModalCalendar').live('click', function(event) {
				
				hideOverlay();
				$('#coreft_end_date').val($(this).data('coreftcalendar-date'));
				$('.coreft_calendar_date:not(.disabled)', '.coreftCalendar_ModalCalendar').die('click');
				
			});
		});
		
		$('.coreftCalendar_btn_getDateRangeStart').click(function(event) {
			
			showOverlay();
			
			$('.coreft_calendar_date:not(.disabled)', '.coreftCalendar_ModalCalendar').live('click', function(event) {
				
				hideOverlay();
				$('#coreftCalendar_date_range_start').val($(this).data('coreftcalendar-date'));
				$('.coreft_calendar_date:not(.disabled)', '.coreftCalendar_ModalCalendar').die('click');
				
			});
		});
		
		$('.coreftCalendar_btn_getDateRangeEnd').click(function(event) {
			
			showOverlay();
			
			$('.coreft_calendar_date:not(.disabled)', '.coreftCalendar_ModalCalendar').live('click', function(event) {
				
				hideOverlay();
				$('#coreftCalendar_date_range_end').val($(this).data('coreftcalendar-date'));
				$('.coreft_calendar_date:not(.disabled)', '.coreftCalendar_ModalCalendar').die('click');
				
			});
		});
		
		$('.btn_manage_special_dates').click(function(event) {
			var nonce = $(this).data('calendar-nonce');
			var calendar = $(this).data('calendar-id');
			$('.coreft_calendar_wrapper', '.coreftCalendar_ModalCalendar').hide();
			$('#coreft_calendar_id'+nonce, '.coreftCalendar_ModalCalendar').show();
			
			showOverlay();
			
			$('.coreft_calendar_date:not(.disabled)', '.coreftCalendar_ModalCalendar').live('click', function(event) {
				if($(this).data('sp_date_active')) { return false; }
				$('.coreft_calendar_date:not(.disabled)', '.coreftCalendar_ModalCalendar').data('sp_date_active', false);
				$(this).data('sp_date_active', true);
				
				$('.coreft_calendar_content', '.coreftCalendar_ModalCalendar').css({'overflow': 'visible'});
				
				$('.coreft_manage_special_dates', '.coreftCalendar_ModalCalendar').slideUp('fast').parent().css('z-index', 2);
				$('.coreft_manage_special_dates', this).slideDown('fast').parent().css('z-index', 3);
				
			});
			
			$('.coreft_calendar_date:not(.disabled) select', '.coreftCalendar_ModalCalendar').live('change', function()
			{
			   changeSpecialDate($(this), calendar);
			});
		});
		
		$('#btn_manage_special_dates').click(function(event) {
			
			showOverlay();
			
			$('.coreft_calendar_date:not(.disabled)', '.coreftCalendar_ModalCalendar').live('click', function(event) {
				if($(this).data('sp_date_active')) { return false; }
				$('.coreft_calendar_date:not(.disabled)', '.coreftCalendar_ModalCalendar').data('sp_date_active', false);
				$(this).data('sp_date_active', true);
				
				$('.coreft_calendar_content', '.coreftCalendar_ModalCalendar').css({'overflow': 'visible'});
				
				$('.coreft_manage_special_dates', '.coreftCalendar_ModalCalendar').slideUp('fast').parent().css('z-index', 2);
				$('.coreft_manage_special_dates', this).slideDown('fast').parent().css('z-index', 3);
				
			});
			
			$('.coreft_calendar_date:not(.disabled) select', '.coreftCalendar_ModalCalendar').live('change', function()
			{
			   changeSpecialDate($(this));
			});
		});
		
	}
	
	function changeSpecialDate(obj, calendar) {
		if($(obj).val() == '') { 
			$(obj).parent().parent().css('background-color', '#fff');
		} else {
			obj_arr = $(obj).val().split(',');
			var color = obj_arr[1];
			var sp = obj_arr[0];
			$(obj).parent().parent().css('background-color', color);
		}
		
		$.post(ProEventCalendarAjax.ajaxurl, { date: $(obj).parent().parent().parent().data('coreftcalendar-date'), sp : sp, calendar: calendar, action: 'setSpecialDates', postEventsNonce : ProEventCalendarAjax.postEventsNonce },
			function(data) {

			}
		);	
	}
	
	function showOverlay() {
		if($(".coreftCalendar_Overlay").length) {
			$($overlay).fadeIn('fast');
		} else {
			$('body').append($overlay);
		}
		$(".coreftCalendar_ModalCalendar").css({ display: 'none', visibility: 'visible' }).fadeIn('fast');
	}
	
	function hideOverlay() {
		$(".coreftCalendar_ModalCalendar").fadeOut('fast', function() { $(this).css({ display: 'block', visibility: 'hidden' }) } );
		$(".coreftCalendar_Overlay").fadeOut('fast');
		
		$('.coreft_manage_special_dates', '.coreftCalendar_ModalCalendar').slideUp('fast').parent().css('z-index', 2);
		$('.coreft_calendar_date:not(.disabled)', '.coreftCalendar_ModalCalendar').die('click');
		$('.coreft_calendar_date:not(.disabled) select', '.coreftCalendar_ModalCalendar').die('change');
	}
			
}); 

function coreft_removeBooking(booking_id, parent_el) {
	jQuery(parent_el).closest('tr').css('opacity', .6);
	jQuery.post(ProEventCalendarAjax.ajaxurl, { booking_id: booking_id, action: 'removeBooking', postEventsNonce : ProEventCalendarAjax.postEventsNonce },
		function(data) {
			jQuery(parent_el).closest('tr').remove();
		}
	);	
}
 