/*
 * jQuery CoreFortress Event Calendar v3
 *
 * Copyright 2012, Diego Pereyra
 *
 * @Web: http://www.dpereyra.com
 * @Email: info@dpereyra.com
 *
 * Depends:
 * jquery.js
 */
  
(function ($) {
	function CoreftCalendar(element, options) {
		this.calendar = $(element);
		this.eventDates = $('.coreft_calendar_date', this.calendar);
		
		/* Setting vars*/
		this.settings = $.extend({}, $.fn.coreftCalendar.defaults, options);
		this.no_draggable = false,
		this.hasTouch = false,
		this.downEvent = "mousedown.rs",
		this.moveEvent = "mousemove.rs",
		this.upEvent = "mouseup.rs",
		this.cancelEvent = 'mouseup.rs',
		this.isDragging = false,
		this.successfullyDragged = false,
		this.view = "monthly",
		this.grid = undefined,
		this.monthlyView = "calendar",
		this.type = 'calendar',
		this.defaultDate = 0,
		this.startTime = 0,
		this.startMouseX = 0,
		this.startMouseY = 0,
		this.currentDragPosition = 0,
		this.lastDragPosition = 0,
		this.accelerationX = 0,
		this.tx = 0;
		
		// Touch support
		if("ontouchstart" in window) {
					
			this.hasTouch = true;
			this.downEvent = "touchstart.rs";
			this.moveEvent = "touchmove.rs";
			this.upEvent = "touchend.rs";
			this.cancelEvent = 'touchcancel.rs';
		} 
		
		this.init();
	}
	
	CoreftCalendar.prototype = {
		init : function(){
			var instance = this;
			
			var coreft_new_event_captcha;

			instance.view = instance.settings.view;
			instance.defaultDate = instance.settings.defaultDate;
			
			if(instance.settings.type == 'compact') {
				instance.settings.skin = 'light';
				instance.view = "monthly";
			}

			if(instance.settings.type == 'countdown') {
				if($('.coreft_calendar_countdown_event', instance.calendar).length) {
					$('.coreft_calendar_countdown_event', instance.calendar).each(function() {
						var launchDateFix = new Date(
							$(this).data('countdown-year'), 
							($(this).data('countdown-month') - 1), 
							$(this).data('countdown-day'), 
							$(this).data('countdown-hour'), 
							$(this).data('countdown-minute')
						);

						var currentDate = new Date(
							$(this).data('current-year'), 
							($(this).data('current-month') - 1), 
							$(this).data('current-day'), 
							$(this).data('current-hour'), 
							$(this).data('current-minute'),
							$(this).data('current-second')
						);

						instance._setup_countdown(launchDateFix, currentDate, this, $(this).data('countdown-tzo'));
					});
				}
			}

			$(instance.calendar).not('.coreft_calendar_compact_wrapper').addClass(instance.settings.skin);
			instance._makeResponsive();
			
			/*
			if($('.coreft_calendar_event_photo', instance.calendar).length) {
				
				$('.coreft_calendar_event_photo', instance.calendar).hover(
				  function() {
				    $(this).stop().animate({
				      backgroundPositionX: '50%',
				      backgroundPositionY: '70%'
				    }, 1000);
				  },
				  function () {
				    $(this).stop().animate({
				      backgroundPositionX: '50%',
				      backgroundPositionY: '50%'
				    }, 1000);
				  }
				);
			}
			*/
			
			if($('.coreft_upcoming_layout', instance.calendar).length) {
				instance.grid = $('.coreft_upcoming_layout', instance.calendar).isotope({
				  itemSelector: '.coreft_calendar_date_event_wrap',
				  layoutMode: 'moduloColumns',
				  isOriginLeft : (instance.settings.isRTL ? false : true),
				  moduloColumns: {
				  }
				});

				$(".coreft_upcoming_layout .coreft_calendar_event_photo img", instance.calendar).one("load", function() {

				  instance.grid.isotope('layout');

				}).each(function() {

				  if(this.complete) $(this).load();

				});

			}
			
			$(instance.calendar).on('click', '.prev_month', function(e) { instance._prevMonth(instance); });
			if(instance.settings.dateRangeStart && instance.settings.dateRangeStart.substr(0, 7) == instance.settings.actualYear+"-"+instance._str_pad(instance.settings.actualMonth, 2, "0", 'STR_PAD_LEFT') && !instance.settings.isAdmin) {
				$('.prev_month', instance.calendar).hide();
			}
			
			$(instance.calendar).on('click', '.next_month', function(e) { instance._nextMonth(instance); });
			if(instance.settings.dateRangeEnd && instance.settings.dateRangeEnd.substr(0, 7) == instance.settings.actualYear+"-"+instance._str_pad(instance.settings.actualMonth, 2, "0", 'STR_PAD_LEFT') && !instance.settings.isAdmin) {
				$('.next_month', instance.calendar).hide();
			}
			
			$('.prev_day', instance.calendar).click(function(e) { instance._prevDay(instance); });
			$('.next_day', instance.calendar).click(function(e) { instance._nextDay(instance); });
			
			$('.prev_week', instance.calendar).click(function(e) { instance._prevWeek(instance); });
			$('.next_week', instance.calendar).click(function(e) { instance._nextWeek(instance); });
						
			if(instance.settings.type == "add-event") {
				$('.coreft_calendar_new_event_wrapper select').selectric();
				$('.coreft_calendar_new_event_wrapper input.checkbox').iCheck({
					checkboxClass: 'icheckbox_flat',
					radioClass: 'iradio_flat',
					increaseArea: '20%' // optional
				});

				if(ProEventCalendarAjax.recaptcha_enable && ProEventCalendarAjax.recaptcha_site_key != "") {
					$(window).load(function() {
						coreft_new_event_captcha = grecaptcha.render($('#coreft_new_event_captcha', instance.calendar)[0], {
						  'sitekey' : ProEventCalendarAjax.recaptcha_site_key
						});
					});
				}
				
			}
			
			if(instance.settings.type == "grid-upcoming") {
				$(instance.calendar).on('click', '.coreft_calendar_grid_event', function() {
					
					//$('.coreft_calendar_grid_link_image', $(this).closest('.coreft_calendar_grid_event')).attr('target', '_blank');
					$('.coreft_calendar_grid_link_image', $(this))[0].click();
					
				})	
			}
			
			$(instance.calendar).on('click', '.coreft_calendar_event_description_more', function(e) {
				if($(this).attr('href') == '#') {
					e.preventDefault();
					
					$(this).closest('.coreft_calendar_event_description_short').hide();
					$(this).closest('.coreft_calendar_event_description').find('.coreft_calendar_event_description_full').show();
					
					if(typeof instance.grid != "undefined") {
						instance.grid.isotope('layout');
					}

				}
				
			});
			
			/* touch support */
			if(instance.settings.draggable && instance.settings.type != "accordion" && instance.settings.type != "accordion-upcoming" && instance.settings.type != "add-event" && instance.settings.type != "bookings-user" && instance.settings.type != "past") {
				$('.coreft_calendar_content', instance.calendar).addClass('isDraggable');
				$('.coreft_calendar_content', instance.calendar).bind(instance.downEvent, function(e) {

					if(!instance.no_draggable) {
						instance.startDrag(e); 	
					} else if(!instance.hasTouch) {							
						e.preventDefault();
					}								
				});	
			}
			
			if(!instance.settings.isAdmin) {
				
				$(instance.calendar).on({
					mouseenter:
					   function(e)
					   {
						   
						   if(!$('.eventsPreviewDiv').length) {
								$('body').append($('<div />').addClass('eventsPreviewDiv'));
						   }
						  
						   $('.eventsPreviewDiv').removeClass('light dark').addClass(instance.settings.skin);
						   
							$('.eventsPreviewDiv').html($('.eventsPreview', $(this)).html());
							
							/*$(this).off( "mouseenter mouseenter", ".coreft_daily_event:not(.coreft_daily_event_show_more)");
							$(this).off( "mouseenter mouseenter", ".coreft_daily_event.coreft_daily_event_show_more");
							*/
							
							
							if($('.eventsPreviewDiv').html() != "" && !$('.coreft_daily_event', instance.calendar).is(':visible')) {
								$('.eventsPreviewDiv').fadeIn('fast');
							}
							
							$('.eventsPreviewDiv ul li').removeClass('coreft_calendar_preview_event').show();
							
					   },
					mouseleave:
					   function()
					   {
							if(!$('.coreft_daily_event', instance.calendar).is(':visible')) {
								$('.eventsPreviewDiv').html('').stop().hide();
							}
							/*
							$(this).off( "mouseenter mouseenter", ".coreft_daily_event:not(.coreft_daily_event_show_more)");
							$(this).off( "mouseenter mouseenter", ".coreft_daily_event.coreft_daily_event_show_more");
							*/
					   }
				   }, '.coreft_calendar_date:not(.disabled)'
				).bind('mousemove', function(e){
						
					if($('.eventsPreviewDiv').html() != "") {
						var body_pos = $("body").css('position');
						if(body_pos == "relative") {
							$("body").css('position', 'static');
						}
						$('.eventsPreviewDiv').removeClass('previewRight');
						
						var position = $(e.target).closest('.coreft_calendar_date').offset();
						var target_height = $(e.target).closest('.coreft_calendar_date').height();
						if(typeof position != "undefined") {
							$('.eventsPreviewDiv').css({
								left: position.left,
								top: position.top,
								marginTop: (target_height + 12) + "px",
								marginLeft: (position.left + $('.eventsPreviewDiv').outerWidth() >= $( window ).width() ? -($('.eventsPreviewDiv').outerWidth() - 30) + "px" : 0)
							});
						}
						
						if(position && position.left + $('.eventsPreviewDiv').outerWidth() >= $( window ).width()) {
							$('.eventsPreviewDiv').addClass('previewRight');
						}
					}
				});

				$(instance.calendar).on({
					mouseenter:
						function(e)
						{
							$('.eventsPreviewDiv ul li').hide();

							var event_id = $(e.target).data('coreftcalendar-event');
							
							if(typeof event_id == "undefined") {
								event_id = $(e.target).closest('.coreft_daily_event').data('coreftcalendar-event')
							}

							$(".eventsPreviewDiv ul").find("li[data-coreftcalendar-event='" + event_id + "']").addClass('coreft_calendar_preview_event').show();

							if($('.eventsPreviewDiv').html() != "") {
								$('.eventsPreviewDiv').fadeIn('fast');
							}
						},
					mouseleave:
						function() 
						{
							$('.eventsPreviewDiv ul li').removeClass('coreft_calendar_preview_event').show();
							$('.eventsPreviewDiv').stop().hide();
						}
				}, '.coreft_daily_event:not(.coreft_daily_event_show_more)');
				
				$(instance.calendar).on({
					mouseenter:
						function(e)
						{
							$('.eventsPreviewDiv ul li').hide();
							$(".eventsPreviewDiv ul li:gt("+( instance.settings.calendar_per_date - 1 )+")").addClass('coreft_calendar_preview_event').show();

							if($('.eventsPreviewDiv').html() != "") {
								$('.eventsPreviewDiv').fadeIn('fast');
							}
						},
					mouseleave:
						function() 
						{
							$('.eventsPreviewDiv ul li').removeClass('coreft_calendar_preview_event').show();
							$('.eventsPreviewDiv').stop().hide();
						}
				}, '.coreft_daily_event.coreft_daily_event_show_more');
				
				
			

				
				$(instance.calendar).on('mouseup', '.coreft_calendar_date:not(.disabled)', function(event) {
					if($(event.target).hasClass('coreft_daily_event') && !$(event.target).hasClass('coreft_daily_event_show_more')) { return; }
					
					if(instance.settings.type == "modern") { 
						if($(event.target).hasClass('coreft_daily_event_show_more')) {
							
							$('.coreft_daily_event', $(this)).show();
							$('.coreft_daily_event_show_more', $(this)).hide();
						}
						return; 
					}

					if(instance.calendar.hasClass('coreft_calendar_daily')) { return; }
					if(instance.calendar.hasClass('coreft_calendar_weekly')) { return; }

					if(instance.settings.event_id != '' && $('.coreft_calendar_form_desc').length) {
						if( !$(this).find('.coreft_book_event_radio').length ) {
							return;	
						}
						
						$('.coreft_book_event_radio', instance.calendar).removeClass('coreft_book_event_radio_checked');
						$(this).find('.coreft_book_event_radio').addClass('coreft_book_event_radio_checked');
						$('#coreft_event_page_book_date', '.coreftCalendarModal').val($(this).data('coreftcalendar-date'));
						
						return;
					}
					
					if(!$('.coreft_calendar_content', instance.calendar).hasClass('isDragging') && (event.which === 1 || event.which === 0)) {
						
						instance._goToByScroll($(instance.calendar));

						instance._removeElements();
						
						$.post(ProEventCalendarAjax.ajaxurl, { 
							date: $(this).data('coreftcalendar-date'),
							calendar: instance.settings.calendar, 
							category: (instance.settings.category != "" ? instance.settings.category : $('select.coreft_categories_list', instance.calendar).val()),
							location: (instance.settings.location != "" ? instance.settings.location : $('select.coreft_location_list', instance.calendar).val()),
							event_id: instance.settings.event_id, 
							author: instance.settings.author, 
							include_all_events: instance.settings.include_all_events,
							hide_old_dates: instance.settings.hide_old_dates,
							type: instance.settings.type, 
							action: 'getEvents', 
							postEventsNonce : ProEventCalendarAjax.postEventsNonce 
						},
							function(data) {

								$('.coreft_calendar_content', instance.calendar).removeClass( 'coreft_calendar_content_loading' ).empty().html(data);
								
								instance.eventDates = $('.coreft_calendar_date', instance.calendar);
								
								$('.coreft_calendar_date', instance.calendar).hide().fadeIn(500);
							}
						);	
					}
	
				});
				
				$(instance.calendar).on('click', '.coreft_daily_event:not(.coreft_daily_event_show_more)', function(event) {
					if(!$('.coreft_calendar_content', instance.calendar).hasClass('isDragging') && (event.which === 1 || event.which === 0)) {
						
						if($(this).attr('href') != "javascript:void(0);" && $(this).attr('href') != "#") {
							
							//event.preventDefault();
							//return false;
							
						} else {
							
							instance._removeElements();
						
							$.post(ProEventCalendarAjax.ajaxurl, { 
									event: $(this).data('coreftcalendar-event'),
									calendar: instance.settings.calendar, 
									date:$(this).data('coreftcalendar-date'),
									action: 'getEvent', 
									postEventsNonce : ProEventCalendarAjax.postEventsNonce 
								},
								function(data) {
	
									$('.coreft_calendar_content', instance.calendar).removeClass( 'coreft_calendar_content_loading' ).empty().html(data);
									
									instance.eventDates = $('.coreft_calendar_date', instance.calendar);
									
									$('.coreft_calendar_date', instance.calendar).hide().fadeIn(500);
								}
							);	

							event.preventDefault();
							return false;
						}
					}
					
				});
			}
			
			$(instance.calendar).on('click', '.coreft_calendar_date_event_back', function(event) {
				event.preventDefault();
				instance._removeElements();
				
				instance._changeLayout();
			});
			
			$(instance.calendar).on({
				'mouseenter': function(i) {

					$('.coreft_calendar_user_rate li a').addClass('is-off');
	
					for(var x = $(this).data('rate-val'); x > 0; x--) {
						$('.coreft_calendar_user_rate li a[data-rate-val="'+x+'"]', instance.calendar).removeClass('is-off').addClass('is-on');
					}

				},
				'mouseleave': function() {
					$('.coreft_calendar_user_rate li a', instance.calendar).removeClass('is-on');
					$('.coreft_calendar_user_rate li a', instance.calendar).removeClass('is-off');
				},
				'click': function() {
					
					$('.coreft_calendar_user_rate', instance.calendar).replaceWith($('<div>').addClass('coreft_calendar_loading').attr({ id: 'coreft_calendar_loading_rating' }));
					
					jQuery.post(ProEventCalendarAjax.ajaxurl, { 
							event_id: $(this).data('event-id'), 
							rate: $(this).data('rate-val'), 
							calendar: instance.settings.calendar,
							action: 'ProEventCalendar_RateEvent', 
							postEventsNonce : ProEventCalendarAjax.postEventsNonce 
						},
						function(data) {
							$('#coreft_calendar_loading_rating', instance.calendar).replaceWith(data);
						}
					);	

					return false;
				}
			}, '.coreft_calendar_user_rate li a');
			
			$(document).on('click', '.coreftCalendar_close_modal_btn', function(e) {
			
				$('.coreftCalendarModal, .coreftCalendarOverlay').fadeOut('fast');
				$('body, html').css('overflow', '');
				
			});
			
			$('.coreftCalendar_subscribe', instance.calendar).click(function(e) {
				e.preventDefault();

				$('body, html').css('overflow', 'hidden');

				var mailform = '<h3>'+instance.settings.lang_subscribe_subtitle+'</h3><form>';
				mailform += '<div class="coreftCalendar_success">'+instance.settings.lang_txt_subscribe_thanks+'</div>';
				mailform += '<div class="coreftCalendar_error"><i class="fa fa-exclamation"></i>'+instance.settings.lang_fields_required+'</div>';
				mailform += '<div class="clear-article-share"></div>';
				mailform += '<input type="text" name="your_name" id="coreftCalendar_your_name" class="coreftCalendar_input coreftCalendar_from_name" placeholder="'+instance.settings.lang_your_name+'" />';
				mailform += '<input type="text" name="your_email" id="coreftCalendar_your_email" class="coreftCalendar_input coreftCalendar_from_email" placeholder="'+instance.settings.lang_your_email+'" />';
				if(ProEventCalendarAjax.recaptcha_enable && ProEventCalendarAjax.recaptcha_site_key != "") {
					mailform += '<div class="coreft_calendar_clear"></div><div id="coreft_subscribe_captcha"></div>';
				}
				mailform += '<div class="coreft_calendar_clear"></div><input type="button" class="coreftCalendar_send coreftCalendar_action" name="" value="'+instance.settings.lang_subscribe+'" />';
				mailform += '<span class="coreftCalendar_sending_email"></span>';
				mailform += '</form>';
				
				if(!$('.coreftCalendarModal').length) {
					$('body').append(
						$('<div>').addClass('coreftCalendarModal').prepend(
							$('<h2>').text(instance.settings.lang_subscribe).append(
								$('<a>').addClass('coreftCalendarClose').attr({ 'href': '#' }).html('<i class="fa fa-times"></i>')
							)
						).append(
							$('<div>').addClass('coreftCalendar_mailform').html(mailform)
						).show()
					);
					
					$('.coreftCalendarOverlay').show();
					
					//dpShareLoadEvents();
				} else {
					
					$('.coreftCalendarModal .coreft_book_select_date, .coreftCalendarModal .coreftCalendar_mailform').remove();
					
					$('.coreftCalendarModal').append(
						$('<div>').addClass('coreftCalendar_mailform').html(mailform)
					)

					$('.coreftCalendarModal, .coreftCalendarOverlay').removeAttr('style').show();

				}
				
				if(ProEventCalendarAjax.recaptcha_enable && ProEventCalendarAjax.recaptcha_site_key != "") {
					var coreft_subscribe_captcha;
					coreft_subscribe_captcha = grecaptcha.render($('#coreft_subscribe_captcha', '.coreftCalendarModal')[0], {
					  'sitekey' : ProEventCalendarAjax.recaptcha_site_key
					});
				}
				
				$('.coreftCalendar_send', '.coreftCalendarModal').click(function(e) {
					e.preventDefault();
					$(this).prop('disabled', true);
					$('.coreftCalendar_sending_email', '.coreftCalendarModal').css('display', 'inline-block');
					
					var post_obj = {
						your_name: $('#coreftCalendar_your_name', '.coreftCalendarModal').val(),
						your_email: $('#coreftCalendar_your_email', '.coreftCalendarModal').val(),
						calendar: instance.settings.calendar,
						action: 'ProEventCalendar_NewSubscriber', 
						postEventsNonce : ProEventCalendarAjax.postEventsNonce 
					}

					var captcha_error = false;
					if(ProEventCalendarAjax.recaptcha_enable && ProEventCalendarAjax.recaptcha_site_key != "") {
						post_obj.grecaptcharesponse = grecaptcha.getResponse(coreft_subscribe_captcha);
						if(post_obj.grecaptcharesponse == "") {
							captcha_error = true;
						}
					}

					if( $('#coreftCalendar_your_name', '.coreftCalendarModal').val() != ""
						&& $('#coreftCalendar_your_email', '.coreftCalendarModal').val() != ""
						&& !captcha_error) {
						
						jQuery.post(ProEventCalendarAjax.ajaxurl, post_obj,
							function(data) {
								$('.coreftCalendar_send', '.coreftCalendarModal').prop('disabled', false);
								$('.coreftCalendar_sending_email', '.coreftCalendarModal').hide();
								
								$('.coreftCalendar_success, .coreftCalendar_error').hide();
								$('.coreftCalendar_success').css('display', 'inline-block');
								$('form', '.coreftCalendarModal')[0].reset();

								grecaptcha.reset(coreft_subscribe_captcha);
							}
						);	
					} else {
						$(this).prop('disabled', false);
						$('.coreftCalendar_sending_email', '.coreftCalendarModal').hide();
						
						$('.coreftCalendar_success, .coreftCalendar_error').hide();
						$('.coreftCalendar_error').css('display', 'inline-block');
					}
				});
				
				$("input, textarea", '.coreftCalendarModal').placeholder();
				
				
			});

			$('.coreft_calendar_references', instance.calendar).click(function(e) {
				e.preventDefault();
				if(!$(this).hasClass('active')) {
					$(this).addClass('active');
					$('.coreft_calendar_references_div', instance.calendar).slideDown('fast');
				} else {
					$(this).removeClass('active');
					$('.coreft_calendar_references_div', instance.calendar).slideUp('fast');
				}
				
			});
			
			if(instance.monthlyView == "calendar") {
				var coreftcalendar_date = $('.coreft_calendar_content', instance.calendar).find(".coreft_calendar_date[data-coreftcalendar-date='" + instance.settings.defaultDateFormat + "']");
				
				if(typeof coreftcalendar_date.attr('style') == 'undefined' && instance.settings.show_current_date && instance.settings.current_date_color != "") {
					coreftcalendar_date.addClass('coreft_calendar_special_date');
					$('.coreft_calendar_date_item, .coreft_special_date_dot', coreftcalendar_date).css('background-color', instance.settings.current_date_color);
				}
			}
			
			$('.coreft_calendar_view_all', instance.calendar).click(function(event) {
				event.preventDefault();

				if(!$('.coreft_calendar_content', instance.calendar).hasClass('isDragging') && (event.which === 1 || event.which === 0)) {
					if(instance.monthlyView == "calendar") {
						$(this).html('<i class="fa fa-calendar-o"></i>'+$(this).data('translation-calendar'));
						instance.monthlyView = "list";
					} else {
						$(this).html('<i class="fa fa-list"></i>'+$(this).data('translation-list'));
						instance.monthlyView = "calendar";
					}
					
					instance._changeMonth();
					
				}
			});

			$('.coreft_calendar_search_btn', instance.calendar).click(function(event) {
				event.preventDefault();

				if((event.which === 1 || event.which === 0)) {
					if(!$('.coreft_calendar_search_form', instance.calendar).is(':visible')) {
						$(this).addClass('active');
						$('.coreft_calendar_search_form', instance.calendar).slideDown('fast');
						$('.coreft_calendar_search_form input[type=search]', instance.calendar).focus();
					} else {
						$(this).removeClass('active');
						$('.coreft_calendar_search_form', instance.calendar).slideUp('fast');
					}
					
				}
			});
			
			if(instance.settings.selectric) {
				$('.coreft_calendar_layout select, .coreft_calendar_add_form select, .coreft_calendar_nav select, .coreft_calendar_accordion_wrapper select', instance.calendar).selectric();
			}

			$(window).bind('unload', function(e){
			    $('.coreft_calendar_nav .selectric-wrapper', instance.calendar).remove();

			});
						
			if(instance.view == "monthly-all-events" 
				&& instance.settings.type != "accordion" 
				&& instance.settings.type != "accordion-upcoming" 
				&& instance.settings.type != "add-event" 
				&& instance.settings.type != "list-author" 
				&& instance.settings.type != "grid" 
				&& instance.settings.type != "grid-upcoming" 
				&& instance.settings.type != "compact-upcoming" 
				&& instance.settings.type != "list-upcoming" 
				&& instance.settings.type != "gmaps-upcoming" 
				&& instance.settings.type != "today-events" 
				&& instance.settings.type != "bookings-user" 
				&& instance.settings.type != "past"
				&& instance.settings.type != "compact"
				&& instance.settings.type != "modern"
				&& instance.settings.type != "countdown") 
			{
				$('.coreft_calendar_view_all', instance.calendar).addClass('active');
				instance.monthlyView = "list";
				
				instance._changeMonth();
			}

			$('.coreft_calendar_references_close', instance.calendar).click(function(e) {
				e.preventDefault();
				$('.coreft_calendar_references', instance.calendar).removeClass('active');
				$('.coreft_calendar_references_div', instance.calendar).slideUp('fast');
			});
			
			$('.coreft_calendar_search', instance.calendar).one('click', function(event) {
				$(this).val("");
			});
			
			if($('.coreft_calendar_accordion_event', instance.calendar).length) {
				$(instance.calendar).on('click', '.coreft_calendar_accordion_event', function(e) {

					if(!$(this).hasClass('visible')) {
						if(e.target.className != "coreft_calendar_date_event_close" && e.target.className != "fa fa-close") {
							$('.coreft_calendar_accordion_event').removeClass('visible');
							$(this).addClass('visible');

							instance._goToByScroll($(this));

							if(typeof instance.grid != "undefined") {
								instance.grid.isotope('layout');
							}
						}
					} else {
						//$(this).removeClass('visible');
					}
				});
				
				$(instance.calendar).on('click', '.coreft_calendar_date_event_close', function(e) {
					
					$('.coreft_calendar_accordion_event', instance.calendar).removeClass('visible');
					
					if(typeof instance.grid != "undefined") {
						instance.grid.isotope('layout');
					}

				});
			}
			
			if($('.coreft_calendar_view_action', instance.calendar).length) {
				$('.coreft_calendar_view_action', instance.calendar).click(function(e) {
					e.preventDefault();
					$('.coreft_calendar_view_action', instance.calendar).removeClass('active');
					$(this).addClass('active');
					
					if(instance.view != $(this).data('coreft-view')) {
						instance.view = $(this).data('coreft-view');
						
						instance._changeLayout();
					}
				});
			}
			
			if($('.coreft_calendar_clear_end_date', instance.calendar).length) {
				$('.coreft_calendar_clear_end_date', instance.calendar).click(function(e) {
					e.preventDefault();
					$('.coreft_calendar_end_date_input', instance.calendar).val('');
				});
				
			}
			
			if($('.coreft_calendar_add_event', instance.calendar).length) {
				$('.coreft_calendar_add_event', instance.calendar).click(function(e) {
					e.preventDefault();
					$(this).hide();
					$('.coreft_calendar_cancel_event', instance.calendar).show();
					
					$('.coreft_calendar_add_form', instance.calendar).slideDown('fast');
					
					if(ProEventCalendarAjax.recaptcha_enable && ProEventCalendarAjax.recaptcha_site_key != "") {
						coreft_new_event_captcha = grecaptcha.render($('#coreft_new_event_captcha', instance.calendar)[0], {
						  'sitekey' : ProEventCalendarAjax.recaptcha_site_key
						});
					}
					
				});
			}
			
			jQuery("#coreft_map_address", instance.calendar).on('focus', function () {
				$('.map_lnlat_wrap', instance.calendar).show();
				
				jQuery("#coreft_map_address", instance.calendar).off('focus');
				
				var geocoder = new google.maps.Geocoder();
				var	map;
				var marker;
									
				function geocodePosition(pos) {
				  geocoder.geocode({
					latLng: pos
				  }, function(responses) {
					if (responses && responses.length > 0) {
					  updateMarkerAddress(responses[0].formatted_address);
					} else {
					  //updateMarkerAddress("Cannot determine address at this location.");
					}
				  });
				}
				
				function updateMarkerPosition(latLng) {
				  jQuery("#map_lnlat", instance.calendar).val([
					latLng.lat(),
					latLng.lng()
				  ].join(", "));
				}
				
				function updateMarkerAddress(str) {
				  jQuery("#coreft_map_address", instance.calendar).val(str);
				}
				
				function coreft_map_initialize() {

				  var latLng = new google.maps.LatLng(instance.settings.map_lat,instance.settings.map_lng);
				  map = new google.maps.Map(jQuery("#coreft_mapCanvas", instance.calendar)[0], {
					zoom: (instance.settings.map_lat != 0 ? 12 : 3),
					center: latLng,
					mapTypeId: google.maps.MapTypeId.ROADMAP
				  });
				  marker = new google.maps.Marker({
					position: latLng,
					title: "Location",
					map: map,
					draggable: true
				  });
				  
				  // Update current position info.
				  updateMarkerPosition(latLng);
				  //geocodePosition(latLng);
				  
				  // Add dragging event listeners.
				  google.maps.event.addListener(marker, "dragstart", function() {
					updateMarkerAddress("");
				  });
				  
				  google.maps.event.addListener(marker, "drag", function() {
					updateMarkerPosition(marker.getPosition());
				  });
				  
				  google.maps.event.addListener(marker, "dragend", function() {
					geocodePosition(marker.getPosition());
				  });
				}
				
				var timeout;

				jQuery("#coreft_map_address", instance.calendar).on('keyup', function () {
				  clearTimeout( timeout );
				  timeout = setTimeout(function() {
					  geocoder.geocode( { "address": jQuery("#coreft_map_address", instance.calendar).val()}, function(results, status) {
						  if(status != "OVER_QUERY_LIMIT") {
							  var latlng = results[0].geometry.location;
							  marker.setPosition(latlng);
							  
							 // var listener = google.maps.event.addListener(map, "idle", function() { 
								  if (map.getZoom() < 12) map.setZoom(12); 
								  map.setCenter(latlng);
								  //google.maps.event.removeListener(listener); 
								//});
								
								updateMarkerPosition(latlng);
						  }
					 });
				 }, 1000);
				});
				
				// Onload handler to fire off the app.
				coreft_map_initialize();
				//google.maps.event.addDomListener(window, "load", coreft_map_initialize);
			});
			
			if($('.coreft_calendar_cancel_event', instance.calendar).length) {
				$('.coreft_calendar_cancel_event', instance.calendar).click(function(e) {
					e.preventDefault();
					$(this).hide();
					$('.coreft_calendar_add_event', instance.calendar).show();
					
					$('.coreft_calendar_add_form', instance.calendar).slideUp('fast');
					$('.coreft_calendar_notification_event_succesfull', instance.calendar).hide();
					
				});
			}
			
			if($('.event_image', instance.calendar).length) {

				$(instance.calendar).on('change', '.event_image', function() 
				{
					$('#event_image_lbl', $(this).parent()).val($(this).val().replace(/^.*[\\\/]/, ''));
				});

			}
			
			//if($('.coreft_edit_event', instance.calendar).length) {
				
			//}
			
			$(instance.calendar).on('click', '.coreft_remove_event', function(e) {
				$('body, html').css('overflow', 'hidden');
				
				if(!$('.coreftCalendarModalEditEvent').length) {
			
					$('body').append(
						$('<div>').addClass('coreftCalendarModalEditEvent coreftCalendarModalSmall coreft_calendar_new_event_wrapper').prepend(
							$('<h2>').text(instance.settings.lang_remove_event).append(
								$('<a>').addClass('coreftCalendarClose').attr({ 'href': '#' }).html('<i class="fa fa-times"></i>')
							)
						).append(
							$('<div>').addClass('coreftCalendar_eventform').append($(this).next().children().clone(true))
						).show()
					);
					
					$('.coreftCalendarOverlay').show();
					
				} else {
					$('.coreftCalendar_eventform').html($(this).next().html());
					$('.coreftCalendarModalEditEvent').addClass('coreftCalendarModalSmall');
					$('.coreftCalendarModalEditEvent h2').text(instance.settings.lang_remove_event).append(
						$('<a>').addClass('coreftCalendarClose').attr({ 'href': '#' }).html('<i class="fa fa-times"></i>')
					);
					$('.coreftCalendarModalEditEvent, .coreftCalendarOverlay').show();
				}
				
				$('.coreftCalendarModalEditEvent').on('click', '.coreft_calendar_remove_event', function(e) {
					e.preventDefault();
					$(this).addClass('coreft_calendar_disabled');
					var form = $(this).closest(".add_new_event_form");
					
					var origName = $(this).html();
					$(this).html(instance.settings.lang_sending);
					var me = this;
					var form = $(this).closest('form');
					var post_obj = {
						calendar: instance.settings.calendar, 
						action: 'removeEvent',
						postEventsNonce : ProEventCalendarAjax.postEventsNonce
					}

					$(this).closest(".add_new_event_form").ajaxForm({
						url: ProEventCalendarAjax.ajaxurl,
						data: post_obj,
						success:function(data){
							$(me).html(origName);
							location.reload();	

							$(me).removeClass('coreft_calendar_disabled');

						}
					}).submit();
				});		
				return false;
			});

			$(instance.calendar).on('click', '.coreft_cancel_booking', function(e) {
				e.preventDefault();

				$('body, html').css('overflow', 'hidden');
				
				if(!$('.coreftCalendarModalEditEvent').length) {
			
					$('body').append(
						$('<div>').addClass('coreftCalendarModalEditEvent coreftCalendarModalSmall coreft_calendar_new_event_wrapper').prepend(
							$('<h2>').text($(this).text()).append(
								$('<a>').addClass('coreftCalendarClose').attr({ 'href': '#' }).html('<i class="fa fa-times"></i>')
							)
						).append(
							$('<div>').addClass('coreftCalendar_eventform').append($(this).next().children().clone(true))
						).show()
					);
					
					$('.coreftCalendarOverlay').show();
					
				} else {
					$('.coreftCalendar_eventform').html($(this).next().html());
					$('.coreftCalendarModalEditEvent').addClass('coreftCalendarModalSmall');
					$('.coreftCalendarModalEditEvent h2').text($(this).text()).append(
						$('<a>').addClass('coreftCalendarClose').attr({ 'href': '#' }).html('<i class="fa fa-times"></i>')
					);
					$('.coreftCalendarModalEditEvent, .coreftCalendarOverlay').show();
				}
				
				$('.coreftCalendarModalEditEvent').on('click', '.coreft_calendar_cancel_booking', function(e) {
					e.preventDefault();
					$(this).addClass('coreft_calendar_disabled');
					var form = $(this).closest(".add_new_event_form");
					
					var origName = $(this).html();
					$(this).html(instance.settings.lang_sending);
					var me = this;
					var form = $(this).closest('form');
					var post_obj = {
						calendar: instance.settings.calendar, 
						action: 'cancelBooking',
						postEventsNonce : ProEventCalendarAjax.postEventsNonce
					}

					$(this).closest(".add_new_event_form").ajaxForm({
						url: ProEventCalendarAjax.ajaxurl,
						data: post_obj,
						success:function(data){
							$(me).html(origName);
							location.reload();	

							$(me).removeClass('coreft_calendar_disabled');

						}
					}).submit();
				});		
				
			});
			
			function coreft_createWindowNotification(text) {
				if(!$('.coreftCalendar_windowNotification').length) {
					$('body').append(
						$('<div>').addClass('coreftCalendar_windowNotification').text(text).show()
					);
				} else {
					$('.coreftCalendar_windowNotification').removeClass('fadeOutDown').text(text).show();
				}
				
				setTimeout(function() { $('.coreftCalendar_windowNotification').addClass('fadeOutDown'); }, 3000)
			}
			
			//if($('.coreft_calendar_submit_event', instance.calendar).length) {
				//$([instance.calendar, '.coreftCalendarModalEditEvent']).each(function() {
				function submit_event_hook(el) {
					$(el).on('click', '.coreft_calendar_submit_event', function(e) {
						e.preventDefault();
						if(typeof tinyMCE != "undefined") {
							tinyMCE.triggerSave();
						}

						//var form = $(this).closest(".add_new_event_form");
						
						var origName = $(this).html();
						
						var me = this;
						var form = $(this).closest('form');
						var post_obj = {
							calendar: instance.settings.calendar, 
							action: 'submitEvent',
							postEventsNonce : ProEventCalendarAjax.postEventsNonce
						}
						
						var is_valid = true;
						$('.coreft_required', form).each(function() {
							
							$(this).removeClass('coreft_calendar_validation_error');

							if($(this).is(':checkbox')) {
								if($(this).is( ":checked" ) == false) {
									
									$(this).addClass('coreft_calendar_validation_error');
									
									is_valid = false;
									return;
								}
							} else {
								if($(this).val() == "") {
									
									$(this).addClass('coreft_calendar_validation_error');
									
									is_valid = false;
									return;
								}
							}

						});

						if(!is_valid) {
							return false;
						}

						if(ProEventCalendarAjax.recaptcha_enable && ProEventCalendarAjax.recaptcha_site_key != "") {
							post_obj.grecaptcharesponse = grecaptcha.getResponse(coreft_new_event_captcha);
							if(post_obj.grecaptcharesponse == "") {
								return false;
							}
						}

						$(this).addClass('coreft_calendar_disabled');
						if(instance.settings.type == "add-event") {
							$('.events_loading', form).show();
							form.fadeTo('fast', .5);
						}
						$(this).html($(this).data('lang-sending'));	
	
						$(this).closest(".add_new_event_form").ajaxForm({
							url: ProEventCalendarAjax.ajaxurl,
							data: post_obj,
							success:function(data){
								$(me).html(origName);
								if(!form.hasClass('edit_event_form')) {
									$(form)[0].reset();
								} else {
									location.reload();	
								}
								$('select', form).selectric('refresh');

								$('.coreft_calendar_form_title', form).removeClass('coreft_calendar_validation_error');
								$(me).removeClass('coreft_calendar_disabled');
								$('.coreft_calendar_notification_event_succesfull', form.parent()).show();

								instance._goToByScroll($('.coreft_calendar_notification_event_succesfull', form.parent()));

								if(instance.settings.type == "add-event") {
									$('.events_loading', form).hide();
									form.fadeTo('fast', 1);
								}
							}
						}).submit();
					});		
				}
				submit_event_hook(instance.calendar);
				//});
			//}
			
			$('.coreft_calendar_search_form', instance.calendar).submit(function() {
				if($(this).find('.coreft_calendar_search').val() != "" && !$('.coreft_calendar_content', instance.calendar).hasClass( 'coreft_calendar_content_loading' )) {
					instance._removeElements();
					
					$.post(ProEventCalendarAjax.ajaxurl, { 
						key: $(this).find('.coreft_calendar_search').val(),
						calendar: instance.settings.calendar, 
						columns: instance.settings.columns, 
						author: instance.settings.author, 
						action: 'getSearchResults', 
						postEventsNonce : ProEventCalendarAjax.postEventsNonce 
					},
						function(data) {
							
							$('.coreft_calendar_content', instance.calendar).removeClass( 'coreft_calendar_content_loading' ).empty().html(data);
							
							instance.eventDates = $('.coreft_calendar_date', instance.calendar);
							
							$('.coreft_calendar_date', instance.calendar).hide().fadeIn(500);
						}
					);	
				}
				return false;
			});
			
			$('.coreft_calendar_icon_search', instance.calendar).click(function(e) {
				e.preventDefault();

				if($(this).parent().find('.coreft_calendar_content_search_input').val() != "" && !$('.coreft_calendar_content', instance.calendar).hasClass( 'coreft_calendar_content_loading' )) {
					instance._removeElements();
					var results_lang = $(this).data('results_lang');
					$('.events_loading', instance.calendar).show();
					
					$.post(ProEventCalendarAjax.ajaxurl, { 
						key: $(this).parent().find('.coreft_calendar_content_search_input').val(),
						type: 'accordion', 
						calendar: instance.settings.calendar, 
						columns: instance.settings.columns, 
						author: instance.settings.author, 
						action: 'getSearchResults', 
						postEventsNonce : ProEventCalendarAjax.postEventsNonce 
					},
						function(data) {
							
							$('.coreft_calendar_content', instance.calendar).removeClass( 'coreft_calendar_content_loading' ).html(data);
							$('.actual_month', instance.calendar).text(results_lang);
							$('.return_layout', instance.calendar).show();
							$('.month_arrows', instance.calendar).hide();
							$('.events_loading', instance.calendar).hide();
							//.empty();
							
						}
					);	
				}
				return false;
			});
			
			$('.return_layout', instance.calendar).click(function() {
				$(this).hide();
				$('.month_arrows', instance.calendar).show();
				$('.coreft_calendar_content_search_input', instance.calendar).val('');
				
				instance._changeMonth();
			});
			
			$(instance.calendar).on('click', '.coreftCalendar_load_more', function() {
				
				var items = $(this).parent().find('.coreft_calendar_isotope:not(.coreft_calendar_date_event_head,.coreft_calendar_date_block_wrap):hidden').slice(0,$(this).data('pagination'));
				
				items.show();
				
				$(this).parent().find('.coreft_calendar_isotope:not(.coreft_calendar_date_event_head):visible:last').prevAll('.coreft_calendar_date_block_wrap').show();
				
				/*$.each($(this).parent().find('.coreft_calendar_isotope:not(.coreft_calendar_date_event_head)'), function(index) {
					
					if($(this).is(':visible')) {
						$(this).prevAll('.coreft_calendar_date_block_wrap').show();
					}
				});*/
				
				if($(this).data('total') <= $(this).parent().find('.coreft_calendar_isotope:not(.coreft_calendar_date_event_head,.coreft_calendar_date_block_wrap):visible').length) {
					$(this).hide();
				}
				
				if(typeof instance.grid != "undefined") {
					instance.grid.isotope('appended', items);
				}

				return false;
				
			});
			
			$('.coreft_calendar_content_search_input', instance.calendar).keyup(function (e) {
				if (e.keyCode == 13) {
					// Do something
					$('.coreft_calendar_icon_search', instance.calendar).trigger('click');
				}
			});
			
			$('.coreft_categories_list', instance.calendar).on('change', function() {
					$('.coreft_calendar_search_form', instance.calendar).find('.coreft_calendar_search').val('');
					
					if(instance.view == "monthly" || instance.view == "monthly-all-events") {
						instance._changeMonth();
					}
					
					if(instance.view == "daily") {
						instance._changeDay();
					}
					
					if(instance.view == "weekly") {
						instance._changeWeek();
					}
				
				return false;
			});

			$('.coreft_location_list', instance.calendar).on('change', function() {
					$('.coreft_calendar_search_form', instance.calendar).find('.coreft_calendar_search').val('');

					if(instance.view == "monthly" || instance.view == "monthly-all-events") {
						instance._changeMonth();
					}
					
					if(instance.view == "daily") {
						instance._changeDay();
					}
					
					if(instance.view == "weekly") {
						instance._changeWeek();
					}
				
				return false;
			});
			
			$('.coreft_calendar_nav select.coreft_switch_year', instance.calendar).on('change', function() {
				$('.coreft_calendar_search_form', instance.calendar).find('.coreft_calendar_search').val('');
				instance.settings.actualYear = $(this).val();
				instance._changeMonth();
				return false;
			});
			
			$('.coreft_calendar_nav select.coreft_switch_month', instance.calendar).on('change', function() {
				$('.coreft_calendar_search_form', instance.calendar).find('.coreft_calendar_search').val('');

				var changed_month = $(this).val();
				if(changed_month.indexOf('-') !== -1) {
					var changed_month_split = changed_month.split('-');
					instance.settings.actualYear = parseInt(changed_month_split[1], 10);
					changed_month = changed_month_split[0];

				}

				for(i = 0; i < instance.settings.monthNames.length; i++) {
					if(instance.settings.monthNames[i] == changed_month) {
						instance.settings.actualMonth = i + 1;
					}
				}
				instance._changeMonth();
				return false;
			});
			
			if(!$.proCalendar_isVersion('1.7')) {
				$(instance.calendar).on('click', '.coreft_calendar_date_event_map', function(event) {
					event.preventDefault();
					$(this).closest('.coreft_calendar_date_event').find('.coreft_calendar_date_event_map_iframe').slideDown('fast');
				});
			} else {
				$('.coreft_calendar_date_event_map', instance.calendar).live('click', function(event) {
					event.preventDefault();
					$(this).closest('.coreft_calendar_date_event').find('.coreft_calendar_date_event_map_iframe').slideDown('fast');
				});
			}
			
			$(instance.calendar).on('change', 'select.coreft_recurring_frequency', function() {
				
				instance._coreft_update_frequency(this.value);
				
			});

			$(instance.calendar).on('change', 'select.coreft_location_form', function() {
				
				instance._coreft_update_location(this.value);
				
			});
		},

		_goToByScroll : function(id){

		      // Scroll
		    $('html,body').animate({
		        scrollTop: (id.offset().top - 30)},
		        'slow');
		},
		
		_coreft_update_location : function(val) {
			
			var instance = this;

			jQuery('.coreft_location_options', instance.calendar).hide();
			
			switch(val) {
				case "-1":
					jQuery(".coreft_location_options", instance.calendar).show();
					break;	
			}
		},

		_coreft_update_frequency : function(val) {
			
			var instance = this;

			jQuery('.coreft_daily_frequency', instance.calendar).hide();
			jQuery('.coreft_weekly_frequency', instance.calendar).hide();
			jQuery('.coreft_monthly_frequency', instance.calendar).hide();
			
			switch(val) {
				case "1":
					jQuery(".coreft_daily_frequency", instance.calendar).show();
					jQuery(".coreft_weekly_frequency", instance.calendar).hide();
					jQuery(".coreft_monthly_frequency", instance.calendar).hide();
					break;	
				case "2":
					jQuery(".coreft_daily_frequency", instance.calendar).hide();
					jQuery(".coreft_weekly_frequency", instance.calendar).show();
					jQuery(".coreft_monthly_frequency", instance.calendar).hide();
					break;	
				case "3":
					jQuery(".coreft_daily_frequency", instance.calendar).hide();
					jQuery(".coreft_weekly_frequency", instance.calendar).hide();
					jQuery(".coreft_monthly_frequency", instance.calendar).show();
					break;	
				case "4":
					jQuery(".coreft_daily_frequency", instance.calendar).hide();
					jQuery(".coreft_weekly_frequency", instance.calendar).hide();
					jQuery(".coreft_monthly_frequency", instance.calendar).hide();
					break;	
			}
		},
						
		_makeResponsive : function() {
			var instance = this;
			
			if(instance.calendar.width() < 500) {

				$(instance.calendar).addClass('coreft_calendar_400');

				$('.coreft_calendar_dayname span', instance.calendar).each(function(i) {
					$(this).html($(this).html().substr(0,3));
				});
				
				$('.prev_month strong', instance.calendar).hide();
				$('.next_month strong', instance.calendar).hide();
				$('.prev_day strong', instance.calendar).hide();
				$('.next_day strong', instance.calendar).hide();
				
			} else {
				$(instance.calendar).removeClass('coreft_calendar_400');

				$('.prev_month strong', instance.calendar).show();
				$('.next_month strong', instance.calendar).show();
				$('.prev_day strong', instance.calendar).show();
				$('.next_day strong', instance.calendar).show();
				
			}
		},
		_removeElements : function () {
			var instance = this;
			
			$('.coreft_calendar_date, .coreft_calendar_date_weekly_time, .coreft_calendar_dayname,.coreft_calendar_isotope,.coreftCalendar_load_more, .coreft_calendar_responsive_weekly', instance.calendar).fadeOut(500);
			$('.coreft_calendar_monthly_row, .coreft_calendar_monthly_row_space', instance.calendar).hide();
			$('.coreft_calendar_content', instance.calendar).addClass( 'coreft_calendar_content_loading' );
			$('.eventsPreviewDiv').html('').hide();
		},
		
		_prevMonth : function (instance) {
			if(!$('.coreft_calendar_content', instance.calendar).hasClass( 'coreft_calendar_content_loading' )) {
				instance.settings.actualMonth--;
				instance.settings.actualMonth = instance.settings.actualMonth == 0 ? 12 : (instance.settings.actualMonth);
				instance.settings.actualYear = instance.settings.actualMonth == 12 ? instance.settings.actualYear - 1 : instance.settings.actualYear;
				
				instance._changeMonth();
			}
		},
		
		_nextMonth : function (instance) {

			if(!$('.coreft_calendar_content', instance.calendar).hasClass( 'coreft_calendar_content_loading' )) {
				instance.settings.actualMonth++;
				instance.settings.actualMonth = instance.settings.actualMonth == 13 ? 1 : (instance.settings.actualMonth);
			
				instance.settings.actualYear = instance.settings.actualMonth == 1 ? instance.settings.actualYear + 1 : instance.settings.actualYear;
				
				instance._changeMonth();
			}
		},
		
		_prevDay : function (instance) {
			if(!$('.coreft_calendar_content', instance.calendar).hasClass( 'coreft_calendar_content_loading' )) {
				instance.settings.actualDay--;
				//instance.settings.actualDay = instance.settings.actualDay == 0 ? 12 : (instance.settings.actualDay);
				
				instance._changeDay();
			}
		},
		
		_nextDay : function (instance) {
			if(!$('.coreft_calendar_content', instance.calendar).hasClass( 'coreft_calendar_content_loading' )) {
				instance.settings.actualDay++;
				//instance.settings.actualDay = instance.settings.actualDay == 13 ? 1 : (instance.settings.actualDay);
	
				instance._changeDay();
			}
		},
		
		_prevWeek : function (instance) {
			if(!$('.coreft_calendar_content', instance.calendar).hasClass( 'coreft_calendar_content_loading' )) {
				instance.settings.actualDay -= 7;
				//instance.settings.actualDay = instance.settings.actualDay == 0 ? 12 : (instance.settings.actualDay);
				
				instance._changeWeek();
			}
		},
		
		_nextWeek : function (instance) {

			if(!$('.coreft_calendar_content', instance.calendar).hasClass( 'coreft_calendar_content_loading' )) {
				instance.settings.actualDay += 7;
				//instance.settings.actualDay = instance.settings.actualDay == 13 ? 1 : (instance.settings.actualDay);
	
				instance._changeWeek();
			}
		},
		
		_changeMonth : function () {
			var instance = this;
			
			//$('.coreft_calendar_content', instance.calendar).css({'overflow': 'hidden'});
			$('.coreft_calendar_nav_monthly', instance.calendar).show();
			$('.actual_month', instance.calendar).html( instance.settings.monthNames[(instance.settings.actualMonth - 1)] + ' ' + instance.settings.actualYear );
			
			if($('.coreft_calendar_nav select.coreft_switch_month', instance.calendar).length) {
				if($('.coreft_calendar_nav select.coreft_switch_month', instance.calendar).val().indexOf('-') !== -1) {

					$('.coreft_calendar_nav select.coreft_switch_month', instance.calendar).val(instance.settings.monthNames[(instance.settings.actualMonth - 1)]+'-'+instance.settings.actualYear);

				} else {

					$('.coreft_calendar_nav select.coreft_switch_month', instance.calendar).val(instance.settings.monthNames[(instance.settings.actualMonth - 1)]);

				}
			}

			$('.coreft_calendar_nav select.coreft_switch_year', instance.calendar).val(instance.settings.actualYear);
			$('.coreft_calendar_nav select', instance.calendar).selectric('refresh');
			
			instance._removeElements();
			
			if(instance.settings.dateRangeStart && instance.settings.dateRangeStart.substr(0, 7) == instance.settings.actualYear+"-"+instance._str_pad(instance.settings.actualMonth, 2, "0", 'STR_PAD_LEFT') && !instance.settings.isAdmin) {
				$('.prev_month', instance.calendar).hide();
			} else {
				$('.prev_month', instance.calendar).show();
			}

			if(instance.settings.dateRangeEnd && instance.settings.dateRangeEnd.substr(0, 7) == instance.settings.actualYear+"-"+instance._str_pad(instance.settings.actualMonth, 2, "0", 'STR_PAD_LEFT') && !instance.settings.isAdmin) {
				$('.next_month', instance.calendar).hide();
			} else {
				$('.next_month', instance.calendar).show();
			}
			
			var date_timestamp = Date.UTC(instance.settings.actualYear, (instance.settings.actualMonth - 1), 15) / 1000;
			
			if(instance.settings.type == "accordion") {
				$('.events_loading', instance.calendar).show();
				$.post(ProEventCalendarAjax.ajaxurl, { 
						month: instance.settings.actualMonth, 
						year: instance.settings.actualYear, 
						calendar: instance.settings.calendar, 
						columns: instance.settings.columns, 
						limit: instance.settings.limit, 
						widget: instance.settings.widget, 
						category: (instance.settings.category != "" ? instance.settings.category : $('select.coreft_categories_list', instance.calendar).val()),
						location: (instance.settings.location != "" ? instance.settings.location : $('select.coreft_location_list', instance.calendar).val()),
						event_id: instance.settings.event_id, 
						author: instance.settings.author, 
						include_all_events: instance.settings.include_all_events,
						hide_old_dates: instance.settings.hide_old_dates,
						action: 'getEventsMonthList', 
						postEventsNonce : ProEventCalendarAjax.postEventsNonce 
					},
					function(data) {
						
						$('.events_loading', instance.calendar).hide();
						
						if(typeof instance.grid != "undefined") {
							
							//instance.grid.isotope( 'appended', data )
							instance.grid.isotope( 'remove', $('.coreft_calendar_content_ajax .coreft_calendar_isotope', instance.calendar) );

							
							var toAppend = []; //array containing promises 
							var tasks    = [];

							
							  var element = $(data);
							  if( element.length == 0 )
							  {
							    return;
							  }
							  //toAppend only contains non-empty elements
							  $.each(element, function(i, el){
							    toAppend.push(el);
							  });

							//console.log(toAppend);
							instance.grid.isotope('insert', toAppend);
							instance.grid.isotope('layout');
						} else {
							$('.coreft_calendar_content_ajax', instance.calendar).empty().html(data);
						}

						$('.coreft_calendar_content', instance.calendar).removeClass( 'coreft_calendar_content_loading' );

					}
				);	
			} else {
				if(instance.monthlyView == "calendar") {
					var start = new Date().getTime(); // note getTime()

					$.post(ProEventCalendarAjax.ajaxurl, { 
						date: date_timestamp, 
						calendar: instance.settings.calendar, 
						category: (instance.settings.category != "" ? instance.settings.category : $('select.coreft_categories_list', instance.calendar).val()),
						location: (instance.settings.location != "" ? instance.settings.location : $('select.coreft_location_list', instance.calendar).val()),
						is_admin: instance.settings.isAdmin, 
						event_id: instance.settings.event_id, 
						author: instance.settings.author, 
						include_all_events: instance.settings.include_all_events,
						hide_old_dates: instance.settings.hide_old_dates,
						type: instance.settings.type, 
						action: 'getDate', 
						postEventsNonce : ProEventCalendarAjax.postEventsNonce 
					},
						function(data) {
							
							$('.coreft_calendar_content', instance.calendar).removeClass( 'coreft_calendar_content_loading' ).empty().html(data);
							
							var coreftcalendar_date = $('.coreft_calendar_content', instance.calendar).find(".coreft_calendar_date[data-coreftcalendar-date='" + instance.settings.defaultDateFormat + "']");
							
							var coreftcalendar_date_item = coreftcalendar_date.find('.coreft_calendar_date_item');
							if(typeof coreftcalendar_date_item.attr('style') == 'undefined' && instance.settings.show_current_date && instance.settings.current_date_color != "") {
								coreftcalendar_date.addClass('coreft_calendar_special_date');
								coreftcalendar_date_item.css('background-color', instance.settings.current_date_color);
								$('.coreft_special_date_dot', coreftcalendar_date_item).css('background-color', instance.settings.current_date_color);
							}

							$(instance.calendar).removeClass('coreft_calendar_daily');
							$(instance.calendar).removeClass('coreft_calendar_weekly');
							$(instance.calendar).addClass('coreft_calendar_'+instance.view);
		
							instance.eventDates = $('.coreft_calendar_date', instance.calendar);
							
							
							// Load time debug
					        //console.log( end - start );
							
							$('.coreft_calendar_date', instance.calendar).hide().fadeIn(500);
							instance._makeResponsive();
						}
					);	
					
				} else {
				
					$.post(ProEventCalendarAjax.ajaxurl, { 
						month: instance.settings.actualMonth, 
						year: instance.settings.actualYear, 
						calendar: instance.settings.calendar, 
						category: (instance.settings.category != "" ? instance.settings.category : $('select.coreft_categories_list', instance.calendar).val()),
						location: (instance.settings.location != "" ? instance.settings.location : $('select.coreft_location_list', instance.calendar).val()),
						event_id: instance.settings.event_id, 
						author: instance.settings.author, 
						include_all_events: instance.settings.include_all_events,
						hide_old_dates: instance.settings.hide_old_dates,
						action: 'getEventsMonth', 
						postEventsNonce : ProEventCalendarAjax.postEventsNonce 
					},
						function(data) {
		
							$('.coreft_calendar_content', instance.calendar).removeClass( 'coreft_calendar_content_loading' ).empty().html(data);
							$(instance.calendar).removeClass('coreft_calendar_daily');
							$(instance.calendar).removeClass('coreft_calendar_weekly');
							$(instance.calendar).addClass('coreft_calendar_'+instance.view);
							
							instance.eventDates = $('.coreft_calendar_date', instance.calendar);
							
							$('.coreft_calendar_date', instance.calendar).hide().fadeIn(500);
							instance._makeResponsive();
						}
					);	
				
				}
			}
			
			
		},
		
		_changeDay : function () {
			var instance = this;
			
			$('.coreft_calendar_nav_daily', instance.calendar).show();
						
			//$('span.actual_month', instance.calendar).html( instance.settings.monthNames[(instance.settings.actualMonth - 1)] + ' ' + instance.settings.actualYear );

			instance._removeElements();
						
			var date_timestamp = Date.UTC(instance.settings.actualYear, (instance.settings.actualMonth - 1), (instance.settings.actualDay)) / 1000;

			$.post(ProEventCalendarAjax.ajaxurl, { 
				date: date_timestamp, 
				calendar: instance.settings.calendar, 
				category: (instance.settings.category != "" ? instance.settings.category : $('select.coreft_categories_list', instance.calendar).val()),
				location: (instance.settings.location != "" ? instance.settings.location : $('select.coreft_location_list', instance.calendar).val()),
				event_id: instance.settings.event_id, 
				author: instance.settings.author, 
				columns: instance.settings.columns, 
				include_all_events: instance.settings.include_all_events,
				hide_old_dates: instance.settings.hide_old_dates,
				is_admin: instance.settings.isAdmin, 
				action: 'getDaily', 
				postEventsNonce : ProEventCalendarAjax.postEventsNonce 
			},
				function(data) {
					var newDate = data.substr(0, data.indexOf(">!]-->")).replace("<!--", "");
					$('span.actual_day', instance.calendar).html( newDate );
					
					$('.coreft_calendar_content', instance.calendar).removeClass( 'coreft_calendar_content_loading' ).empty().html(data);
					$(instance.calendar).removeClass('coreft_calendar_monthly');
					$(instance.calendar).removeClass('coreft_calendar_weekly');
					$(instance.calendar).addClass('coreft_calendar_'+instance.view);

					instance.eventDates = $('.coreft_calendar_date', instance.calendar);
					
					$('.coreft_calendar_date', instance.calendar).hide().fadeIn(500);
					instance._makeResponsive();
				}
			);
			
			
		},
		
		_changeWeek : function () {
			var instance = this;
			
			$('.coreft_calendar_nav_weekly', instance.calendar).show();
						
			//$('span.actual_month', instance.calendar).html( instance.settings.monthNames[(instance.settings.actualMonth - 1)] + ' ' + instance.settings.actualYear );

			instance._removeElements();
						
			var date_timestamp = Date.UTC(instance.settings.actualYear, (instance.settings.actualMonth - 1), (instance.settings.actualDay)) / 1000;

			$.post(ProEventCalendarAjax.ajaxurl, { 
				date: date_timestamp, 
				calendar: instance.settings.calendar, 
				category: (instance.settings.category != "" ? instance.settings.category : $('select.coreft_categories_list', instance.calendar).val()),
				location: (instance.settings.location != "" ? instance.settings.location : $('select.coreft_location_list', instance.calendar).val()),
				event_id: instance.settings.event_id, 
				author: instance.settings.author, 
				include_all_events: instance.settings.include_all_events,
				hide_old_dates: instance.settings.hide_old_dates,
				is_admin: instance.settings.isAdmin, 
				action: 'getWeekly', 
				postEventsNonce : ProEventCalendarAjax.postEventsNonce 
			},
				function(data) {
					var newDate = data.substr(0, data.indexOf(">!]-->")).replace("<!--", "");
					$('span.actual_week', instance.calendar).html( newDate );
					
					$('.coreft_calendar_content', instance.calendar).removeClass( 'coreft_calendar_content_loading' ).empty().html(data);
					$(instance.calendar).removeClass('coreft_calendar_monthly');
					$(instance.calendar).removeClass('coreft_calendar_daily');
					$(instance.calendar).addClass('coreft_calendar_'+instance.view);

					instance.eventDates = $('.coreft_calendar_date', instance.calendar);
					
					$('.coreft_calendar_date', instance.calendar).hide().fadeIn(500);
					instance._makeResponsive();
				}
			);
			
			
		},
		
		_changeLayout : function () {
			var instance = this;
			
			instance._removeElements();
			
			if(instance.settings.type != 'compact') {
				$('.coreft_calendar_nav', instance.calendar).hide();
			}
			
			if(instance.view == "monthly" || instance.view == "monthly-all-events") {
				instance._changeMonth();
			}
			
			if(instance.view == "daily") {
				instance._changeDay();
			}
			
			if(instance.view == "weekly") {
				instance._changeWeek();
			}
			
		},

		_setup_countdown: function (launchDate, currentDate, element, myTZO) {
			var instance = this;
			var seconds_sum = 0;
			setInterval(function(){
				seconds_sum+=1000;

				//var currentTime = new Date(), differenceTime;
				var currentTime = new Date(currentDate.getTime()), differenceTime;
				currentTime_getTime = currentTime.getTime() + seconds_sum;
				//differenceTime = new Date(launchDate.getTime() - currentTime.getTime() + (1000 * 60 * ( myTZO - currentTime.getTimezoneOffset())));
				differenceTime = new Date(launchDate.getTime() - currentTime_getTime );

				//var d = Math.floor(Math.abs((launchDate.getTime() - currentTime.getTime() + (1000 * 60 * ( myTZO - currentTime.getTimezoneOffset()))) / (24*60*60*1000)));
				var d = Math.floor(Math.abs((launchDate.getTime() - currentTime_getTime ) / (24*60*60*1000)));
				var h = differenceTime.getUTCHours();
				var m = differenceTime.getUTCMinutes();
				var s = differenceTime.getUTCSeconds();
				
				if( differenceTime.getTime() < 0 ) {
					d = 0;
					h = 0;
					m = 0;
					s = 0;
				}
				//console.log(differenceTime.getTime());

				$('.coreft_calendar_countdown .coreft_calendar_countdown_days', $(element)).html(instance._str_pad(d, 2, "0", "STR_PAD_LEFT"));
				if(d == 0) {
					$('.coreft_calendar_countdown .coreft_calendar_countdown_days_wrap, .coreft_calendar_countdown .coreft_calendar_countdown_days_wrap *', $(element)).hide();
				}
				if(d == 1) { 
					$('.coreft_calendar_countdown .coreft_calendar_countdown_days_wrap .coreft_calendar_countdown_days_txt', $(element)).text($('.coreft_calendar_countdown .coreft_calendar_countdown_days_wrap .coreft_calendar_countdown_days_txt').data('day'));
				} else {
					$('.coreft_calendar_countdown .coreft_calendar_countdown_days_wrap .coreft_calendar_countdown_days_txt', $(element)).text($('.coreft_calendar_countdown .coreft_calendar_countdown_days_wrap .coreft_calendar_countdown_days_txt').data('days'));
				}

				$('.coreft_calendar_countdown .coreft_calendar_countdown_hours', $(element)).html(instance._str_pad(h, 2, "0", "STR_PAD_LEFT"));

				if(h == 1) { 
					$('.coreft_calendar_countdown .coreft_calendar_countdown_hours_wrap .coreft_calendar_countdown_hours_txt', $(element)).text($('.coreft_calendar_countdown .coreft_calendar_countdown_hours_wrap .coreft_calendar_countdown_hours_txt').data('hour'));
				} else {
					$('.coreft_calendar_countdown .coreft_calendar_countdown_hours_wrap .coreft_calendar_countdown_hours_txt', $(element)).text($('.coreft_calendar_countdown .coreft_calendar_countdown_hours_wrap .coreft_calendar_countdown_hours_txt').data('hours'));
				}

				$('.coreft_calendar_countdown .coreft_calendar_countdown_minutes', $(element)).html(instance._str_pad(m, 2, "0", "STR_PAD_LEFT"));
				$('.coreft_calendar_countdown .coreft_calendar_countdown_seconds', $(element)).html(instance._str_pad(s, 2, "0", "STR_PAD_LEFT"));
				

			},1000);

		},
		
		_str_pad: function (input, pad_length, pad_string, pad_type) {
			
			var half = '',
				pad_to_go;
		 
			var str_pad_repeater = function (s, len) {
				var collect = '',
					i;
		 
				while (collect.length < len) {
					collect += s;
				}
				collect = collect.substr(0, len);
		 
				return collect;
			};
		 
			input += '';
			pad_string = pad_string !== undefined ? pad_string : ' ';
		 
			if (pad_type != 'STR_PAD_LEFT' && pad_type != 'STR_PAD_RIGHT' && pad_type != 'STR_PAD_BOTH') {
				pad_type = 'STR_PAD_RIGHT';
			}
			if ((pad_to_go = pad_length - input.length) > 0) {
				if (pad_type == 'STR_PAD_LEFT') {
					input = str_pad_repeater(pad_string, pad_to_go) + input;
				} else if (pad_type == 'STR_PAD_RIGHT') {
					input = input + str_pad_repeater(pad_string, pad_to_go);
				} else if (pad_type == 'STR_PAD_BOTH') {
					half = str_pad_repeater(pad_string, Math.ceil(pad_to_go / 2));
					input = half + input + half;
					input = input.substr(0, pad_length);
				}
			}
		 
			return input;
		},
		
		// Start dragging
		startDrag:function(e) {
			var instance = this;
			
			if(!instance.isDragging) {					
				var point;
				if(instance.hasTouch) {
					//parsing touch event
					var currTouches = e.originalEvent.touches;
					if(currTouches && currTouches.length > 0) {
						point = currTouches[0];
						instance.fingerCount = currTouches.length;
					}					
					else {	
						return false;						
					}
				} else {
					point = e;		
					
					if (e.target) el = e.target;
					else if (e.srcElement) el = e.srcElement;

					if(el.toString() !== "[object HTMLEmbedElement]" && el.toString() !== "[object HTMLObjectElement]") {	
						e.preventDefault();						
					}
				}

				instance.isDragging = true;
				
				instance.direction = null;
				instance.fingerData = instance.createFingerData();
				
				// check the number of fingers is what we are looking for, or we are capturing pinches
				if (!instance.hasTouch || (instance.fingerCount === instance.settings.fingers || instance.settings.fingers === "all") || instance.hasPinches()) {
					// get the coordinates of the touch
					instance.fingerData[0].start.x = instance.fingerData[0].end.x = point.pageX;
					instance.fingerData[0].start.y = instance.fingerData[0].end.y = point.pageY;
					startTime = instance.getTimeStamp();
					
					if(instance.fingerCount==2) {
						//Keep track of the initial pinch distance, so we can calculate the diff later
						//Store second finger data as start
						instance.fingerData[1].start.x = instance.fingerData[1].end.x = e.originalEvent.touches[1].pageX;
						instance.fingerData[1].start.y = instance.fingerData[1].end.y = e.originalEvent.touches[1].pageY;
						
						//startTouchesDistance = endTouchesDistance = calculateTouchesDistance(fingerData[0].start, fingerData[1].start);
					}
					
					if (instance.settings.swipeStatus || instance.settings.pinchStatus) {
						//ret = triggerHandler(event, phase);
					}
				}
				else {
					//A touch with more or less than the fingers we are looking for, so cancel
					instance.releaseDrag();
					ret = false; // actualy cancel so we dont register event...
				}
				
				if(!$.proCalendar_isVersion('1.7')) {
					$(document).on(instance.moveEvent, function(e) { instance.moveDrag(e); })
						.on(instance.upEvent, function(e) { instance.releaseDrag(e); });
				} else {
					$(document).bind(instance.moveEvent, function(e) { instance.moveDrag(e); })
						.bind(instance.upEvent, function(e) { instance.releaseDrag(e); });
				}
				
				startPos = instance.tx = parseInt(instance.eventDates.css("left"), 10);	
				
				instance.successfullyDragged = false;
				instance.accelerationX = this.tx;
				instance.startTime = (e.timeStamp || new Date().getTime());
				instance.startMouseX = point.clientX;
				instance.startMouseY = point.clientY;
			}
			
			if(instance.hasTouch) {
				$('.coreft_calendar_content', instance.calendar).on(instance.cancelEvent, function(e) { instance.releaseDrag(e); });
			}
			
			return false;	
		},				
		moveDrag:function(e) {	
			var instance = this;
			
			var point;
			if(instance.hasTouch) {	
				if(instance.lockVerticalAxis) {
					return false;
				}	
				
				var touches = e.originalEvent.touches;
				// If touches more then one, so stop sliding and allow browser do default action
				
				if(touches.length > 1) {
					return false;
				}
				
				point = touches[0];	
				
				//e.preventDefault();				
			} else {
				point = e;
				//e.preventDefault();		
			}

			// Helps find last direction of drag move
			instance.lastDragPosition = instance.currentDragPosition;
			var distance = point.clientX - instance.startMouseX;
			if(instance.lastDragPosition != distance) {
				instance.currentDragPosition = distance;
			}

			if(distance != 0)
			{	

				if(instance.settings.dateRangeStart && instance.settings.dateRangeStart.substr(0, 7) == instance.settings.actualYear+"-"+instance._str_pad(instance.settings.actualMonth, 2, "0", 'STR_PAD_LEFT') && !instance.settings.isAdmin) {			
					if(distance > 0) {
						distance = Math.sqrt(distance) * 5;
					}			
				} else if(instance.settings.dateRangeEnd && instance.settings.dateRangeEnd.substr(0, 7) == instance.settings.actualYear+"-"+instance._str_pad(instance.settings.actualMonth, 2, "0", 'STR_PAD_LEFT') && !instance.settings.isAdmin) {		
					if(distance < 0) {
						distance = -Math.sqrt(-distance) * 5;
					}	
				}
				
				$('.coreft_calendar_content', instance.calendar).addClass('isDragging');
				instance.eventDates.css("left", distance);		
				
			}	
			
			var timeStamp = (e.timeStamp || new Date().getTime());
			if (timeStamp - instance.startTime > 350) {
				instance.startTime = timeStamp;
				instance.accelerationX = instance.tx + distance;						
			}
			
			if(!instance.checkedAxis) {
				
				var dir = true,
					diff = (Math.abs(point.pageX - instance.startMouseX) - Math.abs(point.pageY - instance.startMouseY) ) - (dir ? -7 : 7);

				if(diff > 7) {
					// hor movement
					if(dir) {
						e.preventDefault();
						instance.currMoveAxis = 'x';
					} else if(instance.hasTouch) {
						instance.completeGesture();
						return;
					} 
					instance.checkedAxis = true;
				} else if(diff < -7) {
					// ver movement
					if(!dir) {
						e.preventDefault();
						instance.currMoveAxis = 'y';
					} else if(instance.hasTouch) {
						instance.completeGesture();
						return;
					} 
					instance.checkedAxis = true;
				}
				return;
			}
			
			//Save the first finger data
			instance.fingerData[0].end.x = instance.hasTouch ? point.pageX : e.pageX;
			instance.fingerData[0].end.y = instance.hasTouch ? point.pageY : e.pageY;
			
			instance.direction = instance.calculateDirection(instance.fingerData[0].start, instance.fingerData[0].end);
			
			instance.validateDefaultEvent(instance.direction);
			
			return false;		
		},
		completeGesture: function() {
			var instance = this;
			instance.lockVerticalAxis = true;
			instance.releaseDrag();
		},
		releaseDrag:function(e) {
			var instance = this;
			
			if(instance.isDragging) {	
				var self = this;
				instance.isDragging = false;			
				instance.lockVerticalAxis = false;
				instance.checkedAxis = false;	
				$('.coreft_calendar_content', instance.calendar).removeClass('isDragging');
				
				var endPos = parseInt(instance.eventDates.css('left'), 10);

				$(document).unbind(instance.moveEvent).unbind(instance.upEvent);					

				if(endPos == instance._startPos) {						
					instance.successfullyDragged = false;
					return;
				} else {
					instance.successfullyDragged = true;
				}
				
				var dist = (instance.accelerationX - endPos);		
				var duration =  Math.max(40, (e.timeStamp || new Date().getTime()) - instance.startTime);
				// For nav speed calculation F=ma :)
				/*
				var v0 = Math.abs(dist) / duration;	
				
				
				var newDist = instance.eventDates.width() - Math.abs(startPos - endPos);
				var newDuration = Math.max((newDist * 1.08) / v0, 200);
				newDuration = Math.min(newDuration, 600);
				*/
				function returnToCurrent() {						
					/*
					newDist = Math.abs(startPos - endPos);
					newDuration = Math.max((newDist * 1.08) / v0, 200);
					newDuration = Math.min(newDuration, 500);
					*/

					$(instance.eventDates).animate(
						{'left': 0}, 
						'fast'
					);
				}
				
				// calculate move direction
				if((startPos - instance.settings.dragOffset) > endPos) {		

					if(instance.lastDragPosition < instance.currentDragPosition) {	
						returnToCurrent();
						return false;					
					}
					
					if(!(instance.settings.dateRangeEnd && instance.settings.dateRangeEnd.substr(0, 7) == instance.settings.actualYear+"-"+instance._str_pad(instance.settings.actualMonth, 2, "0", 'STR_PAD_LEFT') && !instance.settings.isAdmin)) {
						if(instance.view == "monthly") {
							instance._nextMonth(instance);
						} else {
							instance._nextDay(instance);
						}
					} else {
						returnToCurrent();
					}
					
				} else if((startPos + instance.settings.dragOffset) < endPos) {	

					if(instance.lastDragPosition > instance.currentDragPosition) {
						returnToCurrent();
						return false;
					}
					
					if(!(instance.settings.dateRangeStart && instance.settings.dateRangeStart.substr(0, 7) == instance.settings.actualYear+"-"+instance._str_pad(instance.settings.actualMonth, 2, "0", 'STR_PAD_LEFT') && !instance.settings.isAdmin)) {
						if(instance.view == "monthly") {
							instance._prevMonth(instance);
						} else {
							instance._prevDay(instance);
						}
						
					} else {
						returnToCurrent();
					}

				} else {
					returnToCurrent();
				}
			}

			return false;
		},
		
		/**
		* Checks direction of the swipe and the value allowPageScroll to see if we should allow or prevent the default behaviour from occurring.
		* This will essentially allow page scrolling or not when the user is swiping on a touchSwipe object.
		*/
		validateDefaultEvent : function(direction) {
			if (this.settings.allowPageScroll === "none" || this.hasPinches()) {
				e.preventDefault();
			} else {
				var auto = this.settings.allowPageScroll === true;

				switch (direction) {
					case "left":
						if ((true && auto) || (!auto && this.settings.allowPageScroll != "horizontal")) {
							event.preventDefault();
						}
						break;

					case "right":
						if ((true && auto) || (!auto && this.settings.allowPageScroll != "horizontal")) {
							event.preventDefault();
						}
						break;

					case "up":
						if ((false && auto) || (!auto && this.settings.allowPageScroll != "vertical")) {
							e.preventDefault();
						}
						break;

					case "down":
						if ((false && auto) || (!auto && this.settings.allowPageScroll != "vertical")) {
							e.preventDefault();
						}
						break;
				}
			}

		},
		
		/**
		 * Returns true if any Pinch events have been registered
		 */
		hasPinches : function() {
			return this.settings.pinchStatus || this.settings.pinchIn || this.settings.pinchOut;
		},
		
		createFingerData : function() {
			var fingerData=[];
			for (var i=0; i<=5; i++) {
				fingerData.push({
					start:{ x: 0, y: 0 },
					end:{ x: 0, y: 0 },
					delta:{ x: 0, y: 0 }
				});
			}
			
			return fingerData;
		},
		
		/**
		* Calcualte the angle of the swipe
		* @param finger A finger object containing start and end points
		*/
		caluculateAngle : function(startPoint, endPoint) {
			var x = startPoint.x - endPoint.x;
			var y = endPoint.y - startPoint.y;
			var r = Math.atan2(y, x); //radians
			var angle = Math.round(r * 180 / Math.PI); //degrees

			//ensure value is positive
			if (angle < 0) {
				angle = 360 - Math.abs(angle);
			}

			return angle;
		},
		
		/**
		* Calcualte the direction of the swipe
		* This will also call caluculateAngle to get the latest angle of swipe
		* @param finger A finger object containing start and end points
		*/
		calculateDirection : function(startPoint, endPoint ) {
			var angle = this.caluculateAngle(startPoint, endPoint);

			if ((angle <= 45) && (angle >= 0)) {
				return "left";
			} else if ((angle <= 360) && (angle >= 315)) {
				return "left";
			} else if ((angle >= 135) && (angle <= 225)) {
				return "right";
			} else if ((angle > 45) && (angle < 135)) {
				return "down";
			} else {
				return "up";
			}
		},
		
		/**
		* Returns a MS time stamp of the current time
		*/
		getTimeStamp : function() {
			var now = new Date();
			return now.getTime();
		}
	}
	
	$.fn.coreftCalendar = function(options){

		var coreftCalendar;
		this.each(function(){
			
			coreftCalendar = new CoreftCalendar($(this), options);
			
			$(this).data("coreftCalendar", coreftCalendar);
			
		});
		
		return this;

	}
	
  	/* Default Parameters and Events */
	$.fn.coreftCalendar.defaults = {
		monthNames : new Array('January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'),
		actualMonth : '',
		actualYear : '',
		actualDay : '',
		defaultDate : '',
		lang_sending: 'Sending...',
		skin : 'light',
		view: 'monthly',
		type: 'calendar',
		limit: '',
		widget: 0,
		selectric: true,
		lockVertical: true,
		include_all_events: false,
		hide_old_dates: 0,
		calendar: null,
		show_current_date: true,
		dateRangeStart: null,
		dateRangeEnd: null,
		draggable: true,
		isAdmin: false,
		dragOffset: 50,
		recaptcha_enable : false,
		allowPageScroll: "vertical",
		fingers: 1
	};  
	
	$.fn.coreftCalendar.settings = {}
	
})(jQuery);

/* onShowProCalendar custom event */
 (function($){
  $.fn.extend({ 
    onShowProCalendar: function(callback, unbind){
      return this.each(function(){
        var obj = this;
        var bindopt = (unbind==undefined)?true:unbind; 
        if($.isFunction(callback)){
          if($(this).is(':hidden')){
            var checkVis = function(){
              if($(obj).is(':visible')){
                callback.call();
                if(bindopt){
                  $('body').unbind('click keyup keydown', checkVis);
                }
              }                         
            }
            $('body').bind('click keyup keydown', checkVis);
          }
          else{
            callback.call();
          }
        }
      });
    }
  });
})(jQuery);

(function($) {
/**
 * Used for version test cases.
 *
 * @param {string} left A string containing the version that will become
 *        the left hand operand.
 * @param {string} oper The comparison operator to test against. By
 *        default, the "==" operator will be used.
 * @param {string} right A string containing the version that will
 *        become the right hand operand. By default, the current jQuery
 *        version will be used.
 *
 * @return {boolean} Returns the evaluation of the expression, either
 *         true or false.
 */
	$.proCalendar_isVersion = function(version1, version2){
		if ('undefined' === typeof version1) {
		  throw new Error("$.versioncompare needs at least one parameter.");
		}
		version2 = version2 || $.fn.jquery;
		if (version1 == version2) {
		  return 0;
		}
		var v1 = normalize(version1);
		var v2 = normalize(version2);
		var len = Math.max(v1.length, v2.length);
		for (var i = 0; i < len; i++) {
		  v1[i] = v1[i] || 0;
		  v2[i] = v2[i] || 0;
		  if (v1[i] == v2[i]) {
			continue;
		  }
		  return v1[i] > v2[i] ? 1 : 0;
		}
		return 0;
	};
	function normalize(version){
	return $.map(version.split('.'), function(value){
	  return parseInt(value, 10);
	});

	}
	
	$(document).ready(function() {
	
		if(!$('.coreftCalendarOverlay').length) {
	
			$('body').append(
				$('<div>').addClass('coreftCalendarOverlay').click(function() {
					$('.coreftCalendarModalEditEvent, .coreftCalendarModal, .coreftCalendarOverlay').fadeOut('fast');

					$('body, html').css('overflow', '');
				})
			);
	
		}

		$(document).on('click', '.coreft_event_page_book', function(e) {
			
			if($(window).width() > 720) {
				$('body, html').css('overflow', 'hidden');
			}

			//var $cloned = $(this).next().clone(true);
			
			if($('.coreftCalendarModal').length) {
				$('.coreftCalendarModal').remove()
			}

			if(!$('.coreftCalendarModal').length) {
				$('body').append(
					$('<div>').addClass('coreftCalendarModal').prepend(
						$('<h2>').text($(this).find('strong').text()).append(
							$('<a>').addClass('coreftCalendarClose').attr({ 'href': '#' }).html('<i class="fa fa-times"></i>')
						)
					).show()
				);
				
				$('.coreftCalendarOverlay').show();
				
				//dpShareLoadEvents();
			}
			
			$('.coreftCalendarModal').show();
			
			if($(window).width() < 720) {
				$('.coreftCalendarModal').attr('style', 'display:block; position: absolute !important; top: '+($(window).scrollTop() + 20)+'px;');
			}

			$('.coreftCalendarModal').addClass('coreftCalendarModal_Preload');
			
			
			$.post(ProEventCalendarAjax.ajaxurl, 
				{ 
					event_id: $(this).data('event-id'),
					calendar: $(this).data('calendar'),
					date: $(this).data('date'),
					action: 'getBookEventForm', 
					postEventsNonce : ProEventCalendarAjax.postEventsNonce 
				},
				function(data) {
					
					$('.coreftCalendarModal').removeClass('coreftCalendarModal_Preload').append(data);
					
					$('select', '.coreftCalendarModal').selectric();

					$('#coreft_event_page_book_date', '.coreftCalendarModal').trigger('change');

					$("input, textarea", '.coreftCalendarModal').placeholder();
				}
			);	

			return false;

		});
		
		$(document).on('click', '.coreftCalendarClose, .coreft_calendar_close', function(e) {
			e.preventDefault();
			$('.coreftCalendarModalEditEvent, .coreftCalendarModal, .coreftCalendarOverlay').fadeOut('fast');
			$('body, html').css('overflow', '');
		});
		
		$(document).on('change', '#coreft_event_page_book_date', function(e) {
			
			jQuery('#coreft_event_page_book_quantity option').removeAttr('disabled');

			$('#coreft_event_page_book_quantity', '.coreftCalendarModal').val(1).change();
			$('#coreft_event_page_book_quantity', '.coreftCalendarModal').selectric('refresh');

			if(this.value == 0) { 
				jQuery('.coreft_event_page_send_booking').prop('disabled', true);
			} else { 
				jQuery('.coreft_event_page_send_booking').prop('disabled', false);
	
				$('#coreft_event_page_book_quantity option:gt('+(jQuery(this).find(':selected').data('available') - 1)+')', '.coreftCalendarModal').attr('disabled', 'disabled');

				$('#coreft_event_page_book_quantity', '.coreftCalendarModal').selectric('refresh');

			}

		});

		$(document).on('change', '#coreft_event_page_book_quantity', function(e) {
			
			if($('.coreft_calendar_payment_price').length) {
				var new_price = ($('.coreft_calendar_payment_price').find('span.coreft_calendar_payment_price_value').data('price') * $(this).val()).toFixed(2);
				$('.coreft_calendar_payment_price').find('span.coreft_calendar_payment_price_value').text( new_price );
				$('.coreft_calendar_payment_price').find('span.coreft_calendar_payment_price_value').data( 'price-updated', new_price );

				if($('#coreft_payment_discount_value', '.coreftCalendarModal').length) {
					var coupon_value = $('#coreft_payment_discount_value', '.coreftCalendarModal').val();
					if(coupon_value != "") {

						var result = ((100 - coupon_value) / 100) * new_price;

						$('.coreft_calendar_payment_price', '.coreftCalendarModal').find('span.coreft_calendar_payment_price_value').text(
							result.toFixed(2)
						);

					}
				}
			}

		});

		$(document).on('submit', '.coreft_calendar_coupon_form', function() {
			
			if($(this).find('.coreft_calendar_coupon').val() != "") {

				var coupon_inp = $(this).find('.coreft_calendar_coupon');
				
				coupon_inp.removeClass('coreft_calendar_validation_error');
				if(coupon_inp.hasClass('coreft_calendar_validation_correct')) {
					return false;
				}

				$.post(ProEventCalendarAjax.ajaxurl, { 
					code: $(this).find('.coreft_calendar_coupon').val(),
					action: 'getCoupon', 
					postEventsNonce : ProEventCalendarAjax.postEventsNonce 
				},
					function(data) {
						//coupon_inp.val("");
						if(data == "null") {

							coupon_inp.addClass('coreft_calendar_validation_error');

						} else {

							data = jQuery.parseJSON(data);

							if($('.coreft_calendar_payment_price', '.coreftCalendarModal').length) {
								var result = ((100 - data.discount) / 100) * $('.coreft_calendar_payment_price', '.coreftCalendarModal').find('span.coreft_calendar_payment_price_value').data('price-updated');

								$('.coreft_calendar_payment_price', '.coreftCalendarModal').find('span.coreft_calendar_payment_price_value').text(
									result.toFixed(2)
								);

								$('#coreft_payment_discount_id', '.coreftCalendarModal').val(data.id);
								$('#coreft_payment_discount_coupon', '.coreftCalendarModal').val(data.coupon);
								$('#coreft_payment_discount_value', '.coreftCalendarModal').val(data.discount);

								coupon_inp.addClass('coreft_calendar_validation_correct');
								coupon_inp.closest('.coreft_calendar_coupon_form').addClass('coreft_calendar_validation_form_correct');
								coupon_inp.prop("readonly", true);
							}
						}
					}
				);	
			}
			return false;
		});

		$(document).on('keyup', '.coreft_calendar_coupon', function (e) {

			if (e.keyCode == 13) {
				// Do something
				$('.coreft_calendar_coupon_go', '.coreftCalendarModal').trigger('click');
			}
		});

		if($('.coreft_event_page_action_menu').length) {
			$(document).on('touchstart click', function(e) {

				$('.coreft_event_page_action_menu').each(function(e) {

					var $parent = $(this).parent();

					if($(this).is(':visible') && !$(this).is(':animated')) {
						$('.coreft_event_page_action', $parent).trigger('click');
					}	
				})
				
			});
		}

		$(document).on('click', '.coreft_event_page_action', function(e) {
			e.preventDefault();
			var $parent = $(this).parent();
			if(!$(this).hasClass('active')) {
				$(this).addClass('active');
				$('.coreft_event_page_action_menu', $parent).slideDown('fast');

			} else {
				$(this).removeClass('active');
				$('.coreft_event_page_action_menu', $parent).slideUp('fast');
			}
			
		});

		$(document).on('click', '.coreft_edit_event', function(e) {
					
			$('body, html').css('overflow', 'hidden');

			var $btn = $(this);

			if(!$('.coreftCalendarModalEditEvent').length) {
		
				$('body').append(
					$('<div>').addClass('coreftCalendarModalEditEvent coreft_calendar_new_event_wrapper').prepend(
						$('<h2>').text($btn.attr('title')).append(
							$('<a>').addClass('coreftCalendarClose').attr({ 'href': '#' }).html('<i class="fa fa-times"></i>')
						)
					).append(
						$('<div>').addClass('coreftCalendar_eventform coreft_calendar_content_loading')
					).show()
				);
				
				$('.coreftCalendarOverlay').show();
				
				//$('.coreftCalendar_eventform').html($('.coreftCalendar_eventform').html().replace(/_pecremoveedit/g, ''));
				
			} else {
				$('.coreftCalendar_eventform').empty().addClass('coreft_calendar_content_loading');
				$('.coreftCalendarModalEditEvent').removeClass('coreftCalendarModalSmall');
				$('.coreftCalendarModalEditEvent h2').text($btn.attr('title')).append(
					$('<a>').addClass('coreftCalendarClose').attr({ 'href': '#' }).html('<i class="fa fa-times"></i>')
				);
				$('.coreftCalendarModalEditEvent, .coreftCalendarOverlay').show();
			}
	
			$('.coreftCalendarModalEditEvent').on('change', '.event_image', function()
			{
				$('#event_image_lbl', $(this).parent()).val($(this).val().replace(/^.*[\\\/]/, ''));
			});

			$.post(ProEventCalendarAjax.ajaxurl, 
				{ 
					event_id: $btn.data('event-id'),
					/*calendar: instance.settings.calendar,*/
					action: 'getEditEventForm', 
					postEventsNonce : ProEventCalendarAjax.postEventsNonce 
				},
				function(data) {
					
					$('.coreftCalendar_eventform').removeClass('coreft_calendar_content_loading').empty().html(data);
					
					var editor_id = $('.coreftCalendar_eventform #coreft_edit_form_editor_id').val();
					
		            //init tinymce
		            if(typeof tinyMCE != "undefined") {
			            tinymce.init(
			            	{ 
			            		selector: editor_id, 
			            		toolbar: "bold italic underline blockquote strikethrough | bullist numlist | alignleft aligncenter alignright | undo redo | link unlink | fullscreen"
			            	}
			            ); 
			            tinyMCE.execCommand('mceAddEditor', false, editor_id);
    				}

    				if(ProEventCalendarAjax.recaptcha_enable && ProEventCalendarAjax.recaptcha_site_key != "") {

						coreft_new_event_captcha = grecaptcha.render($('#coreft_new_event_captcha', '.coreftCalendar_eventform')[0], {
						  'sitekey' : ProEventCalendarAjax.recaptcha_site_key
						});
					}
		            //tinymce.init(tinyMCEPreInit.mceInit[editor_id]);

		            var el = '.coreftCalendarModalEditEvent';
					$(el).on('click', '.coreft_calendar_submit_event', function(e) {
						e.preventDefault();
						if(typeof tinyMCE != "undefined") {
							tinyMCE.triggerSave();
						}

						//var form = $(this).closest(".add_new_event_form");
						
						var origName = $(this).html();
						
						var me = this;
						var form = $(this).closest('form');
						var post_obj = {
							action: 'submitEvent',
							postEventsNonce : ProEventCalendarAjax.postEventsNonce
						}
						
						var is_valid = true;
						$('.coreft_required', form).each(function() {
							
							$(this).removeClass('coreft_calendar_validation_error');

							if($(this).is(':checkbox')) {
								if($(this).is( ":checked" ) == false) {
									
									$(this).addClass('coreft_calendar_validation_error');
									
									is_valid = false;
									return;
								}
							} else {
								if($(this).val() == "") {
									
									$(this).addClass('coreft_calendar_validation_error');
									
									is_valid = false;
									return;
								}
							}

						});

						if(!is_valid) {
							return false;
						}

						if(ProEventCalendarAjax.recaptcha_enable && ProEventCalendarAjax.recaptcha_site_key != "") {
							post_obj.grecaptcharesponse = grecaptcha.getResponse(coreft_new_event_captcha);
							if(post_obj.grecaptcharesponse == "") {
								return false;
							}
						}

						$(this).addClass('coreft_calendar_disabled');

						$(this).html($(this).data('lang-sending'));	
	
						$(this).closest(".add_new_event_form").ajaxForm({
							url: ProEventCalendarAjax.ajaxurl,
							data: post_obj,
							success:function(data){
								$(me).html(origName);
								if(!form.hasClass('edit_event_form')) {
									$(form)[0].reset();
								} else {
									location.reload();	
								}
								$('.coreft_calendar_form_title', form).removeClass('coreft_calendar_validation_error');
								$(me).removeClass('coreft_calendar_disabled');
								$('.coreft_calendar_notification_event_succesfull', form.parent()).show();

							}
						}).submit();
					});		

					$('.coreftCalendarModalEditEvent select').selectric();
					$('.coreftCalendarModalEditEvent input.checkbox').iCheck({
						checkboxClass: 'icheckbox_flat',
						radioClass: 'iradio_flat',
						increaseArea: '20%' // optional
					});

				}
			);	
			return false;
			
		});
		
		$(document).on('change', '.coreftCalendarModalEditEvent select.coreft_location_form', function() {
				
			jQuery('.coreft_location_options', '.coreftCalendarModalEditEvent').hide();
			
			switch($(this).val()) {
				case "-1":
					jQuery(".coreft_location_options", '.coreftCalendarModalEditEvent').show();
					break;	
			}
			
		});

		$(document).on('click', '.coreftCalendarModalEditEvent .coreft_calendar_clear_end_date', function(e) {
			e.preventDefault();
			$('.coreft_calendar_end_date_input_modal', '.coreftCalendarModalEditEvent').val('');
		});

		$(document).on('change', '.coreftCalendarModalEditEvent select.coreft_recurring_frequency', function() {
				
			jQuery('.coreft_daily_frequency', '.coreftCalendarModalEditEvent').hide();
			jQuery('.coreft_weekly_frequency', '.coreftCalendarModalEditEvent').hide();
			jQuery('.coreft_monthly_frequency', '.coreftCalendarModalEditEvent').hide();
			
			switch($(this).val()) {
				case "1":
					jQuery(".coreft_daily_frequency", '.coreftCalendarModalEditEvent').show();
					jQuery(".coreft_weekly_frequency", '.coreftCalendarModalEditEvent').hide();
					jQuery(".coreft_monthly_frequency", '.coreftCalendarModalEditEvent').hide();
					break;	
				case "2":
					jQuery(".coreft_daily_frequency", '.coreftCalendarModalEditEvent').hide();
					jQuery(".coreft_weekly_frequency", '.coreftCalendarModalEditEvent').show();
					jQuery(".coreft_monthly_frequency", '.coreftCalendarModalEditEvent').hide();
					break;	
				case "3":
					jQuery(".coreft_daily_frequency", '.coreftCalendarModalEditEvent').hide();
					jQuery(".coreft_weekly_frequency", '.coreftCalendarModalEditEvent').hide();
					jQuery(".coreft_monthly_frequency", '.coreftCalendarModalEditEvent').show();
					break;	
				case "4":
					jQuery(".coreft_daily_frequency", '.coreftCalendarModalEditEvent').hide();
					jQuery(".coreft_weekly_frequency", '.coreftCalendarModalEditEvent').hide();
					jQuery(".coreft_monthly_frequency", '.coreftCalendarModalEditEvent').hide();
					break;	
			}
			
		});

		$(document).on('click', '.coreft_event_page_send_booking', function(e) {
			var instance = this;

			if($('#coreft_event_page_book_name', '.coreftCalendarModal').length) {
				
				$('#coreft_event_page_book_name, #coreft_event_page_book_email', '.coreftCalendarModal').removeClass('coreft_calendar_validation_error');
				
				if($('#coreft_event_page_book_name', '.coreftCalendarModal').val() == '') {
					$('#coreft_event_page_book_name', '.coreftCalendarModal').addClass('coreft_calendar_validation_error');
					
					return false;
				}
				
				var re = /^([\w-]+(?:\.[\w-]+)*)@((?:[\w-]+\.)*\w[\w-]{0,66})\.([a-z]{2,6}(?:\.[a-z]{2})?)$/i;

				if($('#coreft_event_page_book_email', '.coreftCalendarModal').val() == '' || !re.test($('#coreft_event_page_book_email', '.coreftCalendarModal').val())) {
					$('#coreft_event_page_book_email', '.coreftCalendarModal').addClass('coreft_calendar_validation_error');
					
					return false;
				}
				
			}
			
			if($('#coreft_event_page_book_phone', '.coreftCalendarModal').length) {
				
				$('#coreft_event_page_book_phone', '.coreftCalendarModal').removeClass('coreft_calendar_validation_error');
				
				if($('#coreft_event_page_book_phone', '.coreftCalendarModal').val() == '') {
					$('#coreft_event_page_book_phone', '.coreftCalendarModal').addClass('coreft_calendar_validation_error');
					
					return false;
				}
				
			}

			var is_valid = true;
			
			$('.coreft_required', '.coreftCalendarModal').each(function() {
				
				$(this).removeClass('coreft_calendar_validation_error');

				if($(this).is(':checkbox')) {

					$(this).closest('.coreft_calendar_wrap_checkbox').removeClass('coreft_calendar_validation_error');
					
					if($(this).is( ":checked" ) == false) {
						
						$(this).closest('.coreft_calendar_wrap_checkbox').addClass('coreft_calendar_validation_error');

						is_valid = false;
						return;
					}
				} else {
					if($(this).val() == "") {

						$(this).addClass('coreft_calendar_validation_error');
						
						is_valid = false;
						return;
					}
				}

			});

			if(!is_valid) {
				return false;
			}
			
			if($('#coreft_event_page_book_terms_conditions', '.coreftCalendarModal').length) {
				
				if($('#coreft_event_page_book_terms_conditions', '.coreftCalendarModal').is( ":checked" ) == false) {

					$('#coreft_event_page_book_terms_conditions', '.coreftCalendarModal').focus();
					
					return false;
				}

			}

			var extra_fields = {};
			if($('.coreft_event_page_book_extra_fields', '.coreftCalendarModal').length) {

				$('.coreft_event_page_book_extra_fields', '.coreftCalendarModal').each(function( index ) {
				  
				  if($(this).attr('type') == 'checkbox') {
				  	if($(this).is(':checked')) {
				  		extra_fields[$(this).attr('name')] = 1;
				    }
				  } else {
					  extra_fields[$(this).attr('name')] = $(this).val();
				  }
				});

			}
			var $btn_booking = $(this);
			$btn_booking.prop('disabled', true);
			$btn_booking.css('opacity', .6);
			var event_id = $('#coreft_event_page_book_event_id', '.coreftCalendarModal').val();
			var quantity = $('#coreft_event_page_book_quantity', '.coreftCalendarModal').val();
			$.post(ProEventCalendarAjax.ajaxurl, 
				{ 
					event_date: $('#coreft_event_page_book_date', '.coreftCalendarModal').val(),
					ticket: $('#coreft_event_page_book_ticket', '.coreftCalendarModal').val(),
					event_id: event_id, 
					calendar: $('#coreft_event_page_book_calendar', '.coreftCalendarModal').val(),
					comment: $('#coreft_event_page_book_comment', '.coreftCalendarModal').val(),
					quantity: quantity, 
					name: ($('#coreft_event_page_book_name', '.coreftCalendarModal').length ? $('#coreft_event_page_book_name', '.coreftCalendarModal').val() : ''),
					email: ($('#coreft_event_page_book_email', '.coreftCalendarModal').length ? $('#coreft_event_page_book_email', '.coreftCalendarModal').val() : ''),
					phone: ($('#coreft_event_page_book_phone', '.coreftCalendarModal').length ? $('#coreft_event_page_book_phone', '.coreftCalendarModal').val() : ''),
					coreft_payment_discount_id: ($('#coreft_payment_discount_id', '.coreftCalendarModal').length ? $('#coreft_payment_discount_id', '.coreftCalendarModal').val() : ''),
					coreft_payment_discount_coupon: ($('#coreft_payment_discount_coupon', '.coreftCalendarModal').length ? $('#coreft_payment_discount_coupon', '.coreftCalendarModal').val() : ''),
					extra_fields: extra_fields,
					return_url: window.location.href,
					action: 'bookEvent', 
					postEventsNonce : ProEventCalendarAjax.postEventsNonce 
				},
				function(data) {
					data = jQuery.parseJSON(data);
					
					$('#coreft_event_page_book_comment', '.coreftCalendarModal').val('');
					$btn_booking.prop('disabled', false);	
					$btn_booking.css('opacity', 1);
					
					if(data.gateway_screen != "") {
						
						$('.coreft_book_select_date', '.coreftCalendarModal').html(data.gateway_screen);
						
						$('.coreft_gateway_form select', '.coreftCalendarModal').selectric();
						
					} else {

						$('.coreft_book_select_date', '.coreftCalendarModal').html(data.notification);
						//$('.coreft_calendar_attendees_counter_'+ event_id +' span', instance.calendar).text( parseInt($('.coreft_calendar_attendees_counter_'+ event_id +' span', instance.calendar).text(), 10) + parseInt(quantity, 10) );
					}
				}
			);	
			
		});
		
	});
})(jQuery);