<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly
// This function displays the admin page content
function coreftCalendar_calendars_page() {
	global $coreftCalendar, $coreftCalendar_cache, $wpdb, $table_prefix;
	$table_name                        = $table_prefix . COREFT_CALENDAR_TABLE_CALENDARS;
	$table_name_events                 = $table_prefix . COREFT_CALENDAR_TABLE_EVENTS;
	$table_name_special_dates_calendar = $table_prefix . COREFT_CALENDAR_TABLE_SPECIAL_DATES_CALENDAR;
	$table_name_subscribers_calendar   = $table_prefix . COREFT_CALENDAR_TABLE_SUBSCRIBERS_CALENDAR;

	$max_upload   = (int) ( ini_get( 'upload_max_filesize' ) );
	$max_post     = (int) ( ini_get( 'post_max_size' ) );
	$memory_limit = (int) ( ini_get( 'memory_limit' ) );
	$upload_mb    = min( $max_upload, $max_post, $memory_limit );

	if ( (isset($_GET['add']) && $_GET['add'] == 1) || isset( $_POST['submit'] ) && $_POST['submit'] ) {
	    $postData = coreftSanitizeData($_POST);
		foreach ( $postData as $key => $value ) {
			$$key = $value;
		}

		if ( ! isset( $format_ampm ) || $format_ampm != 1 ) {
			$format_ampm = 0;
		}
		if ( ! isset( $show_time ) || $show_time != 1 ) {
			$show_time = 0;
		}
		if ( ! isset( $show_timezone ) || $show_timezone != 1 ) {
			$show_timezone = 0;
		}
		if ( ! isset( $show_search ) || $show_search != 1 ) {
			$show_search = 0;
		}
		if ( ! isset( $show_category_filter ) || $show_category_filter != 1 ) {
			$show_category_filter = 0;
		}
		if ( ! isset( $show_location_filter ) || $show_location_filter != 1 ) {
			$show_location_filter = 0;
		}
		if ( ! isset( $show_x ) || $show_x != 1 ) {
			$show_x = 0;
		}
		if ( ! isset( $allow_user_add_event ) || $allow_user_add_event != 1 ) {
			$allow_user_add_event = 0;
		}
		if ( ! isset( $allow_user_edit_event ) || $allow_user_edit_event != 1 ) {
			$allow_user_edit_event = 0;
		}
		if ( ! isset( $allow_user_remove_event ) || $allow_user_remove_event != 1 ) {
			$allow_user_remove_event = 0;
		}
		if ( ! isset( $publish_new_event ) || $publish_new_event != 1 ) {
			$publish_new_event = 0;
		}
		if ( ! isset( $new_event_email_enable ) || $new_event_email_enable != 1 ) {
			$new_event_email_enable = 0;
		}
		if ( ! isset( $booking_cancel_email_enable ) || $booking_cancel_email_enable != 1 ) {
			$booking_cancel_email_enable = 0;
		}
		if ( ! isset( $show_view_buttons ) || $show_view_buttons != 1 ) {
			$show_view_buttons = 0;
		}
		if ( ! isset( $show_preview ) || $show_preview != 1 ) {
			$show_preview = 0;
		}
		if ( ! isset( $show_titles_monthly ) || $show_titles_monthly != 1 ) {
			$show_titles_monthly = 0;
		}
		if ( ! isset( $show_references ) || $show_references != 1 ) {
			$show_references = 0;
		}
		if ( ! isset( $show_author ) || $show_author != 1 ) {
			$show_author = 0;
		}
		if ( ! isset( $cache_active ) || $cache_active != 1 ) {
			$cache_active = 0;
		}
		if ( ! isset( $ical_active ) || $ical_active != 1 ) {
			$ical_active = 0;
		}
		if ( ! isset( $rss_active ) || $rss_active != 1 ) {
			$rss_active = 0;
		}
		if ( ! isset( $subscribe_active ) || $subscribe_active != 1 ) {
			$subscribe_active = 0;
		}
		if ( ! isset( $link_post ) || $link_post != 1 ) {
			$link_post = 0;
		}
		if ( ! isset( $email_admin_new_event ) || $email_admin_new_event != 1 ) {
			$email_admin_new_event = 0;
		}
		if ( ! isset( $article_share ) || $article_share != 1 ) {
			$article_share = 0;
		}
		if ( ! isset( $hide_old_dates ) || $hide_old_dates != 1 ) {
			$hide_old_dates = 0;
		}
		if ( ! isset( $limit_time_start ) || ! is_numeric( $limit_time_start ) ) {
			$limit_time_start = 0;
		}
		if ( ! isset( $limit_time_end ) || ! is_numeric( $limit_time_end ) ) {
			$limit_time_end = 23;
		}
		if ( ! isset( $booking_max_quantity ) || ! is_numeric( $booking_max_quantity ) || $booking_max_quantity <= 0 ) {
			$booking_max_quantity = 3;
		}
		if ( ! isset( $booking_max_upcoming_dates ) || ! is_numeric( $booking_max_upcoming_dates ) || $booking_max_upcoming_dates <= 0 ) {
			$booking_max_upcoming_dates = 10;
		}
		if ( ! isset( $assign_events_admin ) || $assign_events_admin == "" ) {
			$assign_events_admin = 0;
		}
		if ( ! isset( $form_show_end_date ) || $form_show_end_date != 1 ) {
			$form_show_end_date = 0;
		}
		if ( ! isset( $form_show_start_time ) || $form_show_start_time != 1 ) {
			$form_show_start_time = 0;
		}
		if ( ! isset( $form_show_end_time ) || $form_show_end_time != 1 ) {
			$form_show_end_time = 0;
		}
		if ( ! isset( $form_show_extra_dates ) || $form_show_extra_dates != 1 ) {
			$form_show_extra_dates = 0;
		}
		if ( ! isset( $form_show_description ) || $form_show_description != 1 ) {
			$form_show_description = 0;
		}
		if ( ! isset( $form_show_category ) || $form_show_category != 1 ) {
			$form_show_category = 0;
		}
		if ( ! isset( $form_show_hide_time ) || $form_show_hide_time != 1 ) {
			$form_show_hide_time = 0;
		}
		if ( ! isset( $form_show_frequency ) || $form_show_frequency != 1 ) {
			$form_show_frequency = 0;
		}
		if ( ! isset( $form_show_all_day ) || $form_show_all_day != 1 ) {
			$form_show_all_day = 0;
		}
		if ( ! isset( $form_show_image ) || $form_show_image != 1 ) {
			$form_show_image = 0;
		}
		if ( ! isset( $form_show_link ) || $form_show_link != 1 ) {
			$form_show_link = 0;
		}
		if ( ! isset( $form_show_location ) || $form_show_location != 1 ) {
			$form_show_location = 0;
		}
		if ( ! isset( $form_show_location_options ) || $form_show_location_options != 1 ) {
			$form_show_location_options = 0;
		}
		if ( ! isset( $form_show_phone ) || $form_show_phone != 1 ) {
			$form_show_phone = 0;
		}
		if ( ! isset( $form_show_map ) || $form_show_map != 1 ) {
			$form_show_map = 0;
		}
		if ( ! isset( $form_show_color ) || $form_show_color != 1 ) {
			$form_show_color = 0;
		}
		if ( ! isset( $form_show_timezone ) || $form_show_timezone != 1 ) {
			$form_show_timezone = 0;
		}
		if ( ! isset( $booking_enable ) || $booking_enable != 1 ) {
			$booking_enable = 0;
		}
		if ( ! isset( $booking_comment ) || $booking_comment != 1 ) {
			$booking_comment = 0;
		}
		if ( ! isset( $booking_non_logged ) || $booking_non_logged != 1 ) {
			$booking_non_logged = 0;
		}
		if ( ! isset( $booking_cancel ) || $booking_cancel != 1 ) {
			$booking_cancel = 0;
		}
		if ( ! isset( $enable_wpml ) || $enable_wpml != 1 ) {
			$enable_wpml = 0;
		}
		if ( ! isset( $booking_display_attendees ) || $booking_display_attendees != 1 ) {
			$booking_display_attendees = 0;
		}
		if ( ! isset( $booking_display_attendees_names ) || $booking_display_attendees_names != 1 ) {
			$booking_display_attendees_names = 0;
		}
		if ( ! isset( $booking_display_fully_booked ) || $booking_display_fully_booked != 1 ) {
			$booking_display_fully_booked = 0;
		}

		if ( ! isset( $booking_show_phone ) || $booking_show_phone != 1 ) {
			$booking_show_phone = 0;
		}
		if ( ! isset( $booking_show_remaining ) || $booking_show_remaining != 1 ) {
			$booking_show_remaining = 0;
		}
		if ( ! isset( $form_text_editor ) || $form_text_editor != 1 ) {
			$form_text_editor = 0;
		}
		if ( ! isset( $form_show_booking_enable ) || $form_show_booking_enable != 1 ) {
			$form_show_booking_enable = 0;
		}
		if ( ! isset( $sync_ical_enable ) || $sync_ical_enable != 1 ) {
			$sync_ical_enable = 0;
		}
		if ( ! isset( $form_show_booking_limit ) || $form_show_booking_limit != 1 ) {
			$form_show_booking_limit = 0;
		}
		if ( ! isset( $form_show_booking_price ) || $form_show_booking_price != 1 ) {
			$form_show_booking_price = 0;
		}
		if ( ! isset( $form_show_booking_block_hours ) || $form_show_booking_block_hours != 1 ) {
			$form_show_booking_block_hours = 0;
		}
		if ( ! isset( $sync_ical_category ) || ! is_numeric( $sync_ical_category ) ) {
			$sync_ical_category = 0;
		}
		if ( ! isset( $translation_fields ) ) {
			$translation_fields = '';
		} else {
			$translation_fields = serialize($translation_fields);
		}


		if ( ! isset( $category_filter_include ) || ! is_array( $category_filter_include ) ) {
			$category_filter_include = "";
		} else {
			$category_filter_include = implode( ",", $category_filter_include );
		}

		if ( ! isset( $venue_filter_include ) || ! is_array( $venue_filter_include ) ) {
			$venue_filter_include = "";
		} else {
			$venue_filter_include = implode( ",", $venue_filter_include );
		}

		if ( ! isset( $allow_user_add_event_roles ) || ! is_array( $allow_user_add_event_roles ) ) {
			$allow_user_add_event_roles = "";
		} else {
			$allow_user_add_event_roles = implode( ",", $allow_user_add_event_roles );
		}

		if ( ! isset( $booking_custom_fields ) || ! is_array( $booking_custom_fields ) ) {
			$booking_custom_fields = "";
		} else {
			$booking_custom_fields = implode( ",", $booking_custom_fields );
		}

		if ( ! isset( $form_custom_fields ) || ! is_array( $form_custom_fields ) ) {
			$form_custom_fields = "";
		} else {
			$form_custom_fields = implode( ",", $form_custom_fields );
		}


		$data   = array();
		$format = array();
		if ( ! isset( $title ) ) {
			$title = 'New Calendar';
		}
		if ( ! isset( $description ) ) {
			$description = '';
		}
		if ( ! isset( $width ) ) {
			$width = '';
		}
		if ( ! isset( $width_unity ) ) {
			$width_unity = '';
		}
		$data['title']       = $title;
		$format[]            = '%s';
		$data['description'] = $description;
		$format[]            = '%s';
		$data['width']       = $width;
		$format[]            = '%s';
		$data['width_unity'] = $width_unity;
		$format[]            = '%s';
		if ( isset( $default_date ) && ! is_null( $default_date ) ) {
			$data['default_date'] = $default_date;
			$format[]             = '%s';
		} else {
			$default_date = '';
		}
		if ( isset( $date_range_start ) && ! is_null( $date_range_start ) ) {
			$data['date_range_start'] = $date_range_start;
			$format[]                 = '%s';
		} else {
			$date_range_start = '';
		}
		if ( isset( $date_range_end ) && ! is_null( $date_range_end ) ) {
			$data['date_range_end'] = $date_range_end;
			$format[]               = '%s';
		} else {
			$date_range_end = '';
        }
		if ( ! isset( $current_date_color ) ) {
			$current_date_color = '';
		}
		$data['current_date_color']  = $current_date_color;
		$format[]                    = '%s';
		$data['active']              = 1;
		$format[]                    = '%d';
		$data['hide_old_dates']      = $hide_old_dates;
		$format[]                    = '%d';
		$data['limit_time_start']    = $limit_time_start;
		$format[]                    = '%d';
		$data['limit_time_end']      = $limit_time_end;
		$format[]                    = '%d';
		$data['assign_events_admin'] = $assign_events_admin;
		$format[]                    = '%d';
		$data['cache_active']        = $cache_active;
		$format[]                    = '%d';
		$data['ical_active']         = $ical_active;
		$format[]                    = '%d';
		if ( ! isset( $ical_limit ) ) {
			$ical_limit = '';
		}
		$data['ical_limit']                      = $ical_limit;
		$format[]                                = '%s';
		$data['rss_active']                      = $rss_active;
		$format[]                                = '%d';
		$data['booking_display_attendees']       = $booking_display_attendees;
		$format[]                                = '%d';
		$data['booking_display_attendees_names'] = $booking_display_attendees_names;
		$format[]                                = '%d';
		$data['booking_display_fully_booked']    = $booking_display_fully_booked;
		$format[]                                = '%d';
		$data['booking_show_phone']              = $booking_show_phone;
		$format[]                                = '%d';
		$data['booking_show_remaining']          = $booking_show_remaining;
		$format[]                                = '%d';
		$data['booking_enable']                  = $booking_enable;
		$format[]                                = '%d';
		$data['booking_non_logged']              = $booking_non_logged;
		$format[]                                = '%d';
		$data['booking_cancel']                  = $booking_cancel;
		$format[]                                = '%d';
		if ( ! isset( $booking_email_template_user ) ) {
			$booking_email_template_user = '';
		}
		$data['booking_email_template_user'] = $booking_email_template_user;
		$format[]                            = '%s';
		if ( ! isset( $booking_cancel_email_template ) ) {
			$booking_cancel_email_template = '';
		}
		$data['booking_cancel_email_template'] = $booking_cancel_email_template;
		$format[]                              = '%s';
		if ( ! isset( $booking_email_template_admin ) ) {
			$booking_email_template_admin = '';
		}
		$data['booking_email_template_admin'] = $booking_email_template_admin;
		$format[]                             = '%s';
		if ( ! isset( $booking_email_template_reminder_user ) ) {
			$booking_email_template_reminder_user = '';
		}
		$data['booking_email_template_reminder_user'] = $booking_email_template_reminder_user;
		$format[]                                     = '%s';
		if ( ! isset( $new_event_email_template_published ) ) {
			$new_event_email_template_published = '';
		}
		$data['new_event_email_template_published'] = $new_event_email_template_published;
		$format[]                                   = '%s';
		$data['booking_comment']                    = $booking_comment;
		$format[]                                   = '%d';
		$data['booking_event_color']                = '#fff';
		$format[]                                   = '%s';
		$data['subscribe_active']                   = $subscribe_active;
		$format[]                                   = '%d';
		if ( ! isset( $mailchimp_api ) ) {
			$mailchimp_api = '';
		}
		$data['mailchimp_api'] = $mailchimp_api;
		$format[]              = '%s';
		if ( ! isset( $mailchimp_list ) ) {
			$mailchimp_list = '';
		}
		$data['mailchimp_list'] = $mailchimp_list;
		$format[]               = '%s';
		if ( ! isset( $rss_limit ) ) {
			$rss_limit = '';
		}
		$data['rss_limit'] = $rss_limit;
		$format[]          = '%s';
		$data['link_post'] = $link_post;
		$format[]          = '%d';
		if ( ! isset( $link_post_target ) ) {
			$link_post_target = '';
		}
		$data['link_post_target']      = $link_post_target;
		$format[]                      = '%s';
		$data['article_share']         = $article_share;
		$format[]                      = '%d';
		$data['email_admin_new_event'] = $email_admin_new_event;
		$format[]                      = '%d';
		if ( ! isset( $view ) ) {
			$view = '';
		}
		$data['view']                        = $view;
		$format[]                            = '%s';
		$data['format_ampm']                 = $format_ampm;
		$format[]                            = '%d';
		$data['show_time']                   = $show_time;
		$format[]                            = '%d';
		$data['show_timezone']               = $show_timezone;
		$format[]                            = '%d';
		$data['enable_wpml']                 = $enable_wpml;
		$format[]                            = '%d';
		$data['show_category_filter']        = $show_category_filter;
		$format[]                            = '%d';
		$data['category_filter_include']     = $category_filter_include;
		$format[]                            = '%s';
		$data['venue_filter_include']        = $venue_filter_include;
		$format[]                            = '%s';
		$data['show_location_filter']        = $show_location_filter;
		$format[]                            = '%d';
		$data['allow_user_add_event_roles']  = $allow_user_add_event_roles;
		$format[]                            = '%s';
		$data['booking_custom_fields']       = $booking_custom_fields;
		$format[]                            = '%s';
		$data['form_custom_fields']          = $form_custom_fields;
		$format[]                            = '%s';
		$data['show_search']                 = $show_search;
		$format[]                            = '%d';
		$data['show_x']                      = $show_x;
		$format[]                            = '%d';
		$data['allow_user_add_event']        = $allow_user_add_event;
		$format[]                            = '%d';
		$data['allow_user_edit_event']       = $allow_user_edit_event;
		$format[]                            = '%d';
		$data['allow_user_remove_event']     = $allow_user_remove_event;
		$format[]                            = '%d';
		$data['publish_new_event']           = $publish_new_event;
		$format[]                            = '%d';
		$data['new_event_email_enable']      = $new_event_email_enable;
		$format[]                            = '%d';
		$data['booking_cancel_email_enable'] = $booking_cancel_email_enable;
		$format[]                            = '%d';
		$data['show_view_buttons']           = $show_view_buttons;
		$format[]                            = '%d';
		$data['show_preview']                = $show_preview;
		$format[]                            = '%d';
		$data['show_titles_monthly']         = $show_titles_monthly;
		$format[]                            = '%d';
		$data['show_references']             = $show_references;
		$format[]                            = '%d';
		$data['show_author']                 = $show_author;
		$format[]                            = '%d';
		$data['form_text_editor']            = $form_text_editor;
		$format[]                            = '%d';
		$data['form_show_end_date']          = $form_show_end_date;
		$format[]                            = '%d';
		$data['form_show_start_time']        = $form_show_start_time;
		$format[]                            = '%d';
		$data['form_show_end_time']          = $form_show_end_time;
		$format[]                            = '%d';
		$data['form_show_extra_dates']       = $form_show_extra_dates;
		$format[]                            = '%d';
		$data['form_show_description']       = $form_show_description;
		$format[]                            = '%d';
		$data['form_show_category']          = $form_show_category;
		$format[]                            = '%d';
		$data['form_show_hide_time']         = $form_show_hide_time;
		$format[]                            = '%d';
		$data['form_show_frequency']         = $form_show_frequency;
		$format[]                            = '%d';
		$data['form_show_all_day']           = $form_show_all_day;
		$format[]                            = '%d';
		$data['form_show_image']             = $form_show_image;
		$format[]                            = '%d';
		$data['form_show_link']              = $form_show_link;
		$format[]                            = '%d';
		$data['form_show_location']          = $form_show_location;
		$format[]                            = '%d';
		$data['form_show_location_options']  = $form_show_location_options;
		$format[]                            = '%d';
		$data['form_show_phone']             = $form_show_phone;
		$format[]                            = '%d';
		$data['form_show_map']               = $form_show_map;
		$format[]                            = '%d';
		$data['form_show_color']             = $form_show_color;
		$format[]                            = '%d';
		$data['form_show_timezone']          = $form_show_timezone;
		$format[]                            = '%d';
		if ( ! isset( $first_day ) ) {
			$first_day = '';
		}
		$data['first_day'] = $first_day;
		$format[]          = '%d';
		if ( ! isset( $skin ) ) {
			$skin = '';
		}
		$data['skin']             = $skin;
		$format[]                 = '%s';
		$data['sync_ical_enable'] = $sync_ical_enable;
		$format[]                 = '%d';
		if ( ! isset( $sync_ical_url ) ) {
			$sync_ical_url = '';
		}
		$data['sync_ical_url'] = str_replace( "webcal://", "http://", $sync_ical_url );
		$format[]              = '%s';
		if ( ! isset( $sync_fb_page ) ) {
			$sync_fb_page = '';
		}
		$data['sync_fb_page'] = $sync_fb_page;
		$format[]             = '%s';
		if ( ! isset( $sync_ical_frequency ) ) {
			$sync_ical_frequency = '';
		}
		$data['sync_ical_frequency'] = $sync_ical_frequency;
		$format[]                    = '%s';
		$data['sync_ical_category']  = $sync_ical_category;
		$format[]                    = '%d';
		if ( ! isset( $daily_weekly_layout ) ) {
			$daily_weekly_layout = '';
		}
		$data['daily_weekly_layout']           = $daily_weekly_layout;
		$format[]                              = '%s';
		$data['booking_max_quantity']          = $booking_max_quantity;
		$format[]                              = '%d';
		$data['form_show_booking_enable']      = $form_show_booking_enable;
		$format[]                              = '%d';
		$data['form_show_booking_limit']       = $form_show_booking_limit;
		$format[]                              = '%d';
		$data['form_show_booking_price']       = $form_show_booking_price;
		$format[]                              = '%d';
		$data['form_show_booking_block_hours'] = $form_show_booking_block_hours;
		$format[]                              = '%d';
		$data['booking_max_upcoming_dates']    = $booking_max_upcoming_dates;
		$format[]                              = '%d';
		$data['translation_fields']            = $translation_fields;
		$format[]                              = '%s';

		if ( isset( $_POST['calendar_id'] ) && is_numeric( $_POST['calendar_id'] ) && $_POST['calendar_id'] > 0 ) {
			$wpdb->query( "SET NAMES utf8" );

			$sql = "UPDATE $table_name SET ";
			$sql .= "WHERE id = $calendar_id ";

			$wpdb->update(
				$table_name,
				$data,
				array( 'id' => $calendar_id ),
				$format,
				array( '%d' )
			);

		} else {

			$wpdb->insert(
				$table_name,
				$data,
				$format
			);

			$calendar_id = $wpdb->insert_id;
		}

		if ( isset( $coreftCalendar_cache[ 'calendar_id_' . $calendar_id ] ) ) {
			$coreftCalendar_cache[ 'calendar_id_' . $calendar_id ] = array();
			update_option( 'coreftCalendar_cache', $coreftCalendar_cache );
		}

		if(!isset($_GET['add'])){
			wp_redirect( admin_url( 'admin.php?page=coreftCalendar-admin&settings-updated=1' ) );
			exit;
        }
	}

	if ( ! empty( $_FILES['coreft_ical_file']['name'] ) || ! empty( $_POST['coreft_fb_event_url'] ) ) {
		$calendar_id  = absint($_POST['coreft_id_calendar_ics']);
		$category_ics = sanitize_text_field($_POST['coreft_category_ics']);


		if ( ! empty( $_POST['coreft_fb_event_url'] ) ) {

			$fb_page_arr = explode( ",", esc_url($_POST['coreft_fb_event_url']) );

			foreach ( $fb_page_arr as $url ) {

				if ( $url != "" ) {
					$event_url = rtrim( $url );

					coreftCalendar_importFB( $calendar_id, $event_url, $category_ics, intval($_POST['coreft_fb_event_option']), sanitize_text_field($_POST['coreft_offset_hour']) );
				}

			}

			/*
			echo '<pre>';
			print_r($graph_arr);
			echo '</pre>';
			die();*/
		}


		if ( ! empty( $_FILES['coreft_ical_file']['name'] ) ) {
			$filename = sanitize_text_field($_FILES['coreft_ical_file']['tmp_name']);

			coreftCalendar_importICS( $calendar_id, $filename, sanitize_text_field($_FILES['coreft_ical_file']['name']), $category_ics, sanitize_text_field($_POST['coreft_offset_hour']) );

		}

		if ( isset( $coreftCalendar_cache[ 'calendar_id_' . $calendar_id ] ) ) {
			$coreftCalendar_cache[ 'calendar_id_' . $calendar_id ] = array();
			update_option( 'coreftCalendar_cache', $coreftCalendar_cache );
		}

		wp_redirect( admin_url( 'admin.php?page=coreftCalendar-admin&settings-updated=1' ) );
		exit;
	}

	if ( isset( $_GET['delete_calendar'] ) && $_GET['delete_calendar'] ) {
		$calendar_id = coreftSanitizeData($_GET['delete_calendar']);

		$querystr      = "
		SELECT sync_ical_url, sync_fb_page
		FROM " . $table_name . "
		WHERE id = " . $calendar_id . "
		LIMIT 1
		";
		$calendars_obj = $wpdb->get_results( $querystr, OBJECT );

		$args = array(
			'posts_per_page' => - 1,
			'post_type'      => 'coreft-events',
			'meta_key'       => 'coreft_id_calendar',
			'meta_value'     => $calendar_id
		);

		$delete_posts = get_posts( $args );
		if ( ! empty( $delete_posts ) ) {
			foreach ( $delete_posts as $key ) {
				wp_delete_post( $key->ID );
			}
		}

		$sql    = "DELETE FROM $table_name WHERE id = $calendar_id;";
		$result = $wpdb->query( $sql );

		$sql    = "DELETE FROM $table_name_special_dates_calendar WHERE calendar = $calendar_id;";
		$result = $wpdb->query( $sql );

		wp_clear_scheduled_hook( 'pecsyncical' . $calendar_id, array(
			$calendar_id,
			$calendars_obj[0]->sync_ical_url,
			$calendars_obj[0]->sync_fb_page
		) );

		wp_redirect( admin_url( 'admin.php?page=coreftCalendar-admin&settings-updated=1' ) );
		exit;
	}

	if ( isset( $_GET['delete_calendar_events'] ) && $_GET['delete_calendar_events'] ) {
		$calendar_id = coreftSanitizeData($_GET['delete_calendar_events']);

		$args = array(
			'posts_per_page' => - 1,
			'post_type'      => 'coreft-events',
			'meta_key'       => 'coreft_id_calendar',
			'meta_value'     => $calendar_id
		);

		$delete_posts = get_posts( $args );
		if ( ! empty( $delete_posts ) ) {
			foreach ( $delete_posts as $key ) {
				wp_trash_post( $key->ID );
			}
		}

		wp_redirect( admin_url( 'admin.php?page=coreftCalendar-admin&settings-updated=1' ) );
		exit;
	}

	if ( isset( $_GET['delete_subscriber'] ) && $_GET['delete_subscriber'] ) {
		$subscriber_id = coreftSanitizeData($_GET['delete_subscriber']);
		$calendar_id   = coreftSanitizeData($_GET['edit']);

		$sql    = "DELETE FROM $table_name_subscribers_calendar WHERE calendar = " . $calendar_id . " AND id = " . $subscriber_id . ";";
		$result = $wpdb->query( $sql );

		wp_redirect( admin_url( 'admin.php?page=coreftCalendar-admin&edit=' . $calendar_id . '&settings-updated=1' ) );
		exit;
	}


	require_once( dirname( __FILE__ ) . '/../src/base.class.php' );


	?>
    <script type="text/javascript">
        function MailChimp_getList() {
            jQuery('#div_mailchimp_list').hide();

            if (jQuery('#mailchimp_api_key').val() != "") {
                jQuery.post("<?php echo admin_url('admin-ajax.php'); ?>", {
                        mailchimp_api: jQuery('#mailchimp_api_key').val(),
                        action: 'coreft_calendar_mailchimp_getlists'
                    },
                    function (data) {
                        jQuery('#mailchimp_list').html(data);
                        jQuery('#div_mailchimp_list').show();
                    }
                );

            }
        }
    </script>

    <div class="wrap" style="clear:both;" id="coreft_options">
        <h2></h2>
        <div style="clear:both;"></div>
        <!--end of poststuff -->
        <div id="coreft_ui_content" class="coreft-nobg">

			<?php if ( ( ! isset( $_GET['add'] ) || ! is_numeric( $_GET['add'] ) ) && ( ! isset( $_GET['edit'] ) || ! is_numeric( $_GET['edit'] ) ) ) { ?>


                <div id="coreftCalendarsAdmin">
                    <div id="menu_general_settings">
                        <div class="titleArea">
                            <div class="wrapper">
                                <div class="pageTitle">
                                    <h2><?php _e( 'Calendars', 'coreftCalendar' ); ?></h2>
                                    <input type="button" class="button-primary"
                                           value="<?php echo __( 'Add new calendar', 'coreftCalendar' ) ?>"
                                           name="add_calendar"
                                           onclick="location.href='<?php echo coreftCalendar_admin_url( array( 'add' => '1' ) ) ?>';"/>
                                </div>

                                <div class="clear"></div>
                            </div>
                        </div>

                        <div class="wrapper">

                            <form action="<?php echo admin_url( 'admin.php?page=coreftCalendar-admin&noheader=true' ); ?>"
                                  id="coreftCalendar_events_meta" class="coreftCalendar_calendar_form" method="post"
                                  enctype="multipart/form-data">
								<?php settings_fields( 'coreftCalendar-group' ); ?>

                                <input type="hidden" name="remove_posts_calendar" value="1"/>


								<?php

								$counter = 0;
								$limit   = 10;
								$pag     = 0;
								if ( isset( $_GET['pag'] ) && is_numeric( $_GET['pag'] ) && $_GET['pag'] > 0 ) {
									$pag = coreftSanitizeData($_GET['pag'], 'absint');
								}

								$querystr   = "
                    SELECT COUNT(id) as counter
                    FROM $table_name calendars;
                    ";

								$count = $wpdb->get_row( $querystr, OBJECT );


								if ( $count->counter > $limit ) {

									if ( $pag > 0 ) {
										?>
                                        <a href="<?php echo admin_url( 'admin.php?page=coreftCalendar-admin&pag=' . ( $pag - 1 ) ) ?>"><?php echo __( 'Prev', 'CoreftCalendar' ) ?></a> |

									<?php } ?>
									<?php if ( ( ( $pag + 1 ) * $limit ) < $count->counter ) { ?>
                                        <a href="<?php echo admin_url( 'admin.php?page=coreftCalendar-admin&pag=' . ( $pag + 1 ) ) ?>"><?php echo __( 'Next', 'CoreftCalendar' ) ?></a>
										<?php
									}

								} ?>

                                <table class="widefat" cellpadding="0" cellspacing="0" id="sort-table">
                                    <thead>
                                    <tr style="cursor:default !important;">
                                        <th><?php _e( 'ID', 'coreftCalendar' ); ?></th>
                                        <th><?php _e( 'Shortcode', 'coreftCalendar' ); ?></th>
                                        <th><?php _e( 'Title', 'coreftCalendar' ); ?></th>
                                        <th><?php _e( 'Events', 'coreftCalendar' ); ?></th>
                                        <th><?php _e( 'Actions', 'coreftCalendar' ); ?></th>
                                    </tr>
                                    </thead>
                                    <tbody>
									<?php


									$querystr      = "
                    SELECT calendars.*
                    FROM $table_name calendars
                    ORDER BY calendars.title ASC
                    LIMIT " . ( $pag * $limit ) . " ," . $limit;
									$calendars_obj = $wpdb->get_results( $querystr, OBJECT );
									if ( ! empty( $calendars_obj ) ) {
										foreach ( $calendars_obj as $calendar ) {
											$coreftCalendar_class = new CoreftCalendar( true, ( is_numeric( $calendar->id ) ? $calendar->id : null ) );


											$calendar_nonce     = $coreftCalendar_class->getNonce();
											$args               = array(
												'numberposts' => 500,
												'fields'      => 'ids',
												'post_status' => 'publish',
												'post_type'   => 'coreft-events'
											);
											$args['meta_query'] = array(
												'relation' => 'OR',
												array(
													'key'     => "coreft_id_calendar",
													"value"   => '(,' . $calendar->id . ',)',
													'compare' => 'REGEXP'
												),
												array(
													'key'     => "coreft_id_calendar",
													"value"   => '(,' . $calendar->id . ')$',
													'compare' => 'REGEXP'
												),
												array(
													'key'     => "coreft_id_calendar",
													"value"   => '^(' . $calendar->id . ',)',
													'compare' => 'REGEXP'
												),
												array( 'key' => "coreft_id_calendar", "value" => $calendar->id )
											);

											$events_cal   = get_posts( $args );
											$events_count = count( $events_cal );

											echo '<tr id="' . $calendar->id . '">
								<td width="5%">' . $calendar->id . '</td>
								<td width="25%"><div class="coreft_calendar_shortcode">[coreftCalendar id=' . $calendar->id . ']</div></td>
								<td width="20%">' . $calendar->title . '</td>
								<td width="5%"><a href="' . admin_url( 'edit.php?s&post_status=all&post_type=coreft-events&action=-1&m=0&coreft_id_calendar=' . $calendar->id . '&paged=1' ) . '">' . ( $events_count == 500 ? "500+" : $events_count ) . '</a></td>
								<td width="45%">
									<input type="button" value="' . __( 'Edit', 'coreftCalendar' ) . '" name="edit_calendar" class="button-secondary" onclick="location.href=\'' . admin_url( 'admin.php?page=coreftCalendar-admin&edit=' . $calendar->id ) . '\';" />
									<input type="button" value="' . __( 'Delete', 'coreftCalendar' ) . '" name="delete_calendar" class="button-secondary" onclick="if(confirmCalendarDelete()) { location.href=\'' . admin_url( 'admin.php?page=coreftCalendar-admin&delete_calendar=' . $calendar->id . '&noheader=true' ) . '\'; }" />
									<input type="button" value="' . __( 'Delete All Events', 'coreftCalendar' ) . '" name="delete_calendar" class="button-secondary" onclick="if(confirmCalendarEventsDelete()) { location.href=\'' . admin_url( 'admin.php?page=coreftCalendar-admin&delete_calendar_events=' . $calendar->id . '&noheader=true' ) . '\'; }" />
								</td>
							</tr>';
											$counter ++;
										}
									} else {
										echo '<tr><td colspan="5">No Calendars</td></tr>';
									}
									?>

                                    </tbody>
                                    <tfoot>
                                    <tr style="cursor:default !important;">
                                        <th><?php _e( 'ID', 'coreftCalendar' ); ?></th>
                                        <th><?php _e( 'Shortcode', 'coreftCalendar' ); ?></th>
                                        <th><?php _e( 'Title', 'coreftCalendar' ); ?></th>
                                        <th><?php _e( 'Events', 'coreftCalendar' ); ?></th>
                                        <th><?php _e( 'Actions', 'coreftCalendar' ); ?></th>
                                    </tr>
                                    </tfoot>
                                </table>

                                <div class="clear"></div>

                            </form>
                        </div>
                    </div>
                </div>
			<?php } elseif ( ( isset( $_GET['add'] ) && is_numeric( $_GET['add'] ) ) || ( isset( $_GET['edit'] ) && is_numeric( $_GET['edit'] ) ) ) {

				if ( isset( $_GET['edit'] ) && is_numeric( $_GET['edit'] ) ) {
					$calendar_id  = coreftSanitizeData($_GET['edit'], 'absint');
					$querystr     = "
			SELECT *
			FROM $table_name 
			WHERE id = $calendar_id
			";
					$calendar_obj = $wpdb->get_results( $querystr, OBJECT );
					$calendar_obj = $calendar_obj[0];
					foreach ( $calendar_obj as $key => $value ) {
						$$key = $value;
					}

					$category_filter_include    = explode( ',', $category_filter_include );
					$venue_filter_include       = explode( ',', $venue_filter_include );
					$allow_user_add_event_roles = explode( ',', $allow_user_add_event_roles );
					$booking_custom_fields_arr  = explode( ',', $booking_custom_fields );
					$form_custom_fields_arr     = explode( ',', $form_custom_fields );

				} else {
//				    $calendar_id = null;
//					$width_unity            = '%';
//					$width                  = 100;
//					$booking_event_color    = '#e14d43';
//					$show_time              = 1;
//					$show_preview           = 1;
//					$show_titles_monthly    = 1;
//					$new_event_email_enable = 1;
//					if ( ! isset( $title ) ) {
//						$title = '';
//					}
//					if ( ! isset( $description ) ) {
//						$description = '';
//					}
//					if ( ! isset( $width ) ) {
//						$width = '';
//					}
//					if ( ! isset( $width_unity ) ) {
//						$width_unity = '';
//					}
//					$default_date                         = '';
//					$date_range_start                     = '';
//					$current_date_color                   = '';
//					$ical_limit                           = '';
//					$booking_email_template_user          = '';
//					$booking_cancel_email_template        = '';
//					$booking_email_template_admin         = '';
//					$booking_email_template_reminder_user = '';
//					$new_event_email_template_published   = '';
//					$mailchimp_api                        = '';
//					$mailchimp_list                       = '';
//					$rss_limit                            = '';
//					$link_post_target                     = '';
//					$view                                 = '';
//					$first_day                            = '';
//					$skin                                 = '';
//					$sync_ical_url                        = '';
//					$sync_fb_page                         = '';
//					$sync_ical_frequency                  = '';
//					$daily_weekly_layout                  = '';
//					$format_ampm                          = 0;
//					$show_time                            = 0;
//					$show_timezone                        = 0;
//					$show_search                          = 0;
//					$show_category_filter                 = 0;
//					$show_location_filter                 = 0;
//					$show_x                               = 0;
//					$allow_user_add_event                 = 0;
//					$allow_user_edit_event                = 0;
//					$allow_user_remove_event              = 0;
//					$publish_new_event                    = 0;
//					$new_event_email_enable               = 0;
//					$booking_cancel_email_enable          = 0;
//					$show_view_buttons                    = 0;
//					$show_preview                         = 0;
//					$show_titles_monthly                  = 0;
//					$show_references                      = 0;
//					$show_author                          = 0;
//					$cache_active                         = 0;
//					$ical_active                          = 0;
//					$rss_active                           = 0;
//					$subscribe_active                     = 0;
//					$link_post                            = 0;
//					$email_admin_new_event                = 0;
//					$article_share                        = 0;
//					$hide_old_dates                       = 0;
//					$limit_time_start                     = 0;
//					$booking_max_quantity                 = 3;
//					$booking_max_upcoming_dates           = 10;
//					$assign_events_admin                  = 0;
//					$form_show_end_date                   = 0;
//					$form_show_start_time                 = 0;
//					$form_show_end_time                   = 0;
//					$form_show_extra_dates                = 0;
//					$form_show_description                = 0;
//					$form_show_category                   = 0;
//					$form_show_hide_time                  = 0;
//					$form_show_frequency                  = 0;
//					$form_show_all_day                    = 0;
//					$form_show_image                      = 0;
//					$form_show_link                       = 0;
//					$form_show_location                   = 0;
//					$form_show_location_options           = 0;
//					$form_show_phone                      = 0;
//					$form_show_map                        = 0;
//					$form_show_color                      = 0;
//					$form_show_timezone                   = 0;
//					$booking_enable                       = 0;
//					$booking_comment                      = 0;
//					$booking_non_logged                   = 0;
//					$booking_cancel                       = 0;
//					$enable_wpml                          = 0;
//					$booking_display_attendees            = 0;
//					$booking_display_attendees_names      = 0;
//					$booking_display_fully_booked         = 0;
//					$booking_show_phone                   = 0;
//					$booking_show_remaining               = 0;
//					$form_text_editor                     = 0;
//					$form_show_booking_enable             = 0;
//					$sync_ical_enable                     = 0;
//					$form_show_booking_limit              = 0;
//					$form_show_booking_price              = 0;
//					$form_show_booking_block_hours        = 0;
//					$sync_ical_category                   = 0;
//					$translation_fields                   = '';
//					$date_range_end = '';
//					$category_filter_include    = array();
//					$venue_filter_include       = array();
//					$allow_user_add_event_roles = array();
//					$booking_custom_fields_arr  = array();
//					$form_custom_fields_arr     = array();
				}

				if ( ! isset( $booking_email_template_user ) || $booking_email_template_user == '' ) {
					$booking_email_template_user = "Hi #USERNAME#,\n\nThanks for booking the event:\n\n#EVENT_DETAILS#\n\nPlease contact us if you have questions.\n\nKind Regards.\n#SITE_NAME#";
				}

				if ( ! isset( $booking_cancel_email_template ) || $booking_cancel_email_template == '' ) {
					$booking_cancel_email_template = "Hi #USERNAME#,\n\nThe following booking has been canceled:\n\n#EVENT_DETAILS#\n\n#CANCEL_REASON#\n\nPlease contact us if you have questions.\n\nKind Regards.\n#SITE_NAME#";
				}

				if ( ! isset( $booking_email_template_admin ) || $booking_email_template_admin == '' ) {
					$booking_email_template_admin = "The user #USERNAME# (#USEREMAIL#) booked the event:\n\n#EVENT_DETAILS#\n\n#COMMENT#\n\n#SITE_NAME#";
				}

				if ( ! isset( $booking_email_template_reminder_user ) || $booking_email_template_reminder_user == '' ) {
					$booking_email_template_reminder_user = "Hi #USERNAME#,\n\nWe would like to remind you the booking of the event:\n\n#EVENT_DETAILS#\n\nKind Regards.\n#SITE_NAME#";
				}

				if ( ! isset( $new_event_email_template_published ) || $new_event_email_template_published == '' ) {
					$new_event_email_template_published = "Hi #USERNAME#,\n\nThe event #EVENT_TITLE# has been approved.\n\nPlease contact us if you have questions.\n\nKind Regards.\n#SITE_NAME#";
				}

				$coreftCalendar_class = new CoreftCalendar( true, ( isset( $calendar_id ) && is_numeric( $calendar_id ) ? $calendar_id : null ) );
				if ( isset( $calendar_id ) && is_numeric( $calendar_id ) ) {
					$coreftCalendar_class->addScripts( true );
				}

				?>
                <div id="coreftCalendarsAdmin">

                    <div id="menu_general_settings">

                        <form method="post" id="coreftCalendar_events_meta" class="coreftCalendar_calendar_form"
                              action="<?php echo admin_url( 'admin.php?page=coreftCalendar-admin&noheader=true' ); ?>"
                              onsubmit="return calendar_checkform();" enctype="multipart/form-data">

                            <div class="titleArea">
                                <div class="wrapper">
                                    <div class="pageTitle">
                                        <h2><?php _e( 'Calendar', 'coreftCalendar' ); ?></h2>
                                        <span><?php _e( 'Customize the Calendar.', 'coreftCalendar' ); ?></span>

                                    </div>

                                    <p class="submit" style="float: right; margin: 0; margin-top: 66px;">

                                        <input type="submit" class="button-primary" value="<?php _e( 'Save' ) ?>"/>

                                        <input type="button" class="button" value="<?php _e( 'Back' ) ?>"
                                               onclick="history.back();"/>

                                    </p>

                                    <div class="clear"></div>
                                </div>
                            </div>

                            <div class="wrapper">


                                <input type="hidden" name="submit" value="1"/>
								<?php if ( isset( $id ) && is_numeric( $id ) && $id > 0 ) { ?>
                                    <input type="hidden" name="calendar_id" value="<?php echo $id ?>"/>
								<?php } ?>
								<?php settings_fields( 'coreftCalendar-group' ); ?>
                                <div style="clear:both;"></div>
                                <!--end of poststuff -->

                                <div style="clear:both;"></div>

                                <h2 class="subtitle accordion_title coreft_ui_on"
                                    onclick="showAccordion('div_general_settings', this);">General Settings</h2>
                                <div id="div_general_settings">

                                    <div class="option option-select">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Title', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="text" name="title" maxlength="80"
                                                           id="coreftCalendar_title" class="large-text"
                                                           value="<?php echo $title ?>"
                                                           placeholder="<?php _e( 'Introduce the title (80 chars max.)', 'coreftCalendar' ); ?>"/>
                                                    <br>
                                                </div>
                                                <div class="desc"></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-select">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Description', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="text" name="description"
                                                           id="coreftCalendar_description" class="large-text"
                                                           value="<?php echo $description ?>"
                                                           placeholder="<?php _e( 'Introduce the description', 'coreftCalendar' ); ?>"/>
                                                    <br>
                                                </div>
                                                <div class="desc"></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-select">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Preselected Date', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="text" readonly="readonly" maxlength="10"
                                                           class="large-text" name="default_date"
                                                           id="coreftCalendar_default_date"
                                                           value="<?php echo $default_date != '0000-00-00' ? $default_date : '' ?>"
                                                           style="width:100px;"/>
                                                    <button type="button" class="coreftCalendar_btn_getDate">
                                                        <img src="<?php echo coreftCalendar_plugin_url( 'images/admin/calendar.png' ); ?>"
                                                             alt="Calendar" title="Calendar">
                                                    </button>
                                                    <button type="button"
                                                            onclick="jQuery('#coreftCalendar_default_date').val('');">
                                                        <img src="<?php echo coreftCalendar_plugin_url( 'images/admin/clear.png' ); ?>"
                                                             alt="Clear" title="Clear">
                                                    </button>
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Select the preselected date.(optional)<br />Leave blank to NOT preselect any date.', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Enable iCal Feed', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="checkbox" name="ical_active"
                                                           id="coreftCalendar_ical_active" class="checkbox"
													       <?php if ( $ical_active ) { ?>checked="checked" <?php } ?>
                                                           value="1"/>
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'On/Off the iCal feed for this calendar', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'iCal Limit', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="number" min="0" max="999" name="ical_limit"
                                                           id="coreftCalendar_ical_limit"
                                                           value="<?php echo $ical_limit ?>"/>
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Limits the number of future events shown (0 = unlimited).', 'coreftCalendar' ); ?>
                                                    <br/><?php if ( is_numeric( $calendar_id ) ) {
														_e( 'iCal feed URL: ', 'coreftCalendar' );
														echo '<br>' . home_url( 'calendar-ical-feed/?calendar_id=' . $calendar_id );
													} ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Enable RSS Feed', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="checkbox" name="rss_active"
                                                           id="coreftCalendar_rss_active" class="checkbox"
													       <?php if ( $rss_active ) { ?>checked="checked" <?php } ?>
                                                           value="1"/>
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'On/Off the rss feed for this calendar', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'RSS Limit', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="number" min="0" max="999" name="rss_limit"
                                                           id="coreftCalendar_rss_limit"
                                                           value="<?php echo $rss_limit ?>"/>
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Limits the number of future events shown (0 = unlimited).', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Link Events to Single Post', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="checkbox" name="link_post"
                                                           id="coreftCalendar_link_post" class="checkbox"
													       <?php if ( $link_post ) { ?>checked="checked" <?php } ?>
                                                           value="1"/>
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Adds a link in the event title to the post type single page.', 'coreftCalendar' ); ?></div>

                                                <select name="link_post_target" id="coreftCalendar_link_post_target"
                                                        class="large-text">
                                                    <option value="_self" <?php if ( isset( $link_post_target ) && $link_post_target == "_self" ) {
														echo 'selected="selected"';
													} ?>><?php _e( 'Open in the same tab', 'coreftCalendar' ); ?></option>
                                                    <option value="_blank" <?php if ( isset( $link_post_target ) && $link_post_target == "_blank" ) {
														echo 'selected="selected"';
													} ?>><?php _e( 'Open in a new tab', 'coreftCalendar' ); ?></option>
                                                </select>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-select">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Date Range', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="text" readonly="readonly" maxlength="10"
                                                           class="large-text" name="date_range_start"
                                                           id="coreftCalendar_date_range_start"
                                                           value="<?php echo $date_range_start != '0000-00-00' ? $date_range_start : '' ?>"
                                                           style="width:100px;"/>
                                                    <button type="button" class="coreftCalendar_btn_getDateRangeStart">
                                                        <img src="<?php echo coreftCalendar_plugin_url( 'images/admin/calendar.png' ); ?>"
                                                             alt="Calendar" title="Calendar">
                                                    </button>
                                                    <button type="button"
                                                            onclick="jQuery('#coreftCalendar_date_range_start').val('');">
                                                        <img src="<?php echo coreftCalendar_plugin_url( 'images/admin/clear.png' ); ?>"
                                                             alt="Clear" title="Clear">
                                                    </button>

                                                    &nbsp;&nbsp;to&nbsp;&nbsp;

                                                    <input type="text" readonly="readonly" maxlength="10"
                                                           class="large-text" name="date_range_end"
                                                           id="coreftCalendar_date_range_end"
                                                           value="<?php echo $date_range_end != '0000-00-00' ? $date_range_end : '' ?>"
                                                           style="width:100px;"/>
                                                    <button type="button" class="coreftCalendar_btn_getDateRangeEnd">
                                                        <img src="<?php echo coreftCalendar_plugin_url( 'images/admin/calendar.png' ); ?>"
                                                             alt="Calendar" title="Calendar">
                                                    </button>
                                                    <button type="button"
                                                            onclick="jQuery('#coreftCalendar_date_range_end').val('');">
                                                        <img src="<?php echo coreftCalendar_plugin_url( 'images/admin/clear.png' ); ?>"
                                                             alt="Clear" title="Clear">
                                                    </button>
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'This option will limit the dates displayed in the calendar. (optional)', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Hide Old Dates', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="checkbox" name="hide_old_dates"
                                                           id="coreftCalendar_hide_old_dates" class="checkbox"
													       <?php if ( $hide_old_dates ) { ?>checked="checked" <?php } ?>
                                                           value="1"/>
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Hide old dates in calendar view.', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-select">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'First Day', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <select name="first_day" id="coreftCalendar_first_day"
                                                            class="large-text">
                                                        <option value="0" <?php if ( $first_day == "0" ) {
															echo 'selected="selected"';
														} ?>><?php _e( 'Sunday', 'coreftCalendar' ); ?></option>
                                                        <option value="1" <?php if ( $first_day == "1" ) {
															echo 'selected="selected"';
														} ?>><?php _e( 'Monday', 'coreftCalendar' ); ?></option>
                                                    </select>
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Select the first day to display in the calendar', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-select">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Default View', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <select name="view" id="coreftCalendar_view" class="large-text">
                                                        <option value="monthly" <?php if ( $view == "monthly" ) {
															echo 'selected="selected"';
														} ?>><?php _e( 'Calendar', 'coreftCalendar' ); ?></option>
                                                        <option value="monthly-all-events" <?php if ( $view == "monthly-all-events" ) {
															echo 'selected="selected"';
														} ?>><?php _e( 'Monthly Events List', 'coreftCalendar' ); ?></option>
                                                        <option value="weekly" <?php if ( $view == "weekly" ) {
															echo 'selected="selected"';
														} ?>><?php _e( 'Weekly', 'coreftCalendar' ); ?></option>
                                                        <option value="daily" <?php if ( $view == "daily" ) {
															echo 'selected="selected"';
														} ?>><?php _e( 'Daily', 'coreftCalendar' ); ?></option>
                                                    </select>
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Select the default view.', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Show Monthly / Weekly / Daily Buttons', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="checkbox" name="show_view_buttons" class="checkbox"
                                                           id="coreftCalendar_show_view_buttons" value="1"
													       <?php if ( $show_view_buttons ) { ?>checked="checked" <?php } ?> />
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Show/Hide the Monthly / Weekly / Daily Buttons.', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-select">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Daily / Weekly layout', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <select name="daily_weekly_layout"
                                                            id="coreftCalendar_daily_weekly_layout" class="large-text">
                                                        <option value="list" <?php if ( $daily_weekly_layout == "list" ) {
															echo 'selected="selected"';
														} ?>><?php _e( 'List', 'coreftCalendar' ); ?></option>
                                                        <option value="schedule" <?php if ( $daily_weekly_layout == "schedule" ) {
															echo 'selected="selected"';
														} ?>><?php _e( 'Schedule', 'coreftCalendar' ); ?></option>
                                                    </select>
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Select the events layout for the daily and weekly view.', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox no_border">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Limit Time in daily / weekly schedule view', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="number" name="limit_time_start"
                                                           id="coreftCalendar_limit_time_start" style="width: 60px;"
                                                           maxlength="2" min="0" max="23"
                                                           value="<?php echo $limit_time_start ?>"/>:00 hs /
                                                    &nbsp;
                                                    <input type="number" name="limit_time_end"
                                                           id="coreftCalendar_limit_time_end" style="width: 60px;"
                                                           maxlength="2" min="0" max="23"
                                                           value="<?php echo $limit_time_end ?>"/>:00 hs
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Set a range of time to display in the daily / weekly schedule layout.', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                </div>

                                <h2 class="subtitle accordion_title"
                                    onclick="showAccordion('div_display_settings', this);"><?php _e( 'Display Settings', 'coreftCalendar' ); ?></h2>

                                <div id="div_display_settings" style="display: none;">
                                    <div class="option option-select">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Skin', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <select name="skin" id="coreftCalendar_skin" class="large-text">
                                                        <option value="light" <?php if ( $skin == 'light' ) {
															echo 'selected="selected"';
														} ?>><?php _e( 'Light', 'coreftCalendar' ); ?></option>
                                                        <option value="dark" <?php if ( $skin == 'dark' ) {
															echo 'selected="selected"';
														} ?>><?php _e( 'Dark', 'coreftCalendar' ); ?></option>
                                                    </select>
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Select the skin theme', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Show Time', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="checkbox" name="show_time" class="checkbox"
                                                           id="coreftCalendar_show_time" value="1"
													       <?php if ( $show_time ) { ?>checked="checked" <?php } ?>
                                                           onclick="toggleFormat();"/>
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Show/Hide the events time.', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div id="div_time_extended" style="display:none;">
                                        <div class="option option-checkbox">
                                            <div class="option-inner">
                                                <label class="titledesc"><?php _e( 'Show Timezone', 'coreftCalendar' ); ?></label>
                                                <div class="formcontainer">
                                                    <div class="forminp">
                                                        <input type="checkbox" name="show_timezone"
                                                               id="coreftCalendar_show_timezone"
                                                               class="checkbox" <?php if ( $show_timezone ) { ?> checked="checked" <?php } ?>
                                                               value="1"/>
                                                        <br>
                                                    </div>
                                                    <div class="desc"><?php _e( 'Display Timezone in the frontend.', 'coreftCalendar' ); ?></div>
                                                </div>
                                            </div>
                                        </div>
                                        <div class="clear"></div>
                                    </div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Show Search', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="checkbox" name="show_search" class="checkbox"
                                                           id="coreftCalendar_show_search" value="1"
													       <?php if ( $show_search ) { ?>checked="checked" <?php } ?> />
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Show/Hide the search input.', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Show Category Filter', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="checkbox" name="show_category_filter" class="checkbox"
                                                           id="coreftCalendar_show_category_filter" value="1"
													       <?php if ( $show_category_filter ) { ?>checked="checked" <?php } ?>
                                                           onclick="toggleFormatCategories();"/>
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Show/Hide the categories dropdown.', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox" id="div_category_filter" style="display:none;">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Categories to display', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <select name="category_filter_include[]"
                                                            id="coreftCalendar_category_filter_include"
                                                            multiple="multiple">
                                                        <option value=""
														        <?php if ( empty( $category_filter_include ) ) { ?>selected="selected"<?php } ?>><?php _e( 'All', 'coreftCalendar' ); ?></option>
														<?php
														$categories = get_categories( 'taxonomy=coreft_events_category&hide_empty=0' );
														if ( ! is_array( $category_filter_include ) ) {
															$category_filter_include = array();
														}
														foreach ( $categories as $category ) {
															$option = '<option value="' . $category->term_id . '" ';
															if ( in_array( $category->term_id, $category_filter_include ) ) {
																$option .= 'selected="selected"';
															}
															$option .= '>';
															$option .= $category->cat_name;
															$option .= '</option>';
															echo $option;
														}
														?>
                                                    </select>
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Select specific categories to display. To select multiple categories, keep pressing ctrl.', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Show Location / Venue Filter', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="checkbox" name="show_location_filter" class="checkbox"
                                                           id="coreftCalendar_show_location_filter" value="1"
													       <?php if ( $show_location_filter ) { ?>checked="checked" <?php } ?>
                                                           onclick="toggleFormatVenues();"/>
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Show/Hide the locations dropdown.', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox" id="div_venue_filter" style="display:none;">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Venues to display', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <select name="venue_filter_include[]"
                                                            id="coreftCalendar_venue_filter_include"
                                                            multiple="multiple">
                                                        <option value=""
														        <?php if ( empty( $venue_filter_include ) ) { ?>selected="selected"<?php } ?>><?php _e( 'All', 'coreftCalendar' ); ?></option>
														<?php
														$args = array(
															'posts_per_page' => - 1,
															'post_type'      => 'coreft-venues',
															'post_status'    => 'publish',
															'order'          => 'ASC',
															'orderby'        => 'title'
														);

														$venues_list = get_posts( $args );
														if ( ! is_array( $venue_filter_include ) ) {
															$venue_filter_include = array();
														}

														$option = "";
														foreach ( $venues_list as $venue ) {


															$option .= '<option value="' . $venue->ID . '"';
															if ( in_array( $venue->ID, $venue_filter_include ) ) {
																$option .= ' selected="selected"';
															}

															$option .= ' >' . $venue->post_title . '</option>';

														}
														echo $option; ?>
                                                    </select>
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Select specific venues to display. To select multiple venues, keep pressing ctrl key.', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Show X in dates with events?', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="checkbox" name="show_x" class="checkbox"
                                                           id="coreftCalendar_show_x" value="1"
													       <?php if ( $show_x ) { ?>checked="checked" <?php } ?> />
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Show an "X" instead of the number of events in a date.', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Show Events Title?', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="checkbox" name="show_titles_monthly" class="checkbox"
                                                           id="coreftCalendar_show_titles_monthly" value="1"
													       <?php if ( $show_titles_monthly ) { ?>checked="checked" <?php } ?> />
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Display the event titles in the calendar layout', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Show Events Preview?', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="checkbox" name="show_preview" class="checkbox"
                                                           id="coreftCalendar_show_preview" value="1"
													       <?php if ( $show_preview ) { ?>checked="checked" <?php } ?> />
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Display a list of event in a day on mouse over', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Show References Button?', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="checkbox" name="show_references" class="checkbox"
                                                           id="coreftCalendar_show_references" value="1"
													       <?php if ( $show_references ) { ?>checked="checked" <?php } ?> />
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Display the references button', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Display the Event Author', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="checkbox" name="show_author" class="checkbox"
                                                           id="coreftCalendar_show_author" value="1"
													       <?php if ( $show_author ) { ?>checked="checked" <?php } ?> />
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Display the event author', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Current Date Color', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <div id="currentDate_colorSelector" class="colorSelector">
                                                        <div style="background-color: <?php echo $current_date_color ?>"></div>
                                                    </div>
                                                    <input type="hidden" name="current_date_color"
                                                           id="coreftCalendar_current_date_color"
                                                           value="<?php echo $current_date_color ?>"/>
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Set the Current date color.', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-select no_border">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Width', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="text" name="width" id="coreftCalendar_width"
                                                           maxlength="4" style="width:50px; float: left;"
                                                           class="large-text" value="<?php echo $width ?>"/>
                                                    <select name="width_unity" id="coreftCalendar_width_unity"
                                                            style="width:60px;" class="large-text">
                                                        <option value="px" <?php if ( $width_unity == 'px' ) { ?> selected="selected" <?php } ?>>
                                                            px (<?php _e( 'pixels', 'coreftCalendar' ); ?>)
                                                        </option>
                                                        <option value="%" <?php if ( $width_unity == '%' ) { ?> selected="selected" <?php } ?>>
                                                            % (<?php _e( 'percentage', 'coreftCalendar' ); ?>)
                                                        </option>
                                                    </select>
                                                    <br>
                                                </div>
                                                <div class="desc"
                                                     style="width: 400px;"><?php _e( 'Set the width of the calendar', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>
                                </div>

                                <h2 class="subtitle accordion_title"
                                    onclick="showAccordion('div_user_events', this);"><?php _e( 'User\'s Events', 'coreftCalendar' ); ?></h2>

                                <div id="div_user_events" style="display: none;">
                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Allow users to add events?', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="checkbox" name="allow_user_add_event"
                                                           onclick="toggleNewEventRoles();" class="checkbox"
                                                           id="coreftCalendar_allow_user_add_event" value="1"
													       <?php if ( $allow_user_add_event ) { ?>checked="checked" <?php } ?> />
                                                    <br>
													<?php if ( ! is_array( $allow_user_add_event_roles ) ) {
														$allow_user_add_event_roles = array();
													} ?>
                                                    <select name='allow_user_add_event_roles[]'
                                                            id="allow_user_add_event_roles" multiple="multiple"
                                                            class="multiple">
                                                        <option value="all" <?php if ( empty( $allow_user_add_event_roles ) || $allow_user_add_event_roles == "" || in_array( 'all', $allow_user_add_event_roles ) ) {
															echo 'selected="selected"';
														} ?>><?php _e( 'All', 'coreftCalendar' ); ?></option>
														<?php
														$user_roles     = '';
														$editable_roles = get_editable_roles();

														foreach ( $editable_roles as $role => $details ) {
															$name = translate_user_role( $details['name'] );

															if ( in_array( $role, $allow_user_add_event_roles ) ) // preselect specified role
															{
																$user_roles .= "\n\t<option selected='selected' value='" . esc_attr( $role ) . "'>$name</option>";
															} else {
																$user_roles .= "\n\t<option value='" . esc_attr( $role ) . "'>$name</option>";
															}
														}
														echo $user_roles;
														?>
                                                    </select>
                                                </div>
                                                <div class="desc"><?php _e( 'Adds the possibility for registered users to add events. Select multiple user roles using the ctrl key.', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Assign new events from a non-logged in user to an admin', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <select name="assign_events_admin"
                                                            id="coreftCalendar_assign_events_admin">
                                                        <option value=""
														        <?php if ( empty( $assign_events_admin ) ) { ?>selected="selected"<?php } ?>><?php _e( 'None', 'coreftCalendar' ); ?></option>
														<?php
														$users = get_users( 'role=administrator' );
														foreach ( $users as $user ) {
															$option = '<option value="' . $user->ID . '" ';
															if ( $user->ID == $assign_events_admin ) {
																$option .= 'selected="selected"';
															}
															$option .= '>';
															$option .= $user->display_name;
															$option .= '</option>';
															echo $option;
														}
														?>
                                                    </select>
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'This will allow non-logged in users to submit new events.', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Allow users to edit their events?', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="checkbox" name="allow_user_edit_event" class="checkbox"
                                                           id="coreftCalendar_allow_user_edit_event" value="1"
													       <?php if ( $allow_user_edit_event ) { ?>checked="checked" <?php } ?> />
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Adds the possibility for logged in users to edit their events.', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Allow users to remove their events?', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="checkbox" name="allow_user_remove_event"
                                                           class="checkbox" id="coreftCalendar_allow_user_remove_event"
                                                           value="1"
													       <?php if ( $allow_user_remove_event ) { ?>checked="checked" <?php } ?> />
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Adds the possibility for logged in users to remove their events.', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Publish automatically?', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="checkbox" name="publish_new_event" class="checkbox"
                                                           id="coreftCalendar_publish_new_event" value="1"
													       <?php if ( $publish_new_event ) { ?>checked="checked" <?php } ?> />
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Publish events submitted by users automatically?', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-select option_w">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Email that will receive the user after publishing the event', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="checkbox" name="new_event_email_enable"
                                                           class="checkbox" value="1"
													       <?php if ( $new_event_email_enable ) { ?>checked="checked" <?php } ?> /> <?php _e( 'Enable?', 'coreftCalendar' ); ?>
                                                    <br>
                                                    <textarea cols="20" rows="5"
                                                              name='new_event_email_template_published'><?php echo $new_event_email_template_published ?></textarea>
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Template of the email that will receive the user. Use the reserved tags to display dynamic data.', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Send Email to Admin when a user submits a new event', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="checkbox" name="email_admin_new_event" class="checkbox"
                                                           id="coreftCalendar_email_admin_new_event" value="1"
													       <?php if ( $email_admin_new_event ) { ?>checked="checked" <?php } ?> />
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Email will be sent to (' . get_bloginfo( 'admin_email' ) . ')', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Enable Text Editor', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="checkbox" name="form_text_editor" class="checkbox"
                                                           id="coreftCalendar_form_text_editor" value="1"
													       <?php if ( $form_text_editor ) { ?>checked="checked" <?php } ?> />
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Enables the text editor in the frontend form.', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox no_border">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Form Customization', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="checkbox" name="form_show_end_date" class="checkbox"
                                                           id="coreftCalendar_form_show_end_date" value="1"
													       <?php if ( $form_show_end_date ) { ?>checked="checked" <?php } ?> /> <?php _e( 'Show End date', 'coreftCalendar' ); ?>
                                                    <br>
                                                    <input type="checkbox" name="form_show_start_time" class="checkbox"
                                                           id="coreftCalendar_form_show_start_time" value="1"
													       <?php if ( $form_show_start_time ) { ?>checked="checked" <?php } ?> /> <?php _e( 'Show Start Time', 'coreftCalendar' ); ?>
                                                    <br>
                                                    <input type="checkbox" name="form_show_end_time" class="checkbox"
                                                           id="coreftCalendar_form_show_end_time" value="1"
													       <?php if ( $form_show_end_time ) { ?>checked="checked" <?php } ?> /> <?php _e( 'Show End Time', 'coreftCalendar' ); ?>
                                                    <br>
                                                    <input type="checkbox" name="form_show_extra_dates" class="checkbox"
                                                           id="coreftCalendar_form_show_extra_dates" value="1"
													       <?php if ( $form_show_extra_dates ) { ?>checked="checked" <?php } ?> /> <?php _e( 'Show Extra Dates', 'coreftCalendar' ); ?>
                                                    <br>
                                                    <input type="checkbox" name="form_show_description" class="checkbox"
                                                           id="coreftCalendar_form_show_description" value="1"
													       <?php if ( $form_show_description ) { ?>checked="checked" <?php } ?> /> <?php _e( 'Show Event Decription', 'coreftCalendar' ); ?>
                                                    <br>
                                                    <input type="checkbox" name="form_show_category" class="checkbox"
                                                           id="coreftCalendar_form_show_category" value="1"
													       <?php if ( $form_show_category ) { ?>checked="checked" <?php } ?> /> <?php _e( 'Show Category Dropdown', 'coreftCalendar' ); ?>
                                                    <br>
                                                    <input type="checkbox" name="form_show_hide_time" class="checkbox"
                                                           id="coreftCalendar_form_show_hide_time" value="1"
													       <?php if ( $form_show_hide_time ) { ?>checked="checked" <?php } ?> /> <?php _e( 'Show \'Hide Time\' option', 'coreftCalendar' ); ?>
                                                    <br>
                                                    <input type="checkbox" name="form_show_frequency" class="checkbox"
                                                           id="coreftCalendar_form_show_frequency" value="1"
													       <?php if ( $form_show_frequency ) { ?>checked="checked" <?php } ?> /> <?php _e( 'Show Frequency', 'coreftCalendar' ); ?>
                                                    <br>
                                                    <input type="checkbox" name="form_show_all_day" class="checkbox"
                                                           id="coreftCalendar_form_show_all_day" value="1"
													       <?php if ( $form_show_all_day ) { ?>checked="checked" <?php } ?> /> <?php _e( 'Show All Day option', 'coreftCalendar' ); ?>
                                                    <br>
                                                    <input type="checkbox" name="form_show_image" class="checkbox"
                                                           id="coreftCalendar_form_show_image" value="1"
													       <?php if ( $form_show_image ) { ?>checked="checked" <?php } ?> /> <?php _e( 'Allow to upload an image', 'coreftCalendar' ); ?>
                                                    <br>
                                                    <input type="checkbox" name="form_show_link" class="checkbox"
                                                           id="coreftCalendar_form_show_link" value="1"
													       <?php if ( $form_show_link ) { ?>checked="checked" <?php } ?> /> <?php _e( 'Show Link field', 'coreftCalendar' ); ?>
                                                    <br>
                                                    <input type="checkbox" name="form_show_location" class="checkbox"
                                                           id="coreftCalendar_form_show_location" value="1"
													       <?php if ( $form_show_location ) { ?>checked="checked" <?php } ?> /> <?php _e( 'Show Location / Venue dropdown', 'coreftCalendar' ); ?>
                                                    <br>
                                                    <input type="checkbox" name="form_show_location_options"
                                                           class="checkbox"
                                                           id="coreftCalendar_form_show_location_options" value="1"
													       <?php if ( $form_show_location_options ) { ?>checked="checked" <?php } ?> /> <?php _e( 'Allow users to add new locations / venues', 'coreftCalendar' ); ?>
                                                    <br>
                                                    <input type="checkbox" name="form_show_phone" class="checkbox"
                                                           id="coreftCalendar_form_show_phone" value="1"
													       <?php if ( $form_show_phone ) { ?>checked="checked" <?php } ?> /> <?php _e( 'Show Phone option', 'coreftCalendar' ); ?>
                                                    <br>
                                                    <!--<input type="checkbox" name="form_show_map" class="checkbox" id="coreftCalendar_form_show_map" value="1" <?php if ( $form_show_map ) { ?>checked="checked" <?php } ?> /> <?php _e( 'Show Map option', 'coreftCalendar' ); ?>
                                    <br>-->
                                                    <input type="checkbox" name="form_show_color" class="checkbox"
                                                           id="coreftCalendar_form_show_color" value="1"
													       <?php if ( $form_show_color ) { ?>checked="checked" <?php } ?> /> <?php _e( 'Show \'Color\' option', 'coreftCalendar' ); ?>
                                                    <br>
                                                    <input type="checkbox" name="form_show_timezone" class="checkbox"
                                                           id="coreftCalendar_form_show_timezone" value="1"
													       <?php if ( $form_show_timezone ) { ?>checked="checked" <?php } ?> /> <?php _e( 'Show Timezone', 'coreftCalendar' ); ?>
                                                    <br>
                                                    <input type="checkbox" name="form_show_booking_enable"
                                                           class="checkbox" id="coreftCalendar_form_show_booking_enable"
                                                           value="1"
													       <?php if ( $form_show_booking_enable ) { ?>checked="checked" <?php } ?> /> <?php _e( 'Show Booking Enable checkbox', 'coreftCalendar' ); ?>
                                                    <br>
                                                    <input type="checkbox" name="form_show_booking_limit"
                                                           class="checkbox" id="coreftCalendar_form_show_booking_limit"
                                                           value="1"
													       <?php if ( $form_show_booking_limit ) { ?>checked="checked" <?php } ?> /> <?php _e( 'Show Booking Limit', 'coreftCalendar' ); ?>
                                                    <br>
                                                    <input type="checkbox" name="form_show_booking_price"
                                                           class="checkbox" id="coreftCalendar_form_show_booking_price"
                                                           value="1"
													       <?php if ( $form_show_booking_price ) { ?>checked="checked" <?php } ?> /> <?php _e( 'Show Booking Price', 'coreftCalendar' ); ?>
                                                    <br>
                                                    <input type="checkbox" name="form_show_booking_block_hours"
                                                           class="checkbox"
                                                           id="coreftCalendar_form_show_booking_block_hours" value="1"
													       <?php if ( $form_show_booking_block_hours ) { ?>checked="checked" <?php } ?> /> <?php _e( 'Show Booking Block Hours', 'coreftCalendar' ); ?>
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Customize the frontend form', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Custom Fields', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <select name='form_custom_fields[]' id="form_custom_fields"
                                                            multiple="multiple" class="multiple">
                                                        <option value="all" <?php if ( empty( $form_custom_fields ) || $form_custom_fields == "" || in_array( 'all', $form_custom_fields_arr ) ) {
															echo 'selected="selected"';
														} ?>><?php _e( 'All', 'coreftCalendar' ); ?></option>
														<?php
														$custom_fields_option = "";
														print_r( $form_custom_fields_arr );
														if ( is_array( $coreftCalendar['custom_fields_counter'] ) ) {
															$counter = 0;
															foreach ( $coreftCalendar['custom_fields_counter'] as $key ) {
																$name     = $coreftCalendar['custom_fields']['name'][ $counter ];
																$field_id = $coreftCalendar['custom_fields']['id'][ $counter ];

																if ( in_array( $field_id, $form_custom_fields_arr ) ) // preselect specified role
																{
																	$custom_fields_option .= "\n\t<option selected='selected' value='" . esc_attr( $field_id ) . "'>$name</option>";
																} else {
																	$custom_fields_option .= "\n\t<option value='" . esc_attr( $field_id ) . "'>$name</option>";
																}

																$counter ++;
															}
														}
														echo $custom_fields_option;
														?>
                                                    </select>
                                                </div>
                                                <div class="desc"><?php _e( 'Select multiple custom fields using the ctrl key.', 'coreftCalendar' ); ?></div>
                                                <br>
                                                <p><?php _e( 'Add custom fields from the <a href="' . admin_url( 'admin.php?page=coreftCalendar-settings' ) . '" target="_blank">
General settings</a>.', 'coreftCalendar' ); ?></p>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                </div>

                                <h2 class="subtitle accordion_title"
                                    onclick="showAccordion('div_booking', this);"><?php _e( 'Booking', 'coreftCalendar' ); ?></h2>

                                <div id="div_booking" style="display: none;">

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Enable booking for all the events', 'coreftCalendar' ); ?>
                                                <span class="coreft_info dashicons dashicons-info"><span><?php _e( 'If you only want bookings in specific events, uncheck this option and use the event\'s booking setting instead.', 'coreftCalendar' ); ?></span></span>
                                            </label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="checkbox" name="booking_enable" class="checkbox"
                                                           id="coreftCalendar_booking_enable" value="1"
													       <?php if ( $booking_enable ) { ?>checked="checked" <?php } ?> />
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'A "Book Event" button will be displayed.', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Allow not logged in users to book an event', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="checkbox" name="booking_non_logged" class="checkbox"
                                                           id="coreftCalendar_booking_non_logged" value="1"
													       <?php if ( $booking_non_logged ) { ?>checked="checked" <?php } ?> />
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'A Full name and email field will be required in the booking form.', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Allow logged in users to cancel a booking', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="checkbox" name="booking_cancel" class="checkbox"
                                                           id="coreftCalendar_booking_cancel" value="1"
													       <?php if ( $booking_cancel ) { ?>checked="checked" <?php } ?> />
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Logged in users will see a button to cancel a booking.', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Display attendees counter?', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="checkbox" name="booking_display_attendees"
                                                           class="checkbox"
                                                           id="coreftCalendar_booking_display_attendees" value="1"
													       <?php if ( $booking_display_attendees ) { ?>checked="checked" <?php } ?> />
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'An attendees counter will be displayed in the frontend.', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Display attendees names?', 'coreftCalendar' ); ?>
                                                <span class="coreft_info dashicons dashicons-info"><span><?php _e( 'The list of attendees will be displayed on mouse hover over the attendees counter.', 'coreftCalendar' ); ?></span></span>
                                            </label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="checkbox" name="booking_display_attendees_names"
                                                           class="checkbox"
                                                           id="coreftCalendar_booking_display_attendees_names" value="1"
													       <?php if ( $booking_display_attendees_names ) { ?>checked="checked" <?php } ?> />
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'A list of attendees will be displayed in the frontend.', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Display Fully Booked label?', 'coreftCalendar' ); ?>
                                            </label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="checkbox" name="booking_display_fully_booked"
                                                           class="checkbox"
                                                           id="coreftCalendar_booking_display_fully_booked" value="1"
													       <?php if ( $booking_display_fully_booked ) { ?>checked="checked" <?php } ?> />
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'A fully Booked label will be displayed in some layouts.', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Display Phone field?', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="checkbox" name="booking_show_phone" class="checkbox"
                                                           id="coreftCalendar_booking_show_phone" value="1"
													       <?php if ( $booking_show_phone ) { ?>checked="checked" <?php } ?> />
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Display a phone field for users in the booking form.', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Enable comment option in booking form', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="checkbox" name="booking_comment" class="checkbox"
                                                           id="coreftCalendar_booking_comment" value="1"
													       <?php if ( $booking_comment ) { ?>checked="checked" <?php } ?> />
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Enables a comment text field.', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Custom Fields', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <select name='booking_custom_fields[]' id="booking_custom_fields"
                                                            multiple="multiple" class="multiple">
                                                        <option value="all" <?php if ( empty( $booking_custom_fields ) || $booking_custom_fields == "" || in_array( 'all', $booking_custom_fields_arr ) ) {
															echo 'selected="selected"';
														} ?>><?php _e( 'All', 'coreftCalendar' ); ?></option>
														<?php
														$custom_fields_option = "";
														if ( is_array( $coreftCalendar['booking_custom_fields_counter'] ) ) {
															$counter = 0;
															foreach ( $coreftCalendar['booking_custom_fields_counter'] as $key ) {
																$name     = $coreftCalendar['booking_custom_fields']['name'][ $counter ];
																$field_id = $coreftCalendar['booking_custom_fields']['id'][ $counter ];

																if ( in_array( $field_id, $booking_custom_fields_arr ) ) // preselect specified role
																{
																	$custom_fields_option .= "\n\t<option selected='selected' value='" . esc_attr( $field_id ) . "'>$name</option>";
																} else {
																	$custom_fields_option .= "\n\t<option value='" . esc_attr( $field_id ) . "'>$name</option>";
																}

																$counter ++;
															}
														}
														echo $custom_fields_option;
														?>
                                                    </select>
                                                </div>
                                                <div class="desc"><?php _e( 'Select multiple custom fields using the ctrl key.', 'coreftCalendar' ); ?></div>
                                                <br>
                                                <p><?php _e( 'Add custom fields from the <a href="' . admin_url( 'admin.php?page=coreftCalendar-settings' ) . '" target="_blank">
General settings</a>.', 'coreftCalendar' ); ?></p>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Show remaining tickets?', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="checkbox" name="booking_show_remaining"
                                                           class="checkbox" id="coreftCalendar_booking_show_remaining"
                                                           value="1"
													       <?php if ( $booking_show_remaining ) { ?>checked="checked" <?php } ?> />
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Show the number of remaining tickets in the booking form.', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Max number of bookings by user per event', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="number" min="1" max="99" name="booking_max_quantity"
                                                           id="coreftCalendar_booking_max_quantity"
                                                           value="<?php echo $booking_max_quantity ?>"/>
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'The max quantity of bookings by user in a single event / date.', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Max number of upcoming dates', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="number" min="1" max="99"
                                                           name="booking_max_upcoming_dates"
                                                           id="coreftCalendar_booking_max_upcoming_dates"
                                                           value="<?php echo $booking_max_upcoming_dates ?>"/>
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'The max number of upcoming dates on each event\'s date dropdown.', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-select option_w">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Email that will receive the user after booking', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <textarea cols="20" rows="5"
                                                              name='booking_email_template_user'><?php echo $booking_email_template_user ?></textarea>
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Template of the email that will receive the user. Use the reserved tags to display dynamic data. (#USERNAME#, #USEREMAIL, #USERPHONE#, #COMMENT#, #EVENT_DETAILS#, #SITE_NAME#', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-select option_w">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Email that will receive the user if the booking is canceled', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="checkbox" name="booking_cancel_email_enable"
                                                           class="checkbox" value="1"
													       <?php if ( $booking_cancel_email_enable ) { ?>checked="checked" <?php } ?> /> <?php _e( 'Enable?', 'coreftCalendar' ); ?>
                                                    <br>
                                                    <textarea cols="20" rows="5"
                                                              name='booking_cancel_email_template'><?php echo $booking_cancel_email_template ?></textarea>
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Template of the email that will receive the user. Use the reserved tags to display dynamic data. (#USERNAME#, #USEREMAIL, #USERPHONE#, #COMMENT#, #EVENT_DETAILS#, #CANCEL_REASON#, #SITE_NAME#', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-select option_w">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Email that will receive the event author when a user purchases a booking', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <textarea cols="20" rows="5"
                                                              name='booking_email_template_admin'><?php echo $booking_email_template_admin ?></textarea>
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Template of the email that will receive the event author. Use the reserved tags to display dynamic data. (#USERNAME#, #USEREMAIL, #USERPHONE#, #COMMENT#, #EVENT_DETAILS#, #SITE_NAME#)', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-select option_w">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Email that will receive the user as a reminder before the event', 'coreftCalendar' ); ?>
                                                <span class="coreft_info dashicons dashicons-info"><span><?php _e( 'Reminders are sent 3 days before the event starts.', 'coreftCalendar' ); ?></span></span>
                                            </label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <textarea cols="20" rows="5"
                                                              name='booking_email_template_reminder_user'><?php echo $booking_email_template_reminder_user ?></textarea>
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Template of the email reminder that will receive the user before the event. Use the reserved tags to display dynamic data. (#USERNAME#, #USEREMAIL, #COMMENT#, #EVENT_DETAILS#, #SITE_NAME#', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <!--
                    <div class="option option-checkbox">
                        <div class="option-inner">
                            <label class="titledesc"><?php _e( 'Booked Event Color', 'coreftCalendar' ); ?></label>
                            <div class="formcontainer">
                                <div class="forminp">
                                    <div id="bookedEvent_colorSelector" class="colorSelector"><div style="background-color: <?php echo $booking_event_color ?>"></div></div>
                                    <input type="hidden" name="booking_event_color" id="coreftCalendar_booking_event_color" value="<?php echo $booking_event_color ?>" />
                                    <br>
                                </div>
                                <div class="desc"><?php _e( 'Set the booked event color.', 'coreftCalendar' ); ?></div>
                            </div>
                        </div>
                    </div>
                    <div class="clear"></div>
                	-->
                                </div>

                                <h2 class="subtitle accordion_title"
                                    onclick="showAccordion('div_translations', this);"><?php _e( 'Translations / Multi Language', 'coreftCalendar' ); ?></h2>

                                <div id="div_translations" style="display: none;">

                                    <div id="div_translations_ml">
                                        <div class="option option-select">
                                            <div class="option-inner">
                                                <label class="titledesc"><?php _e( 'Enable Multi language / use .PO file', 'coreftCalendar' ); ?></label>
                                                <div class="formcontainer">
                                                    <div class="forminp">
                                                        <input type="checkbox" name="enable_wpml"
                                                               id="coreftCalendar_enable_wpml"
                                                               onclick="toggleTranslations();" class="checkbox"
                                                               value="1"
														       <?php if ( $enable_wpml ) { ?>checked="checked" <?php } ?> />
                                                        <br>
                                                    </div>
                                                    <div class="desc"><?php _e( 'Use PO files in the /languages/ folder to translate the plugin texts.', 'coreftCalendar' ); ?></div>

                                                    <div class="errorCustom"><p><?php _e( 'Notice: The Multi language feature requires the <a href="https://wpml.org/?aid=86607&affiliate_key=pCq9y9jsvJMt" target="_blank">
Wordpress Multi Language plugin</a>.', 'coreftCalendar' ); ?></p></div>
                                                </div>
                                            </div>
                                        </div>
                                        <div class="clear"></div>
                                    </div>

                                    <div id="div_translations_fields">

										<?php foreach ( $coreftCalendar_class->translation as $key => $value ) { ?>

											<?php if ( is_array( $coreftCalendar_class->translation[ $key ] ) ) {
												foreach ( $coreftCalendar_class->translation[ $key ] as $key2 => $value2 ) {
													?>
                                                    <div class="option option-select">
                                                        <div class="option-inner">
                                                            <label class="titledesc"><?php echo $value2 ?></label>
                                                            <div class="formcontainer">
                                                                <div class="forminp">
                                                                    <input type="text"
                                                                           name="translation_fields[<?php echo strtolower( $key ) ?>][<?php echo strtolower( $key2 ) ?>]"
                                                                           class="large-text"
                                                                           value="<?php echo htmlentities( $coreftCalendar_class->translation[ $key ][ $key2 ] ) ?>"/>
                                                                    <br>
                                                                </div>
                                                                <div class="desc"></div>
                                                            </div>
                                                        </div>
                                                    </div>
                                                    <div class="clear"></div>
													<?php
												}
												continue;
											}
											?>
                                            <div class="option option-select">
                                                <div class="option-inner">
                                                    <label class="titledesc"><?php echo $coreftCalendar_class->translation_orig[ $key ] ?></label>
                                                    <div class="formcontainer">
                                                        <div class="forminp">
                                                            <input type="text"
                                                                   name="translation_fields[<?php echo strtolower( $key ) ?>]"
                                                                   class="large-text"
                                                                   value="<?php echo htmlentities( $coreftCalendar_class->translation[ $key ] ) ?>"/>
                                                            <br>
                                                        </div>
                                                        <div class="desc"></div>
                                                    </div>
                                                </div>
                                            </div>
                                            <div class="clear"></div>
										<?php } ?>

                                    </div>
                                </div>

                                <h2 class="subtitle accordion_title"
                                    onclick="showAccordion('div_sync', this);"><?php _e( 'Sync iCal Feed / Facebook Events', 'coreftCalendar' ); ?></h2>

                                <div id="div_sync" style="display: none;">

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Enable Sync', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="checkbox" name="sync_ical_enable"
                                                           id="coreftCalendar_sync_ical_enable" class="checkbox"
													       <?php if ( $sync_ical_enable ) { ?>checked="checked" <?php } ?>
                                                           value="1"/>
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'On/Off the sync feature for this calendar.', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'iCal URL', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="text" name="sync_ical_url"
                                                           id="coreftCalendar_sync_ical_url" class="large-text"
                                                           value="<?php echo $sync_ical_url ?>"/>
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'The events will be synced with this iCal Feed. For multiple feeds, separate them with commas.', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Facebook Page', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="text" name="sync_fb_page"
                                                           id="coreftCalendar_sync_fb_page" class="large-text"
                                                           value="<?php echo $sync_fb_page ?>"/>
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Introduce the Facebook Page ID or URL. For multiple Facebook pages, separate them with commas.', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Category', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <select name="sync_ical_category"
                                                            id="coreftCalendar_sync_ical_category">
                                                        <option value="0"><?php _e( 'None', 'coreftCalendar' ); ?></option>
														<?php
														$categories = get_categories( 'taxonomy=coreft_events_category&hide_empty=0' );
														if ( is_array( $categories ) ) {
															foreach ( $categories as $category ) {
																$option = '<option value="' . $category->term_id . '" ' . ( $sync_ical_category == $category->term_id ? 'selected="selected"' : '' ) . '>';
																$option .= $category->cat_name;
																$option .= ' (' . $category->category_count . ')';
																$option .= '</option>';
																echo $option;
															}
														} ?>
                                                    </select>
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Select a category to import events (optional)', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Sync Frequency', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <select name="sync_ical_frequency"
                                                            id="coreftCalendar_sync_ical_frequency">
                                                        <option value="hourly" <?php if ( $sync_ical_frequency == 'hourly' ) { ?> selected="selected" <?php } ?>><?php _e( 'Hourly', 'coreftCalendar' ); ?></option>
                                                        <option value="twicedaily" <?php if ( $sync_ical_frequency == 'twicedaily' ) { ?> selected="selected" <?php } ?>><?php _e( 'Twice Daily', 'coreftCalendar' ); ?></option>
                                                        <option value="daily" <?php if ( $sync_ical_frequency == 'daily' ) { ?> selected="selected" <?php } ?>><?php _e( 'Daily', 'coreftCalendar' ); ?></option>
                                                    </select>
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'Select the sync recurrence', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>

                                </div>

                                <h2 class="subtitle accordion_title"
                                    onclick="showAccordion('div_cache', this);"><?php _e( 'Cache', 'coreftCalendar' ); ?></h2>

                                <div id="div_cache" style="display: none;">
                                    <div class="option option-checkbox">
                                        <div class="option-inner">
                                            <label class="titledesc"><?php _e( 'Enable Cache', 'coreftCalendar' ); ?></label>
                                            <div class="formcontainer">
                                                <div class="forminp">
                                                    <input type="checkbox" name="cache_active"
                                                           id="coreftCalendar_cache_active" class="checkbox"
													       <?php if ( $cache_active ) { ?>checked="checked" <?php } ?>
                                                           value="1"/>
                                                    <br>
                                                </div>
                                                <div class="desc"><?php _e( 'On/Off the cache feature for this calendar. The cache will be cleared every time you edit the calendar settings and when you add / edit an event.', 'coreftCalendar' ); ?></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clear"></div>
                                </div>

								<?php if ( is_numeric( $_GET['edit'] ) ) { ?>
                                    <h2 class="subtitle accordion_title"
                                        onclick="showAccordion('div_subscribers', this);"><?php _e( 'Subscribers', 'coreftCalendar' ); ?></h2>

                                    <div id="div_subscribers" style="display: none;">

                                        <div class="option option-checkbox no_border">
                                            <div class="option-inner">
                                                <label class="titledesc"><?php _e( 'Enable Subscribe Button', 'coreftCalendar' ); ?></label>
                                                <div class="formcontainer">
                                                    <div class="forminp">
                                                        <input type="checkbox" name="subscribe_active"
                                                               id="coreftCalendar_subscribe_active" class="checkbox"
														       <?php if ( $subscribe_active ) { ?>checked="checked" <?php } ?>
                                                               value="1"/>
                                                        <br>
                                                    </div>
                                                    <div class="desc"><?php _e( 'On/Off the "subscribe" button for this calendar', 'coreftCalendar' ); ?></div>
                                                </div>
                                            </div>
                                        </div>
                                        <div class="clear"></div>

                                        <h2><?php _e( 'List of Subscribers', 'coreftCalendar' ); ?>
                                            <a class="button" style="float: right;"
                                               href="<?php echo home_url( 'calendar-export-subscribers?calendar_id=' . coreftSanitizeData($_GET['edit'], 'absint') ) ?>"><?php _e( 'Export to CSV', 'coreftCalendar' ); ?></a>
                                        </h2>

                                        <table class="widefat" cellpadding="0" cellspacing="0" id="sort-table">
                                            <thead>
                                            <tr style="cursor:default !important;">
                                                <th><?php _e( 'Name', 'coreftCalendar' ); ?></th>
                                                <th><?php _e( 'Email', 'coreftCalendar' ); ?></th>
                                                <th><?php _e( 'Subscription Date', 'coreftCalendar' ); ?></th>
                                                <th><?php _e( 'Actions', 'coreftCalendar' ); ?></th>
                                            </tr>
                                            </thead>
                                            <tbody>
											<?php
											$querystr        = "
                            SELECT *
                            FROM $table_name_subscribers_calendar 
                            WHERE calendar = %d
                            ORDER BY subscription_date ASC
                            ";
											$subscribers_obj = $wpdb->get_results( $wpdb->prepare( $querystr, coreftSanitizeData($_GET['edit'], 'absint') ), OBJECT );
											foreach ( $subscribers_obj as $subscriber ) {
												?>
                                                <tr>
                                                    <td><?php echo $subscriber->name ?></td>
                                                    <td><?php echo $subscriber->email ?></td>
                                                    <td><?php echo $subscriber->subscription_date ?></td>
                                                    <td><input type="button"
                                                               value="<?php echo __( 'Delete', 'coreftCalendar' ) ?>"
                                                               name="delete_calendar" class="button-secondary"
                                                               onclick="if(confirm('<?php echo __( 'Are you sure that you want to remove this subscriber?', 'coreftCalendar' ) ?>')) { location.href='<?php echo admin_url( 'admin.php?page=coreftCalendar-admin&edit=' . coreftSanitizeData($_GET['edit'], 'absint') . '&delete_subscriber=' . $subscriber->id . '&noheader=true' ) ?>'; }"/>
                                                    </td>
                                                </tr>
											<?php } ?>
                                            </tbody>
                                            <tfoot>
                                            <tr style="cursor:default !important;">
                                                <th><?php _e( 'Name', 'coreftCalendar' ); ?></th>
                                                <th><?php _e( 'Email', 'coreftCalendar' ); ?></th>
                                                <th><?php _e( 'Subscription Date', 'coreftCalendar' ); ?></th>
                                                <th><?php _e( 'Actions', 'coreftCalendar' ); ?></th>
                                            </tr>
                                            </tfoot>
                                        </table>

                                        <h2 class="coreft_subsection"><?php _e( 'MailChimp Subscription', 'coreftCalendar' ); ?></h2>

                                        <div class="option option-select option_w no_border">
                                            <div class="option-inner">
                                                <label class="titledesc"><?php _e( 'API Key', 'coreftCalendar' ); ?></label>
                                                <div class="formcontainer">
                                                    <div class="forminp">
                                                        <input type='text' name='mailchimp_api' id="mailchimp_api_key"
                                                               value="<?php echo $mailchimp_api ?>"
                                                               placeholder="<?php _e( 'Introduce your MailChimp API key.', 'coreftCalendar' ); ?>"/>&nbsp;&nbsp;
                                                        <input type="button"
                                                               onclick="MailChimp_getList(); return false;"
                                                               style="width: auto;padding: 0 10px;margin: 0 !important;height: 34px;"
                                                               class="button" value="<?php _e( 'Get Lists' ) ?>"/>
                                                        <br>
                                                    </div>
                                                    <div class="desc"></div>
                                                </div>
                                            </div>
                                        </div>
                                        <div class="clear"></div>

                                        <div class="option option-select option_w no_border" id="div_mailchimp_list"
                                             style="display: <?php echo ( $mailchimp_api != "" ) ? 'block' : 'none' ?>;">
                                            <div class="option-inner">
                                                <label class="titledesc"><?php _e( 'List:', 'coreftCalendar' ); ?></label>
                                                <div class="formcontainer">
                                                    <div class="forminp" id="mailchimp_list">
                                                        <select name='mailchimp_list'>
															<?php
															if ( $mailchimp_api != "" ) {
																$return = '';
																//$mailchimp_class = new mailchimpSF_MCAPI($_POST['mailchimp_api']);

																//$retval = $mailchimp_class->lists();

																// Query String Perameters are here
																// for more reference please vizit http://developer.mailchimp.com/documentation/mailchimp/reference/lists/
																$data = array(
																	'fields' => 'lists' // total_items, _links
																);

																$url = 'https://' . substr( $mailchimp_api, strpos( $mailchimp_api, '-' ) + 1 ) . '.api.mailchimp.com/3.0/lists/';

																$result = coreftCalendar_mailchimp_curl_connect( $url, 'GET', $mailchimp_api, $data );

																if ( is_array( $result ) && ! is_wp_error( $result ) && isset($result->lists) && ! empty( $result->lists ) ) {
																	foreach ( $result->lists as $list ) {

																		?>
                                                                        <option
                                                                        value="<?php echo $list->id; ?>" <?php if ( $list->id == $mailchimp_list ) { ?>selected="selected"<?php } ?>><?php echo $list->name ?></option><?php

																	}
																}
															}
															?>
                                                        </select>
                                                        <br>
                                                    </div>
                                                    <div class="desc"><?php _e( 'Select a list to add the new suscribers.', 'coreftCalendar' ); ?></div>
                                                </div>
                                            </div>
                                        </div>
                                        <div class="clear"></div>

                                        <div class="clear"></div>
                                    </div>
								<?php } ?>

                                <p class="submit">
                                    <input type="submit" class="button-primary" value="<?php _e( 'Save' ) ?>"/>
                                    <input type="button" class="button" value="<?php _e( 'Back' ) ?>"
                                           onclick="history.back();"/>
                                </p>
                            </div>
                            <script type="text/javascript">
                                toggleFormat();
                                toggleTranslations();
                                toggleNewEventRoles();
                                toggleFormatVenues();
                                toggleFormatCategories();
                            </script>
                        </form>
                    </div>
                </div>
				<?php
				if ( isset( $calendar_id ) && is_numeric( $calendar_id ) ) {
					$coreftCalendar_class->output( true );
				}
				?>
			<?php } ?>
            <!--end of poststuff -->


        </div> <!--end of float wrap -->
        <div class="clear"></div>


	<?php
}

?>