<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly
function coreftCalendar_settings_page() {
global $coreftCalendar, $wpdb;

$max_upload = (ini_get('upload_max_filesize'));
$max_upload_kb = (int)(convertBytes($max_upload) / 1000);

if(!isset($coreftCalendar['year_from'])) {
    $coreftCalendar['year_from'] = 2;
}
if(!isset($coreftCalendar['year_until'])) {
    $coreftCalendar['year_until'] = 3;
}
?>

<div class="wrap" style="clear:both;" id="coreft_options">

<h2></h2>
<?php $url = coreftCalendar_admin_url( array( 'page' => 'coreftCalendar-admin' ) );?>

<form method="post" id="coreftCalendar_events_meta" action="options.php" enctype="multipart/form-data">
<?php settings_fields('coreftCalendar-group'); ?>
<div style="clear:both;"></div>
 <!--end of poststuff -->

    <div id="coreft_ui_content" class="coreft-nobg">

        <div id="coreftCalendarSettingsAdmin">
        	<div id="menu_general_settings">
                <div class="titleArea">
                    <div class="wrapper">
                        <div class="pageTitle">
                            <h5><?php _e('General Settings','coreftCalendar'); ?></h5>
                            <span></span>
                        </div>

                        <div class="clear"></div>
                    </div>
                </div>

                <div class="wrapper">



                    <div class="option option-select option_w">
                        <div class="option-inner">
                            <label class="titledesc"><?php _e('User Roles:','coreftCalendar'); ?></label>
                            <div class="formcontainer">
                                <div class="forminp">
                                    <select name='coreftCalendar_options[user_roles][]' multiple="multiple" class="multiple">
                                    	<option value=""><?php _e('None','coreftCalendar'); ?></option>
                                       <?php
									   $user_roles = '';
                                       $editable_roles = get_editable_roles();

								       foreach ( $editable_roles as $role => $details ) {
								           $name = translate_user_role($details['name'] );
								           if(esc_attr($role) == "administrator" || esc_attr($role) == "subscriber") { continue; }
										   if ( in_array($role, $coreftCalendar['user_roles']) ) // preselect specified role
								               $user_roles .= "\n\t<option selected='selected' value='" . esc_attr($role) . "'>$name</option>";
								           else
								               $user_roles .= "\n\t<option value='" . esc_attr($role) . "'>$name</option>";
								       }
									   echo $user_roles;
									   ?>
                                    </select>
                                    <br>
                                </div>
                                <div class="desc"><?php _e('Select the user role that will manage the plugin.','coreftCalendar'); ?></div>
                            </div>
                        </div>
                    </div>
                    <div class="clear"></div>

                    <div class="option option-select option_w">
                        <div class="option-inner">
                            <label class="titledesc"><?php _e('Events Slug:','coreftCalendar'); ?></label>
                            <div class="formcontainer">
                                <div class="forminp">
                                    <input type="text" value="<?php echo $coreftCalendar['events_slug']?>" name='coreftCalendar_options[events_slug]' class="large-text"/>
                                    <br>
                                </div>
                                <div class="desc"><?php _e('Introduce the events URL slug. Be sure that there is not any other post type using it already. <br>(Default: coreft-events)','coreftCalendar'); ?></div>
                            </div>
                        </div>
                    </div>
                    <div class="clear"></div>

                    <div class="option option-select option_w">
                        <div class="option-inner">
                            <label class="titledesc"><?php _e('Categories Slug:','coreftCalendar'); ?></label>
                            <div class="formcontainer">
                                <div class="forminp">
                                    <input type="text" value="<?php echo $coreftCalendar['categories_slug']?>" name='coreftCalendar_options[categories_slug]' class="large-text"/>
                                    <br>
                                </div>
                                <div class="desc"><?php _e('Introduce the categories URL slug. Be sure that there is not any other post type using it already. <br>(Default: coreft_events_category)','coreftCalendar'); ?></div>
                            </div>
                        </div>
                    </div>
                    <div class="clear"></div>

                    <div class="option option-select option_w">
                        <div class="option-inner">
                            <label class="titledesc"><?php _e('Redirect archive page:','coreftCalendar'); ?></label>
                            <div class="formcontainer">
                                <div class="forminp">
                                    <input type="text" value="<?php echo $coreftCalendar['redirect_archive']?>" name='coreftCalendar_options[redirect_archive]' class="large-text"/>
                                    <br>
                                </div>
                                <div class="desc"><?php _e('Introduce a custom url if you want to redirect the default archive page. ('.get_post_type_archive_link('coreft-events').')') ?></div>
                            </div>
                        </div>
                    </div>
                    <div class="clear"></div>

                    <div class="option option-select option_w">
                        <div class="option-inner">
                            <label class="titledesc"><?php _e('Email to send emails from:','coreftCalendar'); ?></label>
                            <div class="formcontainer">
                                <div class="forminp">
                                    <input type="text" value="<?php echo $coreftCalendar['wp_mail_from']?>" name='coreftCalendar_options[wp_mail_from]' class="large-text" placeholder="wordpress@<?php echo str_replace("www.", "", $_SERVER['HTTP_HOST'])?>"/>
                                    <br>
                                </div>
                                <div class="desc"></div>
                            </div>
                        </div>
                    </div>
                    <div class="clear"></div>

                    <div class="option option-select option_w">
                        <div class="option-inner">
                            <label class="titledesc"><?php _e('Custom CSS:','coreftCalendar'); ?></label>
                            <div class="formcontainer">
                                <div class="forminp">
                                    <textarea name='coreftCalendar_options[custom_css]' rows="10" placeholder=".classname {
    background: #333;
}"><?php echo $coreftCalendar['custom_css']?></textarea>
                                    <br>
                                </div>
                                <div class="desc"><?php _e('Add your custom CSS code.','coreftCalendar'); ?></div>
                            </div>
                        </div>
                    </div>
                    <div class="clear"></div>

                    <div class="option option-select option_w">
                        <div class="option-inner">
                            <label class="titledesc"><?php _e('RTL (Right-to-left) Support','coreftCalendar'); ?></label>
                            <div class="formcontainer">
                                <div class="forminp">
                                    <input type="checkbox" value="1" <?php echo ($coreftCalendar['rtl_support'] ? "checked='checked'" : "")?> name='coreftCalendar_options[rtl_support]' class="checkbox"/>
                                    <br>
                                </div>
                                <div class="desc"><?php _e('Add RTL support for the calendars.','coreftCalendar'); ?></div>
                            </div>
                        </div>
                    </div>
                    <div class="clear"></div>

                    <div class="option option-select option_w">
                        <div class="option-inner">
                            <label class="titledesc"><?php _e('Exclude Google Maps JS file?','coreftCalendar'); ?></label>
                            <div class="formcontainer">
                                <div class="forminp">
                                    <input type="checkbox" value="1" <?php echo ($coreftCalendar['exclude_gmaps'] ? "checked='checked'" : "")?> name='coreftCalendar_options[exclude_gmaps]' class="checkbox"/>
                                    <br>
                                </div>
                                <div class="desc"><?php _e('Check this option if you have a conflict with other plugins related to the Google Maps feature.','coreftCalendar'); ?></div>
                            </div>
                        </div>
                    </div>
                    <div class="clear"></div>

                    <div class="option option-select option_w">
                        <div class="option-inner">
                            <label class="titledesc"><?php _e('Disable URL Rewrite Rules?','coreftCalendar'); ?></label>
                            <div class="formcontainer">
                                <div class="forminp">
                                    <input type="checkbox" value="1" <?php echo ($coreftCalendar['disable_rewrite_rules'] ? "checked='checked'" : "")?> name='coreftCalendar_options[disable_rewrite_rules]' class="checkbox"/>
                                    <br>
                                </div>
                                <div class="desc"><?php _e('Select this option if you have unexpected 404 error pages in your site.','coreftCalendar'); ?></div>
                            </div>
                        </div>
                    </div>
                    <div class="clear"></div>

                    <div class="option option-select option_w">
                        <div class="option-inner">
                            <label class="titledesc"><?php _e('Disable Reminders?','coreftCalendar'); ?></label>
                            <div class="formcontainer">
                                <div class="forminp">
                                    <input type="checkbox" value="1" <?php echo ($coreftCalendar['disable_reminders'] ? "checked='checked'" : "")?> name='coreftCalendar_options[disable_reminders]' class="checkbox"/>
                                    <br>
                                </div>
                                <div class="desc"><?php _e('Disable booking reminders for all calendars.','coreftCalendar'); ?></div>
                            </div>
                        </div>
                    </div>
                    <div class="clear"></div>

                    <div class="option option-select option_w">
                        <div class="option-inner">
                            <label class="titledesc"><?php _e('Send reminders','coreftCalendar'); ?></label>
                            <div class="formcontainer">
                                <div class="forminp">
                                    <input type="number" min="1" maxlength="2" max="99" value="<?php echo ($coreftCalendar['days_reminders'] == "" ? 3 : $coreftCalendar['days_reminders'])?>" name='coreftCalendar_options[days_reminders]' class="large-text" style="width:50px;" /> <?php _e('Days before the event starts','coreftCalendar'); ?>
                                    <br>
                                </div>
                                <div class="desc"><?php _e('Amount of days prior to the event to send the reminders.','coreftCalendar'); ?></div>
                            </div>
                        </div>
                    </div>
                    <div class="clear"></div>

                    <div class="option option-select option_w">
                        <div class="option-inner">
                            <label class="titledesc"><?php _e('Terms & Conditions Page','coreftCalendar'); ?></label>
                            <div class="formcontainer">
                                <div class="forminp">
                                    <select name="coreftCalendar_options[terms_conditions]">
                                    	<option value=""></option>
                                        <?php
										  $pages = get_pages();
										  foreach ( $pages as $page ) {
											$option = '<option value="' . $page->ID . '" ' . ($page->ID == $coreftCalendar['terms_conditions'] ? 'selected="selected"' : '') . '>';
											$option .= $page->post_title;
											$option .= '</option>';
											echo $option;
										  }
										 ?>
                                    </select>
                                    <br>
                                </div>
                                <div class="desc"><?php _e('Select the Terms & Conditions page for booking events','coreftCalendar'); ?></div>
                            </div>
                        </div>
                    </div>
                    <div class="clear"></div>

                    <div class="option option-select option_w">
                        <div class="option-inner">
                            <label class="titledesc"><?php _e('Pagination:','coreftCalendar'); ?></label>
                            <div class="formcontainer">
                                <div class="forminp">
                                    <input type="number" min="1" maxlength="2" max="99" value="<?php echo ($coreftCalendar['pagination'] == "" ? 10 : $coreftCalendar['pagination'])?>" name='coreftCalendar_options[pagination]' class="large-text" style="width:50px;" />
                                    <br>
                                </div>
                                <div class="desc"><?php _e('Set the number of items to display per page.','coreftCalendar'); ?></div>
                            </div>
                        </div>
                    </div>
                    <div class="clear"></div>

                    <div class="option option-select option_w">
                        <div class="option-inner">
                            <label class="titledesc"><?php _e('Max image size:','coreftCalendar'); ?></label>
                            <div class="formcontainer">
                                <div class="forminp">
                                    <input type="number" min="1" maxlength="10" max="<?php echo $max_upload_kb?>" value="<?php echo $coreftCalendar['max_file_size']?>" name='coreftCalendar_options[max_file_size]' placeholder='<?php echo $max_upload_kb?>' class="large-text" />
                                    <br>
                                </div>
                                <div class="desc"><?php _e('Set the max size in kb for the image upload in frontend forms. Leave blank to use server limit.','coreftCalendar'); ?> <?php _e('Max','coreftCalendar'); ?>: <?php echo $max_upload_kb?>kb</div>
                            </div>
                        </div>
                    </div>
                    <div class="clear"></div>

                    <div class="option option-select option_w">
                        <div class="option-inner">
                            <label class="titledesc"><?php _e('Year range:','coreftCalendar'); ?></label>
                            <div class="formcontainer">
                                <div class="forminp" id="div_year_range">
                                    <select name='coreftCalendar_options[year_from]'>
                                    <?php for($i = 10; $i >= 1; $i--) {?>
                                        <option value="<?php echo $i?>" <?php echo ($coreftCalendar['year_from'] == $i ? 'selected="selected"' : '')?>><?php echo (date('Y') - $i) . ' (-'.$i.')'?></option>
                                    <?php }?>
                                    </select>
                                    &nbsp;
                                    <select name='coreftCalendar_options[year_until]'>
                                    <?php for($i = 1; $i <= 10; $i++) {?>
                                        <option value="<?php echo $i?>" <?php echo ($coreftCalendar['year_until'] == $i ? 'selected="selected"' : '')?>><?php echo (date('Y') + $i) . ' (+'.$i.')'?></option>
                                    <?php }?>
                                    </select>
                                </div>
                                <div class="desc"><?php _e('Set the year range used in the calendar layouts.','coreftCalendar'); ?> <?php _e('Max','coreftCalendar'); ?></div>
                            </div>
                        </div>
                    </div>
                    <div class="clear"></div>

                    <h2 class="subtitle accordion_title" id="settings_maps_title" onclick="showAccordion('div_maps', this);"><?php _e('Google Maps','coreftCalendar'); ?></h2>
                    <div id="div_maps" style="display:none;">
                        <div class="option option-select option_w">
                            <div class="option-inner">
                                <label class="titledesc"><?php _e('API Key:','coreftCalendar'); ?>
                                </label>
                                <div class="formcontainer">
                                    <div class="forminp">
                                        <input type="text" value="<?php echo $coreftCalendar['google_map_key']?>" name='coreftCalendar_options[google_map_key]' class="large-text" />
                                        <br>
                                    </div>
                                    <div class="desc"><?php _e('Create an API key as per instructions here:.','coreftCalendar'); ?>  <a href="https://developers.google.com/maps/documentation/javascript/get-api-key" target="_blank">https://developers.google.com/maps/documentation/javascript/get-api-key</a></div>
                                </div>
                            </div>
                        </div>
                        <div class="clear"></div>

                        <div class="option option-select option_w">
                            <div class="option-inner">
                                <label class="titledesc"><?php _e('Google Maps Zoom:','coreftCalendar'); ?>
                                <span class="coreft_info dashicons dashicons-info"><span><?php _e('Higher number means a closer view.','coreftCalendar'); ?></span></span>
                                </label>
                                <div class="formcontainer">
                                    <div class="forminp">
                                        <input type="number" min="1" maxlength="2" max="99" value="<?php echo ($coreftCalendar['google_map_zoom'] == "" ? 10 : $coreftCalendar['google_map_zoom'])?>" name='coreftCalendar_options[google_map_zoom]' class="large-text" style="width:50px;" />
                                        <br>
                                    </div>
                                    <div class="desc"><?php _e('Set the Google Map Zoom number.','coreftCalendar'); ?></div>
                                </div>
                            </div>
                        </div>
                        <div class="clear"></div>

                        <div class="option option-select">
                            <div class="option-inner">
                                <label class="titledesc"><?php _e('Google Map Custom Marker:','coreftCalendar'); ?></label>
                                <div class="formcontainer">
                                    <div class="forminp">
                                        <input id="coreftCalendar_options_map_marker" style="width: 350px;" type="text" class="large-text" name="coreftCalendar_options[map_marker]" value="<?php echo $coreftCalendar['map_marker']?>" placeholder="<?php _e('Enter an URL or upload an image to use a custom marker.','coreftCalendar'); ?>" />
                                    </div>
                                    <input id="upload_image_button" type="button" class="button-secondary" value="<?php _e('Upload Image','coreftCalendar'); ?>" style="width:auto; padding:auto; font-weight:normal;" />
                                    <div class="desc"></div>
                                </div>
                            </div>
                        </div>
                        <div class="clear"></div>

                        <div class="option option-select">
                            <div class="option-inner">
                                <label class="titledesc"><?php _e('Default Location:','coreftCalendar'); ?></label>
                                <div class="formcontainer">
                                    <div class="forminp">
                                        <input id="coreft_map" style="width: 350px;" type="text" class="large-text" name="coreftCalendar_options[map_default_location]" value="<?php echo $coreftCalendar['map_default_location']?>" placeholder="<?php _e('Enter a city / country to set as the default location.','coreftCalendar'); ?>" />
                                        <input id="coreft_map_lnlat" type="text" name="coreftCalendar_options[map_default_latlng]" value="<?php echo $coreftCalendar['map_default_latlng']?>" />
                                         <div class="coreft_calendar_date_event_map_overlay" onclick="style.pointerEvents='none'" style="height:400px; margin-top: -400px; top: 400px;"></div>
                                         <?php
                                        $map_lat = 0;
                                        $map_lng = 0;

                                        if($coreftCalendar['map_default_latlng'] != "") {

                                            $map_lnlat = explode(",", $coreftCalendar['map_default_latlng']);
                                            $map_lat = $map_lnlat[0];
                                            $map_lng = $map_lnlat[1];
                                        }
                                         ?>
                                        <div id="mapCanvas" data-map-lat="<?php echo $map_lat?>" data-map-lng="<?php echo $map_lng?>" style="height: 400px;"></div>
                                    </div>
                                    <div class="desc"></div>
                                </div>
                            </div>
                        </div>
                        <div class="clear"></div>
                    </div>

                    <h2 class="subtitle accordion_title" onclick="showAccordion('div_fb_api', this);"><?php _e('Facebook API Keys','coreftCalendar'); ?></h2>
                    <div id="div_fb_api" style="display:none;">

                        <div class="option option-select">
                            <div class="option-inner">
                                <label class="titledesc"><?php _e('App ID:','coreftCalendar'); ?></label>
                                <div class="formcontainer">
                                    <div class="forminp">
                                        <input type='text' name='coreftCalendar_options[facebook_app_id]' value="<?php echo $coreftCalendar['facebook_app_id']?>"/>
                                        <br>
                                    </div>
                                    <div class="desc"></div>
                                </div>
                            </div>
                        </div>
                        <div class="clear"></div>

                        <div class="option option-select no_border">
                            <div class="option-inner">
                                <label class="titledesc"><?php _e('App Secret:','coreftCalendar'); ?></label>
                                <div class="formcontainer">
                                    <div class="forminp">
                                        <input type='text' name='coreftCalendar_options[facebook_app_secret]' value="<?php echo $coreftCalendar['facebook_app_secret']?>"/>
                                        <br>
                                    </div>
                                    <div class="desc"></div>
                                </div>
                            </div>
                        </div>
                        <div class="clear"></div>


                        <strong><?php _e('Instructions to get the Facebook API keys','coreftCalendar'); ?></strong>
                        <ol>
                            <li>If you are not registered as a developer in Facebook, you will have to register in <a href="https://developers.facebook.com/">https://developers.facebook.com/</a>, go to Apps -> Register as a Developer</li>
                            <li>Once you are registered go to <a href="https://developers.facebook.com/">https://developers.facebook.com/</a> Apps -> Create a new App and fill the form</li>
                            <li>If you created the App succesfully, you will see the new App ID and Secret keys in the dashboard</li>
                        </ol>

                    </div>

                    <h2 class="subtitle accordion_title" onclick="showAccordion('div_recaptcha', this);"><?php _e('ReCaptcha','coreftCalendar'); ?></h2>

                    <div id="div_recaptcha" style="display: none;">
                        <div class="option option-select option_w">
                            <div class="option-inner">
                                <label class="titledesc"><?php _e('Enable ReCaptcha for frontend forms','coreftCalendar'); ?></label>
                                <div class="formcontainer">
                                    <div class="forminp">
                                        <input type="checkbox" value="1" <?php echo ($coreftCalendar['recaptcha_enable'] ? "checked='checked'" : "")?> name='coreftCalendar_options[recaptcha_enable]' class="checkbox"/>
                                        <br>
                                    </div>
                                    <div class="desc"><?php _e('A captcha will be displayed in some of the frontend forms. Useful to block spam bots.','coreftCalendar'); ?></div>
                                </div>
                            </div>
                        </div>
                        <div class="clear"></div>

                        <div class="option option-select">
                            <div class="option-inner">
                                <label class="titledesc"><?php _e('Site Key:','coreftCalendar'); ?></label>
                                <div class="formcontainer">
                                    <div class="forminp">
                                        <input type='text' name='coreftCalendar_options[recaptcha_site_key]' value="<?php echo $coreftCalendar['recaptcha_site_key']?>"/>
                                        <br>
                                    </div>
                                    <div class="desc"></div>
                                </div>
                            </div>
                        </div>
                        <div class="clear"></div>

                        <div class="option option-select no_border">
                            <div class="option-inner">
                                <label class="titledesc"><?php _e('Secret Key:','coreftCalendar'); ?></label>
                                <div class="formcontainer">
                                    <div class="forminp">
                                        <input type='text' name='coreftCalendar_options[recaptcha_secret_key]' value="<?php echo $coreftCalendar['recaptcha_secret_key']?>"/>
                                        <br>
                                    </div>
                                    <div class="desc"></div>
                                </div>
                            </div>
                        </div>
                        <div class="clear"></div>

                        <p><strong><?php _e('Get the Keys adding your domain in the recaptcha site:','coreftCalendar'); ?> <a href="https://www.google.com/recaptcha/intro/index.html" target="_blank">https://www.google.com/recaptcha/intro/index.html</a></strong></p>

                    </div>

                    <h2 class="subtitle accordion_title" onclick="showAccordion('div_expired', this);"><?php _e('Expired Events','coreftCalendar'); ?></h2>

                    <div id="div_expired" style="display: none;">

                        <div class="option option-select option_w no_border">
                            <div class="option-inner">
                                <label class="titledesc"><?php _e('Remove expired events automatically','coreftCalendar'); ?></label>
                                <div class="formcontainer">
                                    <div class="forminp">
                                        <input type="checkbox" value="1" <?php echo ($coreftCalendar['remove_expired_enable'] ? "checked='checked'" : "")?> name='coreftCalendar_options[remove_expired_enable]' class="checkbox"/>
                                        <br>
                                    </div>
                                    <div class="desc"><?php _e('Events which End date field has passed or the Start date has passed and it is not a recurrent event. This will also prevent importing old events.','coreftCalendar'); ?></div>
                                </div>
                            </div>
                        </div>
                        <div class="clear"></div>

                        <div class="option option-select option_w">
                            <div class="option-inner">
                                <label class="titledesc"><?php _e('Status of events','coreftCalendar'); ?></label>
                                <div class="formcontainer">
                                    <div class="forminp">
                                        <select name="coreftCalendar_options[remove_expired_status]">
                                            <option value="publish"><?php _e('Only published Events','coreftCalendar'); ?></option>
                                            <option value="any" <?php echo ('any' == $coreftCalendar['remove_expired_status'] ? 'selected="selected"' : '')?>><?php _e('Events with any status','coreftCalendar'); ?></option>
                                        </select>
                                        <br>
                                    </div>
                                    <div class="desc"><?php _e('Select if you want to remove expired events with published / any status.','coreftCalendar'); ?></div>
                                </div>
                            </div>
                        </div>
                        <div class="clear"></div>

                        <div class="option option-select option_w">
                            <div class="option-inner">
                                <label class="titledesc"><?php _e('Trash / Remove','coreftCalendar'); ?></label>
                                <div class="formcontainer">
                                    <div class="forminp">
                                        <select name="coreftCalendar_options[remove_expired_completly]">
                                            <option value="trash"><?php _e('Send to trash','coreftCalendar'); ?></option>
                                            <option value="remove" <?php echo ('remove' == $coreftCalendar['remove_expired_completly'] ? 'selected="selected"' : '')?>><?php _e('Remove completly','coreftCalendar'); ?></option>
                                        </select>
                                        <br>
                                    </div>
                                    <div class="desc"><?php _e('Select if you want to remove expired events completly or send them to the trash.','coreftCalendar'); ?></div>
                                </div>
                            </div>
                        </div>
                        <div class="clear"></div>

                        <div class="option option-select option_w">
                            <div class="option-inner">
                                <label class="titledesc"><?php _e('Expire after:','coreftCalendar'); ?></label>
                                <div class="formcontainer">
                                    <div class="forminp">
                                        <input type="number" min="0" maxlength="3" max="999" value="<?php echo ($coreftCalendar['remove_expired_days'] == "" ? 10 : $coreftCalendar['remove_expired_days'])?>" name='coreftCalendar_options[remove_expired_days]' class="large-text" style="width:50px;" /> <?php _e('Days','coreftCalendar'); ?>
                                        <br>
                                    </div>
                                    <div class="desc"></div>
                                </div>
                            </div>
                        </div>
                        <div class="clear"></div>
                    </div>

                    <!--
                    <h2 class="subtitle accordion_title" onclick="showAccordion('div_landing', this);"><?php _e('Event Landing Page (beta)','coreftCalendar'); ?></h2>

                    <div id="div_landing" style="display: none;">

                        <div class="option option-select option_w no_border">
                            <div class="option-inner">
                                <label class="titledesc"><?php _e('Enable Event Landing Page Template','coreftCalendar'); ?></label>
                                <div class="formcontainer">
                                    <div class="forminp">
                                        <input type="checkbox" value="1" <?php echo ($coreftCalendar['event_single_enable'] ? "checked='checked'" : "")?> name='coreftCalendar_options[event_single_enable]' class="checkbox"/>
                                        <br>
                                    </div>
                                    <div class="desc"><?php _e('The events single pages will be displayed with a different theme.','coreftCalendar'); ?></div>
                                </div>
                            </div>
                        </div>
                        <div class="clear"></div>
                    </div>
                    -->

                    <h2 class="subtitle accordion_title" onclick="showAccordion('div_custom_fields', this);"><?php _e('Event Custom Fields','coreftCalendar'); ?></h2>

                    <div id="div_custom_fields" style="display: none;">
                        <table class="widefat" cellpadding="0" cellspacing="0" id="custom_fields_list">
                            <thead>
                                <tr style="cursor:default !important;">
                                    <th><?php _e('ID','coreftCalendar'); ?></th>
                                    <th><?php _e('Name','coreftCalendar'); ?></th>
                                    <th><?php _e('Type','coreftCalendar'); ?></th>
                                    <th><?php _e('Optional','coreftCalendar'); ?></th>
                                    <th><?php _e('Placeholder','coreftCalendar'); ?></th>
                                    <th>&nbsp;</th>
                                 </tr>
                            </thead>
                            <tbody>
                                <tr id="custom_field_new" style="display:none;">
                                	<input type="hidden" name="coreftCalendar_options_replace[custom_fields_counter][]" value="1" />
                                    <td><input type="text" name="coreftCalendar_options_replace[custom_fields][id][]" class="coreft_custom_field_id" style="width: 100%;" placeholder="<?php _e('Introduce a lower case id wihout spaces.', 'coreftCalendar')?>" /></td>
                                    <td><input type="text" name="coreftCalendar_options_replace[custom_fields][name][]" class="" style="width: 100%;" placeholder="<?php _e('Name of the Field', 'coreftCalendar')?>" /></td>
                                    <td style="overflow: visible;">
                                    	<select name="coreftCalendar_options_replace[custom_fields][type][]">
                                        	<option value="text"><?php _e('Text Field','coreftCalendar'); ?></option>
                                            <option value="checkbox"><?php _e('Checkbox','coreftCalendar'); ?></option>
                                    	</select>
                                    </td>
                                    <td>
                                        <select name="coreftCalendar_options_replace[custom_fields][optional][]">
                                            <option value="1"><?php _e('Yes','coreftCalendar'); ?></option>
                                            <option value="0">><?php _e('No','coreftCalendar'); ?></option>
                                        </select>
                                    </td>
                                    <td><input type="text" name="coreftCalendar_options_replace[custom_fields][placeholder][]" class="" style="width: 100%;" placeholder="<?php _e('Text to display in the form', 'coreftCalendar')?>" /></td>
                                    <td>
    									<input type="button" value="<?php _e('Delete','coreftCalendar'); ?>" name="delete_custom_field" class="button-secondary" onclick="if(confirm('<?php _e('Are you sure?', 'coreftCalendar')?>')) { jQuery(this).closest('tr').remove(); }" />
                                    </td>
                                </tr>
                                <?php
    							if(is_array($coreftCalendar['custom_fields_counter'])) {
    								$counter = 0;
    								foreach($coreftCalendar['custom_fields_counter'] as $key) {
    								?>
    								<tr>
                                    	<input type="hidden" name="coreftCalendar_options[custom_fields_counter][]" value="1" />
    									<td><input type="text" name="coreftCalendar_options[custom_fields][id][]" class="coreft_custom_field_id" value="<?php echo $coreftCalendar['custom_fields']['id'][$counter]?>" style="width: 100%;" placeholder="<?php _e('Introduce a lower case id wihout spaces.', 'coreftCalendar')?>" /></td>
    									<td><input type="text" name="coreftCalendar_options[custom_fields][name][]" class="" value="<?php echo htmlentities($coreftCalendar['custom_fields']['name'][$counter])?>" style="width: 100%;" placeholder="<?php _e('Name of the Field', 'coreftCalendar')?>" /></td>
    									<td style="overflow: visible;">
    										<select name="coreftCalendar_options[custom_fields][type][]">
    											<option value="text"><?php _e('Text Field','coreftCalendar'); ?></option>
                                                <option value="checkbox" <?php echo ($coreftCalendar['custom_fields']['type'][$counter] == 'checkbox' ? 'selected="selected"' : '')?>><?php _e('Checkbox','coreftCalendar'); ?></option>
    										</select>
    									</td>
    									<td>
                                            <select name="coreftCalendar_options[custom_fields][optional][]">
                                                <option value="1"><?php _e('Yes','coreftCalendar'); ?></option>
                                                <option value="0" <?php echo ($coreftCalendar['custom_fields']['optional'][$counter] == '0' ? 'selected="selected"' : '')?>><?php _e('No','coreftCalendar'); ?></option>
                                            </select>
                                        </td>
    									<td><input type="text" name="coreftCalendar_options[custom_fields][placeholder][]" class="" value="<?php echo htmlentities($coreftCalendar['custom_fields']['placeholder'][$counter])?>" style="width: 100%;" placeholder="<?php _e('Text to display in the form', 'coreftCalendar')?>" /></td>
    									<td>
    										<input type="button" value="<?php _e('Delete','coreftCalendar'); ?>" name="delete_custom_field" class="button-secondary" onclick="if(confirm('<?php _e('Are you sure?', 'coreftCalendar')?>')) { jQuery(this).closest('tr').remove(); }" />
    									</td>
    								</tr>
    								<?php
    									$counter++;
    								}
    							} else {

    							}?>
                            </tbody>
                            <tfoot>
                                <tr style="cursor:default !important;">
                                    <th><?php _e('ID','coreftCalendar'); ?></th>
                                    <th><?php _e('Name','coreftCalendar'); ?></th>
                                    <th><?php _e('Type','coreftCalendar'); ?></th>
                                    <th><?php _e('Optional','coreftCalendar'); ?></th>
                                    <th><?php _e('Placeholder','coreftCalendar'); ?></th>
                                    <th>&nbsp;</th>
                                 </tr>
                            </tfoot>
                    	</table>

                        <div class="submit">
                            <input type="button" class="button-primary" value="<?php echo __( 'Add New', 'coreftCalendar' )?>" onclick="jQuery('#custom_fields_list tbody').append('<tr>'+jQuery('#custom_field_new').html().replace(/coreftCalendar_options_replace/g, 'coreftCalendar_options')+'</tr>'); jQuery('#custom_fields_list tbody select').selectric('refresh');" />
                        </div>
                    </div>

                    <h2 class="subtitle accordion_title" onclick="showAccordion('div_booking_fields', this);"><?php _e('Booking Extra Fields','coreftCalendar'); ?></h2>

                    <div id="div_booking_fields" style="display:none;">

                        <table class="widefat" cellpadding="0" cellspacing="0" id="booking_custom_fields_list">
                            <thead>
                                <tr style="cursor:default !important;">
                                    <th><?php _e('ID','coreftCalendar'); ?></th>
                                    <th><?php _e('Name','coreftCalendar'); ?></th>
                                    <th><?php _e('Type','coreftCalendar'); ?></th>
                                    <th><?php _e('Optional','coreftCalendar'); ?></th>
                                    <th><?php _e('Placeholder','coreftCalendar'); ?></th>
                                    <th>&nbsp;</th>
                                 </tr>
                            </thead>
                            <tbody>
                                <tr id="booking_custom_field_new" style="display:none;">
                                    <input type="hidden" name="coreftCalendar_options_replace[booking_custom_fields_counter][]" value="1" />
                                    <td><input type="text" name="coreftCalendar_options_replace[booking_custom_fields][id][]" class="coreft_booking_custom_field_id" style="width: 100%;" placeholder="<?php _e('Introduce a lower case id wihout spaces.', 'coreftCalendar')?>" /></td>
                                    <td><input type="text" name="coreftCalendar_options_replace[booking_custom_fields][name][]" class="" style="width: 100%;" placeholder="<?php _e('Name of the Field', 'coreftCalendar')?>" /></td>
                                    <td style="overflow: visible;">
                                        <select name="coreftCalendar_options_replace[booking_custom_fields][type][]">
                                            <option value="text"><?php _e('Text Field','coreftCalendar'); ?></option>
                                            <option value="checkbox"><?php _e('Checkbox','coreftCalendar'); ?></option>
                                        </select>
                                    </td>
                                    <td>
                                        <select name="coreftCalendar_options_replace[booking_custom_fields][optional][]">
                                            <option value="1"><?php _e('Yes','coreftCalendar'); ?></option>
                                            <option value="0"><?php _e('No','coreftCalendar'); ?></option>
                                        </select>
                                    </td>
                                    <td><input type="text" name="coreftCalendar_options_replace[booking_custom_fields][placeholder][]" class="" style="width: 100%;" placeholder="<?php _e('Text to display in the form', 'coreftCalendar')?>" /></td>
                                    <td>
                                        <input type="button" value="<?php _e('Delete','coreftCalendar'); ?>" name="delete_booking_custom_field" class="button-secondary" onclick="if(confirm('<?php _e('Are you sure?', 'coreftCalendar')?>')) { jQuery(this).closest('tr').remove(); }" />
                                    </td>
                                </tr>
                                <?php
                                if(is_array($coreftCalendar['booking_custom_fields_counter'])) {
                                    $counter = 0;
                                    foreach($coreftCalendar['booking_custom_fields_counter'] as $key) {
                                    ?>
                                    <tr>
                                        <input type="hidden" name="coreftCalendar_options[booking_custom_fields_counter][]" value="1" />
                                        <td><input type="text" name="coreftCalendar_options[booking_custom_fields][id][]" class="coreft_booking_custom_field_id" value="<?php echo $coreftCalendar['booking_custom_fields']['id'][$counter]?>" style="width: 100%;" placeholder="<?php _e('Introduce a lower case id wihout spaces.', 'coreftCalendar')?>" /></td>
                                        <td><input type="text" name="coreftCalendar_options[booking_custom_fields][name][]" class="" value="<?php echo htmlentities($coreftCalendar['booking_custom_fields']['name'][$counter])?>" style="width: 100%;" placeholder="<?php _e('Name of the Field', 'coreftCalendar')?>" /></td>
                                        <td style="overflow: visible;">
                                            <select name="coreftCalendar_options[booking_custom_fields][type][]">
                                                <option value="text"><?php _e('Text Field','coreftCalendar'); ?></option>
                                                <option value="checkbox" <?php echo ($coreftCalendar['booking_custom_fields']['type'][$counter] == 'checkbox' ? 'selected="selected"' : '')?>><?php _e('Checkbox','coreftCalendar'); ?></option>
                                            </select>
                                        </td>
                                        <td>
                                            <select name="coreftCalendar_options[booking_custom_fields][optional][]">
                                                <option value="1"><?php _e('Yes','coreftCalendar'); ?></option>
                                                <option value="0" <?php echo ($coreftCalendar['booking_custom_fields']['optional'][$counter] == '0' ? 'selected="selected"' : '')?>><?php _e('No','coreftCalendar'); ?></option>
                                            </select>
                                        </td>
                                        <td><input type="text" name="coreftCalendar_options[booking_custom_fields][placeholder][]" class="" value="<?php echo htmlentities($coreftCalendar['booking_custom_fields']['placeholder'][$counter])?>" style="width: 100%;" placeholder="<?php _e('Text to display in the form', 'coreftCalendar')?>" /></td>
                                        <td>
                                            <input type="button" value="<?php _e('Delete','coreftCalendar'); ?>" name="delete_booking_booking_custom_field" class="button-secondary" onclick="if(confirm('<?php _e('Are you sure?', 'coreftCalendar')?>')) { jQuery(this).closest('tr').remove(); }" />
                                        </td>
                                    </tr>
                                    <?php
                                        $counter++;
                                    }
                                } else {

                                }?>
                            </tbody>
                            <tfoot>
                                <tr style="cursor:default !important;">
                                    <th><?php _e('ID','coreftCalendar'); ?></th>
                                    <th><?php _e('Name','coreftCalendar'); ?></th>
                                    <th><?php _e('Type','coreftCalendar'); ?></th>
                                    <th><?php _e('Optional','coreftCalendar'); ?></th>
                                    <th><?php _e('Placeholder','coreftCalendar'); ?></th>
                                    <th>&nbsp;</th>
                                 </tr>
                            </tfoot>
                        </table>

                        <div class="submit">
    	                    <input type="button" class="button-primary" value="<?php echo __( 'Add New', 'coreftCalendar' )?>" onclick="jQuery('#booking_custom_fields_list tbody').append('<tr>'+jQuery('#booking_custom_field_new').html().replace(/coreftCalendar_options_replace/g, 'coreftCalendar_options')+'</tr>'); jQuery('#booking_custom_fields_list tbody select').selectric('refresh');" />
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="clear"></div>
    </div>

    <p align="right">
		<input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
    </p>
</form>

<script type="text/javascript">
jQuery(document).on('keyup', '.coreft_custom_field_id, .coreft_booking_custom_field_id', function() {

	jQuery(this).val(jQuery(this).val().replace(/ /g, "").toLowerCase());

});
</script>


</div> <!--end of float wrap -->


<?php
}