<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly
// This function displays the admin page content
function coreftCalendar_custom_shortcodes_page() {
	global $wpdb, $table_prefix;
	$table_name_calendars = $table_prefix.COREFT_CALENDAR_TABLE_CALENDARS;
	
	require_once (COREFT_CALENDAR_PATH . 'src/base.class.php');
	
	$coreftCalendar_class = new CoreftCalendar( true, (isset($calendar_id) && is_numeric($calendar_id) ? $calendar_id : null) );

	if(isset($calendar_id) && is_numeric($calendar_id)){
		$coreftCalendar_class->addScripts(true);
    }

	?>

    <div class="wrap" style="clear:both;" id="coreft_options">
    
    <h2></h2>
    <div style="clear:both;"></div>
     <!--end of poststuff --> 
        <div id="coreft_ui_content" class="coreft-nobg">
            
            <div id="coreftShortcodeGenerator">
                <div id="menu_general_settings">
                    <div class="titleArea">
                        <div class="wrapper">
                            <div class="pageTitle">
                                <h2><?php _e('Custom Shortcodes','coreftCalendar'); ?></h2>
                                <span><?php _e('Get a calendar custom shortcode.','coreftCalendar'); ?></span>
                            </div>
                            
                            <div class="clear"></div>
                        </div>
                    </div>
                    
                    <div class="wrapper">
                    	<div class="option option-select">
                            <div class="option-inner">
                                <label class="titledesc"><?php _e('Calendar','coreftCalendar'); ?></label>
                                <div class="formcontainer">
                                    <div class="forminp">
                                        <select name="coreft_custom_shortcode_calendar" id="coreft_custom_shortcode_calendar" onchange="coreft_updateShortcode();">
											<?php
                                            $querystr = "
                                            SELECT *
                                            FROM $table_name_calendars
                                            ORDER BY title ASC
                                            ";
                                            $calendars_obj = $wpdb->get_results($querystr, OBJECT);
                                            foreach($calendars_obj as $calendar_key) {
                                            ?>
                                                <option value="<?php echo $calendar_key->id?>"><?php echo $calendar_key->title?></option>
                                            <?php }?>
                                        </select>
                                        <br>
                                    </div>
                                    <div class="desc"><?php _e('Select a calendar','coreftCalendar'); ?></div>
                                </div>
                            </div>
                        </div>
                        <div class="clear"></div>
                        
                        <div class="option option-select">
                            <div class="option-inner">
                                <label class="titledesc"><?php _e('Layout','coreftCalendar'); ?></label>
                                <div class="formcontainer">
                                    <div class="forminp">
                                        <select name="coreft_custom_shortcode_layout" id="coreft_custom_shortcode_layout" onchange="coreft_updateShortcode();">
											<option value=""><?php _e('Default','coreftCalendar'); ?></option>
                                            <option value="upcoming"><?php _e('Upcoming Events','coreftCalendar'); ?></option>
                                            <option value="past"><?php _e('Past Events','coreftCalendar'); ?></option>
                                            <option value="accordion"><?php _e('Accordion List','coreftCalendar'); ?></option>
                                            <option value="accordion-upcoming"><?php _e('Accordion Upcoming Events','coreftCalendar'); ?></option>
                                            <option value="add-event"><?php _e('Add Event','coreftCalendar'); ?></option>
                                            <option value="list-author"><?php _e('List Events by Author','coreftCalendar'); ?></option>
                                            <option value="calendar-author"><?php _e('Calendar by Author','coreftCalendar'); ?></option>
                                            <option value="bookings-user"><?php _e('List of Bookings by Logged in User','coreftCalendar'); ?></option>
                                            <option value="specific-event"><?php _e('Specific event','coreftCalendar'); ?></option>
                                            <option value="today-events"><?php _e('Today Events','coreftCalendar'); ?></option>
                                            <option value="gmap-upcoming"><?php _e('Google Map Upcoming Events','coreftCalendar'); ?></option>
                                            <option value="grid-upcoming"><?php _e('Grid Upcoming Events','coreftCalendar'); ?></option>
                                            <option value="compact"><?php _e('Compact','coreftCalendar'); ?></option>
                                            <option value="modern"><?php _e('Modern','coreftCalendar'); ?></option>
                                            <option value="compact-upcoming"><?php _e('Compact Upcoming Events','coreftCalendar'); ?></option>
                                            <option value="list-upcoming"><?php _e('List Upcoming Events','coreftCalendar'); ?></option>
                                            <option value="countdown"><?php _e('Countdown','coreftCalendar'); ?></option>
                                        </select>
                                        <br>
                                    </div>
                                    <div class="desc"><?php _e('Select a layout type.','coreftCalendar'); ?></div>
                                </div>
                            </div>
                        </div>
                        <div class="clear"></div>
                        
                        <div class="option option-select" id="list-category">
                            <div class="option-inner">
                                <label class="titledesc"><?php _e('Category','coreftCalendar'); ?></label>
                                <div class="formcontainer">
                                    <div class="forminp">
                                        <select name="coreft_custom_shortcode_category" id="coreft_custom_shortcode_category" onchange="coreft_updateShortcode();">
                                        	<option value=""><?php _e('All Categories...','coreftCalendar'); ?></option>
                                            <?php 
											 $categories = get_categories(array('taxonomy' => 'coreft_events_category', 'hide_empty' => 0));
											  foreach ($categories as $category) {

												$option = '<option value="'.$category->term_id.'">';
												$option .= $category->cat_name;
												$option .= '</option>';
												echo $option;
											  }
?>
                                        </select>
                                        <br>
                                    </div>
                                    <div class="desc"><?php _e('Select a category.','coreftCalendar'); ?></div>
                                </div>
                            </div>
                        </div>
                        <div class="clear"></div>
                        
                        <div class="option option-select" id="list-events" style="display:none;">
                            <div class="option-inner">
                                <label class="titledesc"><?php _e('Event','coreftCalendar'); ?></label>
                                <div class="formcontainer">
                                    <div class="forminp">
                                        <select name="coreft_custom_shortcode_event" id="coreft_custom_shortcode_event" onchange="coreft_updateShortcode();">
                                        	<option value=""><?php _e('All Events...','coreftCalendar'); ?></option>
                                            <?php 
											 $events = get_posts(array('post_type' => 'coreft-events', 'posts_per_page' => -1));
											  foreach ($events as $event) {

												$option = '<option value="'.$event->ID.'">';
												$option .= $event->post_title;
												$option .= '</option>';
												echo $option;
											  }
?>
                                        </select>
                                        <br>
                                    </div>
                                    <div class="desc"><?php _e('Select an event (optional).','coreftCalendar'); ?></div>
                                </div>
                            </div>
                        </div>
                        <div class="clear"></div>

                        <div class="option option-select" id="include-all-events">
                            <div class="option-inner">
                                <label class="titledesc"><?php _e('Events from all calendars','coreftCalendar'); ?></label>
                                <div class="formcontainer">
                                    <div class="forminp">
                                        <select name="coreft_custom_shortcode_include_all_events" id="coreft_custom_shortcode_include_all_events" onchange="coreft_updateShortcode();">
                                            <option value=""><?php _e('No','coreftCalendar'); ?></option>
                                            <option value="1"><?php _e('Yes','coreftCalendar'); ?></option>
?>
                                        </select>
                                        <br>
                                    </div>
                                    <div class="desc"><?php _e('Display the events from all the calendars and unassigned events.','coreftCalendar'); ?></div>
                                </div>
                            </div>
                        </div>
                        <div class="clear"></div>
                        
                        <div class="option option-select" id="list-view">
                            <div class="option-inner">
                                <label class="titledesc"><?php _e('View','coreftCalendar'); ?></label>
                                <div class="formcontainer">
                                    <div class="forminp">
                                        <select name="coreft_custom_shortcode_view" id="coreft_custom_shortcode_view" onchange="coreft_updateShortcode();">
                                            <option value=""><?php _e('Default','coreftCalendar'); ?></option>
                                            <option value="monthly"><?php _e('Calendar','coreftCalendar'); ?></option>
                                            <option value="monthly-all-events"><?php _e('Monthly Events List'); ?></option>
                                            <option value="weekly"><?php _e('Weekly','coreftCalendar'); ?></option>
                                            <option value="daily"><?php _e('Daily','coreftCalendar'); ?></option>
                                        </select>
                                        <br>
                                    </div>
                                    <div class="desc"><?php _e('Select the view.','coreftCalendar'); ?></div>
                                </div>
                            </div>
                        </div>
                        <div class="clear"></div>
                        
                        <div class="option option-select" id="list-authors" style="display:none;">
                            <div class="option-inner">
                                <label class="titledesc"><?php _e('Authors','coreftCalendar'); ?></label>
                                <div class="formcontainer">
                                    <div class="forminp">
                                        <select name="coreft_custom_shortcode_authors" id="coreft_custom_shortcode_authors" onchange="coreft_updateShortcode();">
                                            <option value="current"><?php _e('Current logged in user','coreftCalendar'); ?></option>
											<?php 
											$blogusers = get_users('who=authors');
											foreach ($blogusers as $user) {
												echo '<option value="'.$user->ID.'">' . $user->display_name . ' ('.$user->user_nicename.')</option>';
											}?>
                                        </select>
                                        <br>
                                    </div>
                                    <div class="desc"><?php _e('Select an author.','coreftCalendar'); ?></div>
                                </div>
                            </div>
                        </div>
                        <div class="clear"></div>
                        
                        <div class="option option-select" id="list-columns" style="display:none;">
                            <div class="option-inner">
                                <label class="titledesc"><?php _e('Columns','coreftCalendar'); ?></label>
                                <div class="formcontainer">
                                    <div class="forminp">
                                        <select name="coreft_custom_shortcode_columns" id="coreft_custom_shortcode_columns" onchange="coreft_updateShortcode();">
                                            <option value="1"><?php _e('1 Column','coreftCalendar'); ?></option>
                                            <option value="2"><?php _e('2 Columns','coreftCalendar'); ?></option>
                                            <option value="3"><?php _e('3 Columns','coreftCalendar'); ?></option>
                                            <option value="4"><?php _e('4 Columns','coreftCalendar'); ?></option>
                                        </select>
                                        <br>
                                    </div>
                                    <div class="desc"><?php _e('Select the number of columns.','coreftCalendar'); ?></div>
                                </div>
                            </div>
                        </div>
                        <div class="clear"></div>
                        
                        <div class="option option-select" id="list-skin">
                            <div class="option-inner">
                                <label class="titledesc"><?php _e('Skin color','coreftCalendar'); ?></label>
                                <div class="formcontainer">
                                    <div class="forminp">
                                        <select name="coreft_custom_shortcode_skin" id="coreft_custom_shortcode_skin" onchange="coreft_updateShortcode();">
                                            <option value=""><?php _e('None','coreftCalendar'); ?></option>
                                            <option value="red"><?php _e('Red','coreftCalendar'); ?></option>
                                            <option value="pink"><?php _e('Pink','coreftCalendar'); ?></option>
                                            <option value="purple"><?php _e('Purple','coreftCalendar'); ?></option>
                                            <option value="deep_purple"><?php _e('Deep Purple','coreftCalendar'); ?></option>
                                            <option value="indigo"><?php _e('Indigo','coreftCalendar'); ?></option>
                                            <option value="blue"><?php _e('Blue','coreftCalendar'); ?></option>
                                            <option value="light_blue"><?php _e('Light Blue','coreftCalendar'); ?></option>
                                            <option value="cyan"><?php _e('Cyan','coreftCalendar'); ?></option>
                                            <option value="teal"><?php _e('Teal','coreftCalendar'); ?></option>
                                            <option value="green"><?php _e('Green','coreftCalendar'); ?></option>
                                            <option value="light_green"><?php _e('Light Green','coreftCalendar'); ?></option>
                                            <option value="lime"><?php _e('Lime','coreftCalendar'); ?></option>
                                            <option value="yellow"><?php _e('Yellow','coreftCalendar'); ?></option>
                                            <option value="amber"><?php _e('Amber','coreftCalendar'); ?></option>
                                            <option value="orange"><?php _e('Orange','coreftCalendar'); ?></option>
                                            <option value="deep_orange"><?php _e('Deep Orange','coreftCalendar'); ?></option>
                                            <option value="brown"><?php _e('Brown','coreftCalendar'); ?></option>
                                            <option value="grey"><?php _e('Grey','coreftCalendar'); ?></option>
                                            <option value="blue_grey"><?php _e('Blue Grey','coreftCalendar'); ?></option>
                                        </select>
                                        <br>
                                    </div>
                                    <div class="desc"><?php _e('Select the skin color for this layout.','coreftCalendar'); ?></div>
                                </div>
                            </div>
                        </div>
                        <div class="clear"></div>
                        
                        <div class="option option-select" id="from-param" style="display:none;">
                            <div class="option-inner">
                                <label class="titledesc"><?php _e('From','coreftCalendar'); ?></label>
                                <div class="formcontainer">
                                    <div class="forminp">
                                        <input type="text" readonly="readonly" maxlength="10" class="large-text"  name="default_date" id="coreft_custom_shortcode_from" value="" style="width:100px;" />
                                    	<button type="button" class="coreftCalendar_btn_getFromDate">
                                            <img src="<?php echo coreftCalendar_plugin_url( 'images/admin/calendar.png' ); ?>" alt="Calendar" title="Calendar">
                                        </button>
                                        <br>
                                    </div>
                                    <div class="desc"><?php _e('Select a date to start displaying the past events.','coreftCalendar'); ?></div>
                                </div>
                            </div>
                        </div>
                        <div class="clear"></div>

                        <div class="option option-select" id="daily-group" style="display:none;">
                            <div class="option-inner">
                                <label class="titledesc"><?php _e('Group','coreftCalendar'); ?></label>
                                <div class="formcontainer">
                                    <div class="forminp">
                                        <select name="coreft_custom_shortcode_daily_group" id="coreft_custom_shortcode_daily_group" onchange="coreft_updateShortcode();">
                                            <option value=""><?php _e('No','coreftCalendar'); ?></option>
                                            <option value="1"><?php _e('Yes','coreftCalendar'); ?></option>
?>
                                        </select>
                                    </div>
                                    <div class="desc"><?php _e('Group daily events.','coreftCalendar'); ?></div>
                                </div>
                            </div>
                        </div>
                        <div class="clear"></div>

                        <div class="option option-select" id="scope" style="display:none;">
                            <div class="option-inner">
                                <label class="titledesc"><?php _e('Scope','coreftCalendar'); ?></label>
                                <div class="formcontainer">
                                    <div class="forminp">
                                        <select name="coreft_custom_shortcode_scope" id="coreft_custom_shortcode_scope" onchange="coreft_updateShortcode();">
                                            <option value=""><?php _e('Default','coreftCalendar'); ?></option>
                                            <option value="past"><?php _e('Past Events','coreftCalendar'); ?></option>
?>
                                        </select>
                                    </div>
                                    <div class="desc"><?php _e('Change the scope for this layout.','coreftCalendar'); ?></div>
                                </div>
                            </div>
                        </div>
                        <div class="clear"></div>
                        
                        <div class="option option-select" id="limit-param" style="display:none;">
                            <div class="option-inner">
                                <label class="titledesc"><?php _e('Limit','coreftCalendar'); ?></label>
                                <div class="formcontainer">
                                    <div class="forminp">
	                                    
                                        <input type="number" min="1" max="99" name="coreft_custom_shortcode_limit" id="coreft_custom_shortcode_limit" value="5" onchange="coreft_updateShortcode();" />
                                        <br>
                                    </div>
                                    <div class="desc"><?php _e('Select a limit of posts to display.','coreftCalendar'); ?></div>
                                </div>
                            </div>
                        </div>
                        <div class="clear"></div>
                        
                        <div class="submit">
                        
                            <span class="coreft_custom_shortcode"></span>

                            <div class="clear"></div>
                            
                            <p class="coreft_custom_shortcode_help"></p>
                            
                            <div id="coreft_custom_shortcode_preview"></div>
                        </div>
                    </div>
                </div>           
            </div>
        </div>
                    
</div> <!--end of float wrap -->

<script type="text/javascript">
	function coreft_updateShortcode() {
		var shortcode = '[coreftCalendar';
		
		jQuery('#list-authors').hide();
		jQuery('#list-category').hide();
		jQuery('#list-view').hide();
		jQuery('#list-events').hide();
        jQuery('#include-all-events').hide();
		jQuery('#list-columns').hide();
		jQuery('#list-skin').hide();
		jQuery('#limit-param').hide();
        jQuery('#daily-group').hide();
        jQuery('#scope').hide();
		
		if(jQuery('#coreft_custom_shortcode_calendar').val() != "") {
			shortcode += ' id="'+jQuery('#coreft_custom_shortcode_calendar').val()+'"';
		}
		
		if(jQuery('#coreft_custom_shortcode_layout').val() != "" && jQuery('#coreft_custom_shortcode_layout').val() != "calendar-author" && jQuery('#coreft_custom_shortcode_layout').val() !=  "specific-event") {
			shortcode += ' type="'+jQuery('#coreft_custom_shortcode_layout').val()+'"';
		}
		
		if(jQuery('#coreft_custom_shortcode_layout').val() == ""
            || jQuery('#coreft_custom_shortcode_layout').val() == "calendar-author"
            || jQuery('#coreft_custom_shortcode_layout').val() == "countdown"
            || jQuery('#coreft_custom_shortcode_layout').val() == "compact"
            || jQuery('#coreft_custom_shortcode_layout').val() == "modern"
            || jQuery('#coreft_custom_shortcode_layout').val() == "grid") {
			jQuery('#list-category').show();
            jQuery('#include-all-events').show();
			
			if(jQuery('#coreft_custom_shortcode_category').val() != "") {
				shortcode += ' category="'+jQuery('#coreft_custom_shortcode_category').val()+'"';
			}
			
            if(jQuery('#coreft_custom_shortcode_include_all_events').val() != "") {
                shortcode += ' include_all_events="1"';
            }

		}

        if(jQuery('#coreft_custom_shortcode_layout').val() == "specific-event"
            || jQuery('#coreft_custom_shortcode_layout').val() == "countdown" ) {
            jQuery('#list-events').show();
            
            if(jQuery('#coreft_custom_shortcode_event').val() != "") {
                
                if(jQuery('#coreft_custom_shortcode_layout').val() == "countdown") {
                    shortcode += ' event_id="'+jQuery('#coreft_custom_shortcode_event').val()+'"';
                } else {
                    shortcode += ' event="'+jQuery('#coreft_custom_shortcode_event').val()+'"';
                }
                
            }
        }

        if(jQuery('#coreft_custom_shortcode_layout').val() == "accordion-upcoming" || jQuery('#coreft_custom_shortcode_layout').val() == "accordion") {
            jQuery('#list-category').show();
            jQuery('#include-all-events').show();
            
            if(jQuery('#coreft_custom_shortcode_category').val() != "") {
                shortcode += ' category="'+jQuery('#coreft_custom_shortcode_category').val()+'"';
            }

            if(jQuery('#coreft_custom_shortcode_include_all_events').val() != "") {
                shortcode += ' include_all_events="1"';
            }

        }
		
		if(jQuery('#coreft_custom_shortcode_layout').val() == "list-author" || jQuery('#coreft_custom_shortcode_layout').val() == "calendar-author") {
			jQuery('#list-authors').show();
			shortcode += ' author="'+jQuery('#coreft_custom_shortcode_authors').val()+'"';
			//jQuery('.coreft_custom_shortcode_help').text('<?php echo __( 'This shortcode should be implemented inside the author template of your theme.', 'coreftCalendar' )?>');
		} else {
			jQuery('.coreft_custom_shortcode_help').text('');
		}
		
		if(jQuery('#coreft_custom_shortcode_layout').val() == "upcoming"
			|| jQuery('#coreft_custom_shortcode_layout').val() == "accordion-upcoming"
			|| jQuery('#coreft_custom_shortcode_layout').val() == "grid-upcoming"
            || jQuery('#coreft_custom_shortcode_layout').val() == "compact-upcoming"
			|| jQuery('#coreft_custom_shortcode_layout').val() == "bookings-user"
			|| jQuery('#coreft_custom_shortcode_layout').val() == "past"
            || jQuery('#coreft_custom_shortcode_layout').val() == "countdown"
            || jQuery('#coreft_custom_shortcode_layout').val() == "list-upcoming") {
			jQuery('#limit-param').show();
			shortcode += ' limit="'+jQuery('#coreft_custom_shortcode_limit').val()+'"';
		}
		
		if(jQuery('#coreft_custom_shortcode_layout').val() == "") {
			jQuery('#list-view').show();
			if(jQuery('#coreft_custom_shortcode_view').val() != "") {
				shortcode += ' view="'+jQuery('#coreft_custom_shortcode_view').val()+'"';
			}
		}
		
		if(jQuery('#coreft_custom_shortcode_layout').val() == "past") {
			//jQuery('#from-param').show();
			//shortcode += ' from="'+jQuery('#coreft_custom_shortcode_from').val()+'"';
		}

        if(jQuery('#coreft_custom_shortcode_layout').val() == "countdown" || jQuery('#coreft_custom_shortcode_layout').val() == "list-upcoming") {
            jQuery('#daily-group').show();
            if(jQuery('#coreft_custom_shortcode_daily_group').val() != "") {
                shortcode += ' group="'+jQuery('#coreft_custom_shortcode_daily_group').val()+'"';
            }
        }
        
        if(jQuery('#coreft_custom_shortcode_layout').val() == "grid-upcoming" || jQuery('#coreft_custom_shortcode_layout').val() == "list-upcoming" || jQuery('#coreft_custom_shortcode_layout').val() == "compact-upcoming") {
            jQuery('#scope').show();
            if(jQuery('#coreft_custom_shortcode_scope').val() != "") {
                shortcode += ' scope="'+jQuery('#coreft_custom_shortcode_scope').val()+'"';
            }
        }

		
		if(jQuery('#coreft_custom_shortcode_layout').val() == "grid-upcoming" || jQuery('#coreft_custom_shortcode_layout').val() == "accordion-upcoming" || jQuery('#coreft_custom_shortcode_layout').val() == "upcoming" || jQuery('#coreft_custom_shortcode_layout').val() == "past") {
			jQuery('#list-columns').show();
			shortcode += ' columns="'+jQuery('#coreft_custom_shortcode_columns').val()+'"';
		}
		
		if(jQuery('#coreft_custom_shortcode_layout').val() == "accordion-upcoming" || jQuery('#coreft_custom_shortcode_layout').val() == "compact-upcoming" || jQuery('#coreft_custom_shortcode_layout').val() == "accordion" || jQuery('#coreft_custom_shortcode_layout').val() == "add-event" || jQuery('#coreft_custom_shortcode_layout').val() == "") {
			jQuery('#list-skin').show();
			if(jQuery('#coreft_custom_shortcode_skin').val() != "") {
				shortcode += ' skin="'+jQuery('#coreft_custom_shortcode_skin').val()+'"';
			}
		}

		shortcode += ']';
		
		jQuery('.coreft_custom_shortcode').text(shortcode);
	};

	coreft_updateShortcode();
</script>

<?php

    if(isset($calendar_id) && is_numeric($calendar_id)){
	    $coreftCalendar_class->output(true);
    }
    ?>
<?php	
}
?>